BeginPackage["Tens3D`"];

CanonicalBasis::usage = \
"Name of a predefinite orthonormal basis in the 3D vectorial space.";

MetricTensor::usage = \
"Name of the rank 2 metric tensor. The components in any variance and in any orthonormal basis are the identity matrix. In other basis, the components may be different and variance dependent.";\


OrientationTensor::usage =
    "Name of the rank 3 orientation tensor in a 3D space.  The components in any variance and in any orthonormal basis are : \n  1 if the 3 indices are ordrered in a even permutation, \n -1 if the 3 indices are ordrered in a odd permutation,\n else.\nIn other basis, the components may be different and variance dependent.";\
 

Rank::usage = \
"Rank[T] returns the rank of T if T has been defined as Tens3D tensor.";

DefineTensor::usage = \
"DefineTensor[ArrayOfComponents,ListOfVariances,Basis] returns a Tens3D tensor in the form  Tens3D`Private`Tensor$nnn  where nnn is an arbitrary internal integer without meaningfull.";\


DefineGeneralTensor::usage = \
"DefineGeneralTensor[symbol,ListOfVariances,Basis] in which components names are the symbol concatened with the values of the indices.";\


Components::usage = \
"Components[Tens3DTensor,ListOfVariances,Basis] returns the Array of components of the tensor, in the variances given in ListOfVariances (1=contravariant=indice up, -1=covariant=indice down) in the given basis.";\


Tens3DQ::usage = \
"Tens3DQ[x] returns True if x is a Tens3D tensor, and False otherwise.";

BasisQ::usage = \
"BasisQ[x] returns True if x is a Tens3D basis, and False otherwise.";

DefineBasis::usage = \
"DefineBasis[v1,v2,v3] returns a Tens3DBasis if v1,v2,v3 are Tens3D vectors. DefineBasis attempts to find the orientation of the basis, if it is possible. You may have to make some assumptions to help this.";\


CircleTimes::usage = 
    "CircleTimes[T1,T2] returns the tensorial product of the two tens3D tensors T1 and T2.";\


CirclePlus::usage = \
"CirclePlus[T1,T2] returns the tensorial sum of same rank Tens3D tensors T1 and T2 .";\


CircleMinus::usage = \
"CircleMinus[T1,T2] returns the tensorial difference of the same rank Tens3D tensors T1 and T2.";\


SmallCircle::usage = \
"SmallCircle[a,T] or SmallCircle[T,a] returns the product of the scalar a times the Tens3D tensor T.";\


Dot::usage = \
"Dot[T1,T2] or T1\[CenterDot]T2 returns the single contraction of the two Tens3DTensors T1 and T2 (summation on the last indice of T1 and the first indice of T2).";\


Colon::usage = \
"Colon[T1,T2] or T1:T2 returns the double contracted product of the two Tens3D tensors T1 and T2 (summation on the last two indices of T1 and the first two indices of T2 in the same order.";\


AutoContract::usage = \
"Autocontract[T,i1,i2] returns a Rank[T]-2 Tens3D tensor by contraction of indices number i1 and i2. \n By default i1=1 and i2=2. If T is rank 2, the result is a scalar.";\


Therefore::usage = \
"Therefore[T1,T2] returns the triple contracted product of the two Tens3D tensors T1 and T2 (summation on the last three indices of T1 and the first three indices of T2 in the same order.";\


Proportion::usage = \
"Proportion[T1,T2] returns the quadruple contraction of the two Tens3D tensors T1 and T2 (summation on the last four indices of T1 and the first four indices of T2 in the same order.";\


Wedge::usage = \
"Wedge[v1,v2] returns the cross product of the two Tens3d vectors.";

FirstInvariant::usage = \
"FirstInvariant[T] or I1[T] returns the first invariant of the rank 2 tensor T.";\


I1::usage = \
"FirstInvariant[T] or I1[T] returns the trace of the rank 2 tensor T.";

J1::usage = \
"FirstInvariant[T] or I1[T] returns the trace of the rank 2 tensor T.";

SecondInvariant::usage = 
    "SecondInvariant[T] or I2[T] returns the second invariant (sum of diagonal minors, second coefficient of the characteristic polynom) of the rank 2 tensor T.";\


I2::usage = \
"SecondInvariant[T] or I2[T] returns the second invariant (sum of diagonal minors, second coefficient of the characteristic polynom) of the rank 2 tensor T.";\


J2::usage = "J2[T] returns the trace of T.T ";

ThirdInvariant::usage = \
"ThirdInvariant[T] or I3[T] or Det[T] returns the determinant  of the rank 2 tensor T.";\


I3::usage = \
"ThirdInvariant[T] or I3[T] or Det[T] returns the determinant  of the rank 2 tensor T.";\


J3::usage = "J3[T] returns the trace of T.T.T ";

SymmetricPart::usage = \
"SymmetricPart[T] or Sym[T] returns the symmetric part of the rank 2 tensor T.";\


Sym::usage = \
"SymmetricPart[T] or Sym[T] returns the symmetric part of the rank 2 tensor T.";\


AntisymmetricPart::usage = \
"AntisymmetricPart[T] or Asym[T] returns the antisymmetric part of the rank 2 tensor T.";\


Asym::usage = \
"AntisymmetricPart[T] or Asym[T] returns the antisymmetric part of the rank 2 tensor T.";\


SphericalPart::usage = \
"SphericalPart[T] or Sph[T] returns the spherical part of the rank 2 tensor T.";\


Sph::usage = \
"SphericalPart[T] or Sph[T] returns the spherical part of the rank 2 tensor T.";\


TracelessPart::usage = \
"TracelessPart[T] or Dev[T] returns the traceless part of the rank 2 tensor T.";\


Dev::usage = \
"TracelessPart[T] or Dev[T] returns the traceless part of the rank 2 tensor T.";\


BasisVectors::usage = \
"BasisVectors[B] returns the list of the three basis vectors of the Tens3D basis B.";\


DualBasisVectors::usage = \
"DualBasisVectors[B] returns the list of the three basis vectors of the dual basis of the Tens3D basis B.";\


Eigensystem::usage = \
"Eigensystem[T] where T is an evan rank Tens3DTensor, returns a list of two lists the first one contains eigenvalues and the second one contains eigentensors.";\


Eigenvalues::usage = \
"Eigenvalues[T] where T is an evan rank Tens3DTensor, returns a list of eigenvalues of T.";\


Eigentensors::usage = \
"Eigentensors[T] where T is an evan rank Tens3DTensor, returns a list of eigentensors of T.";\


Inverse::usage = \
"Inverse[T] where T is an evan rank Tens3D tensor, returns a same rank Tens3D tensor such that T.Inverse[T]=MetricTensor if Rank[T]==2, T\[Colon]Inverse[T]=IdentityTensor[4] if Rank[T]==4, ...";\


RightPolarDecomposition::usage = \
"RightPolarDecomposition[T] returns a list of two rank 2 Tens3D tensors {Q,U} such that T=Q.U where Q is orthogonal and U is symmetric definite positive.";\


LeftPolarDecomposition::usage = \
"LeftPolarDecomposition[T] returns a list of two rank 2 Tens3D tensors {Q,U} such that T=V.Q where Q is orthogonal and V is symmetric definite positive.";\


IdentityTensor::usage = \
"IdentityTensor[n] returns the identity rank n (even) Tens3D tensor. \nFor example IdentityTensor[4}:T=T ";\


EuclidianNorm::usage = \
"EuclidianNorm[T] returns the euclidian norm of the even rank Tens3D tensor T.";\


DefineOrthogonalTensor::usage = \
"DefineOrthogonalTensor[angle,axis,det] returns the rank 2 orthogonal Tens3D tensor, defined by the given angle around the Tens3DVector axis and with a determinant det = 1 or -1.";\


IdentifyOrthogonalTensor::usage = \
"IdentifyOrthogonalTensor[Q] returns the list {angle,axis,det} of the given orthogonal Tens3D tensor Q. This is the inverse function of DefineOrthogonalTensor.";\


OrthogonalTransform::usage = \
"OrthogonalTransform[T,Q] returns the transformed of T by the orthogonal tensor Q.";\


DefineCoordinateSystem::usage = \
"DefineCoordinateSystem[OM,{c1,C2,C3}] returns the natural basis defined by the current point OM (a Tens3D vector normally function of the three coordinates c1, c2 and c3). It may be usefull to put some assumptions to determine completely the orientation of the natural basis).";\


PrintChristoffel::usage = 
    "PrintChristoffel[CS] prints the Christoffel coefficients  of the Tens3D coordinate system CS. This function returns Null.";\


ChristoffelArray::usage = \
"ChristoffelArray[CS] returns the 27 Christoffel coefficients in an array 3x3x3.";\


NormalizedBasis::usage = \
"NormalizedBasis[B] returns a Tens3D basis colinear to B but with unit vectors.";\


Gradient::usage = \
"Gradient[field,CS] returns a Rank[field]+1 Tens3DTensor field. CS is the natural basis of a coordinate system (returned by DefineCoordinateSystem). Components of tensorial field are normally functions of coordinates.\n If field is a scalar field, then Gradient[field,BN] is a tens3DVector field. ";\


Divergence::usage = \
"Divergence[field,CS] returns a Rank[field]-1 Tens3DTensor field. CS is the natural basis of a coordinate system (returned by DefineCoordinateSystem). Components of tensorial field are normally functions of coordinates.";\


Curl::usage = \
"Curl[field,CS] returns a Rank[field] Tens3DTensor field. CS is the natural basis of a coordinate system (returned by DefineCoordinateSystem). Components of tensorial field are normally functions of coordinates.";\


Laplacian::usage = \
"Laplacian[field,CS] returns a Rank[field] Tens3DTensor field. CS is the natural basis of a coordinate system (returned by DefineCoordinateSystem). Components of tensorial field are normally functions of coordinates.";\


CompactDerivativeForm::usage = \
"CompactDerivativeForm[exp] or expr//CompactDerivativeForm writes partial derivatives in a condensed format. This output can not be used as input.";\


Begin["`Private`"];

Unprotect[DimV, vecs, gcc, gCC, validbasis, coords, rank, comp, var, basis, 
    validtensor];
DimV = 3;
vecs = 1; gcc = 2; gCC = 3; coords = 4; validbasis = 5;
rank = 1; comp = 2; var = 3; basis = 4; validtensor = 5;
Protect[DimV, vecs, gcc, gCC, validbasis, coords, rank, comp, var, basis, 
    validtensor];


(*Predefined entities*)

Unprotect[CanonicalBasis];
CanonicalBasis[vecs] = IdentityMatrix[DimV];
CanonicalBasis[gcc] = IdentityMatrix[DimV];
CanonicalBasis[gCC] = IdentityMatrix[DimV];
CanonicalBasis[coords] = {};
CanonicalBasis[validbasis] = True;
Protect[CanonicalBasis];

Unprotect[MetricTensor];
MetricTensor[rank] = 2;
MetricTensor[comp] = IdentityMatrix[DimV];
MetricTensor[var] = {1, -1};
MetricTensor[basis] = CanonicalBasis;
MetricTensor[validtensor] = True;
Protect[MetricTensor];

Unprotect[OrientationTensor];
OrientationTensor[rank] = 3;
OrientationTensor[comp]  = 
    SparseArray[{{1, 2, 3} -> 1     , {2, 3, 1} -> 1   , {3, 1, 2} -> 1 ,
                                 {1, 3, 2} -> -1  , {2, 1, 3} -> -1 , {3, 2, 
            1} -> -1  }];
OrientationTensor[var]  = {-1, -1, -1};
OrientationTensor[basis] = CanonicalBasis;
OrientationTensor[validtensor] = True;
Protect[OrientationTensor];


Unprotect[Tens3DQ];
Tens3DQ[T_] := If[T[validtensor], True, False, False];
Protect[Tens3DQ];

Unprotect[BasisQ];
BasisQ[B_] := If[B[validbasis], True, False, False];
Protect[BasisQ];


Unprotect[Rank];
Rank[T_] := T[rank] /; T[validtensor] ;
Protect[Rank];

ChangementDeVariance[T_, v_] := Module[{Tab, i, L},
      Tab = T[comp];
      For[i = 1, i <  Length[v] + 1,
        If[T[var][[i]] != v[[i]],
          L = Range[Length[v]]; L[[i]] = Length[v]; L[[Length[v]]] = i;
          If[T[var][[i]] == 1,
            Tab = Transpose[ Transpose[Tab, L].T[basis][gcc], L],
            Tab = Transpose[ Transpose[Tab, L].T[basis][gCC], L],
            AnomalieChangementDeVariance1
            ] (* If[T[var][[i]] == 1 *)
          ,
          Null
          ,
          AnomalieChangementDeVariance2
          ] (* If[T[var][[i]] != v[[i]] *); i++
        ] (* For[i = 1, i = Length[v]*);
      Tab
      ];

ChangementDeBase[Co_, BT_, v_, B_] := Module[{Tab, i, L, AcC, BCc},
      BCc = Simplify[Inverse[B[vecs]].BT[vecs]];
      AcC = Transpose[Simplify[Inverse[BCc]], {2, 1}];
      Tab = Co;
      For[i = 1, i <  Length[v] + 1,
        L = Range[Length[v]]; L[[1]] = i; L[[i]] = 1;
        If[v[[i]] == 1,
          Tab =  Transpose[ BCc . Transpose[Tab, L], L]
          ,
          Tab =  Transpose[ AcC . Transpose[Tab, L], L]
          ,
          AnomalieChangementDeBase
          ]; i++
        ] (* For[i = 1, i = Length[v]*);
      Tab
      ];


Unprotect[Components];
Components[T_, v1_ : {}, B_:CanonicalBasis] := Module[{Tab, v},
      If[! Tens3DQ[T], Message[Components::tensor]; Return[],
          v = v1;
          
          If[Length[v] == 0, v = Array[#^0 &, T[rank]]; 
            Print["Note: Components in ", B]];
          
          If[ (Length[v] != Rank[T]) || (Length[DeleteCases[v, 1 | -1]] != 
                  0) , Message[Components::listvar]; Return[],
            If[! BasisQ[B],
              Message[Components::basis]; Return[],
              If[T[var] == v,
                Tab = T[comp];
                ,
                Tab = ChangementDeVariance[T, v]
                ](* If[T[var] == v*);
              If[T[basis][vecs] == B[vecs],
                Null
                ,
                Tab = ChangementDeBase[Tab, T[basis], v, B],
                Tab = ChangementDeBase[Tab, T[basis], v, B]
                ](* If[T[basis] == B*);
              Return[Simplify[Tab]]
              (*Return[Tab]*)
              ]]];
      ] ;
Protect[Components];
Components::listvar = "Incorrect list of variances in second argument.";
Components::basis = "Incorrect basis in third argument.";
Components::tensor = "First argument is not a tensor";


Unprotect[DefineTensor];
DefineTensor[A_, v_, B_] := Module[{Tensor},
      If[! ArrayQ[A] || (Length[DeleteCases[Dimensions[A], 3]] != 0), 
        Message[DefineTensor::array, A],
        If[(Head[v] != List) || (Length[v] !=  
                ArrayDepth[A]) || (Length[DeleteCases[v, 1 | -1]] != 0) , 
          Message[DefineTensor::listvar, v],
          If[! BasisQ[B], Message[DefineTensor::basis, B],
            Tensor[rank] = Length[v];
            Tensor[comp] = Simplify[A];
            Tensor[var] = v;
            Tensor[basis] = B;
            Tensor[validtensor] = True;
            Return[Tensor]
            ]
          ]
        ]
      ];
Protect[DefineTensor];
DefineTensor::array = \
"First argument `1` is not a valid array for Tens3D Package.";
DefineTensor::listvar = "List `1`is incorrect list of variances.";
DefineTensor::basis = "Argument `1` is not a Tens3D basis.";


Unprotect[DefineGeneralTensor];
DefineGeneralTensor[s_Symbol, l_List, B_, v_List:{}] := Module[{T},
      Off[General::"spell1"];
      If[Length[v] == 0,
        T = DefineTensor[
            
            Array[ Symbol[ StringJoin[ ToString[s], Map[ToString, {##}]]  ] &,
               Table[3, {Length[l]}]],
            l, B
            ],
        T = DefineTensor[
            
            Array[ Symbol[ StringJoin[ ToString[s], Map[ToString, {##}]]  ][
                  Apply[Sequence, v]] &, Table[3, {Length[l]}]],
            l, B
            ]
        ];
      On[General::"spell1"];
      T
      ];
Protect[DefineGeneralTensor];


(*
  Unprotect[DefineGeneralTensor];
  Options[DefineGeneralTensor] = { sym -> {}, asym -> {} };
  
  DefineGeneralTensor[s_Symbol, variances_List, B_, variables_List:{}, 
      opts___] := Module[{tab, Ls, La, n},
        
        (* recup des options*)
        sy = sym /. {opts} /. Options[DefineGeneralTensor];
        as = asym /. {opts} /. Options[DefineGeneralTensor];
        sy = Union[Map[Sort, sy]];
        as = Union[Map[Sort, as]];
        
        For[i = 1, i < Length[sy] + 1, i++,
          
          If[Length[sy[[i]]] == 2 &&  IntegerQ[sy[[i, 1]]] && 
              IntegerQ[sy[[i, 2]]] && sy[[i, 1]] > 0 && sy[[i, 2]] > 0 && 
              sy[[i, 1]] < Length[variances] + 1 && 
              sy[[i, 2]] < Length[variances] + 1 &&
              variances[[sy[[i, 1]]]] == variances[[sy[[i, 2]]]]
            ,
            sy
            ,
            Message[DefineGeneralTensor::invalsym, sy[[i]] ];
            sy = Delete[sy, i]
            ]
          ];
        For[i = 1, i < Length[as] + 1, i++,
          
          If[Length[as[[i]]] == 2 &&  IntegerQ[as[[i, 1]]] && 
              IntegerQ[as[[i, 2]]] && as[[i, 1]] > 0 && as[[i, 2]] > 0 && 
              as[[i, 1]] < Length[variances] + 1 && 
              as[[i, 2]] < Length[variances] + 1 &&
              variances[[as[[i, 1]]]] == variances[[as[[i, 2]]]]
            ,
            as
            ,
            Message[DefineGeneralTensor::invalasym, as[[i]] ];
            as = Delete[as, i]
            ]
          ];
        
        echange[n_, s1_] := 
          ReplacePart[ReplacePart[n, n[[s1[[1]]]] , s1[[2]] ], n[[s1[[2]]]] , 
            s1[[1]] ];
        
        
        tab = Array[s , Table[3, {Length[variances]}]];
        
        tab = tab /. s[a__] :> (
                Ls = {{a}};
                For[i = 1, i < Length[sy] + 1, i++,
                  Ls = Append[Ls, echange[{a}, sy[[i]]]]
                  ];
                La = {};
                For[i = 1, i < Length[as] + 1, i++,
                  La = Append[La, echange[{a}, as[[i]]]]
                  ];
                n = Sort[Flatten[{ {{a}}, Ls, La}, 1]][[1]];
                If[MemberQ[Ls, Apply[Alternatives , La]]
                  ,
                  s[Apply[Sequence, n]] = 0
                  ,
                  If[n == {a} , s[a],
                    If[MemberQ[La, n],
                      s[a] = -s[Apply[Sequence, n]],
                      s[a] = s[Apply[Sequence, n]]]
                    ]
                  ]
                );
        Off[General::"spell1"];
        If[Length[variables] == 0,
          
          tab = tab /. 
              s[a__] :> Symbol[StringJoin[ToString[s], Map[ToString, {a}]]]
          ,
          
          tab = tab /. 
              s[a__] :> Symbol[StringJoin[ToString[s], Map[ToString, {a}]]][
                  Apply[Sequence, variables]]
          ];
        On[General::"spell1"];
        Clear[s];
        
        DefineTensor[tab, variances, B]
        
        ] /; BasisQ[B] ;(*Fin Module DefineGeneralTensor*)
  
  DefineGeneralTensor::invalsym = \
"Symmetry specification `1` is invalid and has been ignored. Check if the variances of the indices are the same or if the values are out of bounds.";\

  DefineGeneralTensor::invalasym = \
"Antisymmetry specification `1` is invalid and has been ignored. Check if the variances of the indices are the same or if the values are out of bounds.";\

  Protect[DefineGeneralTensor];
  *)





Unprotect[CirclePlus];
SetAttributes[CirclePlus, {Flat, OneIdentity}];
CirclePlus[T1_, T2_] :=
    If[(Rank[T1] == Rank[T2]) ,
        DefineTensor[
          
          Components[T1, T1[var], T1[basis]] + 
            Components[T2, T1[var], T1[basis]], T1[var], T1[basis]
          ], Message[CirclePlus::BadRank]; Return[], 
        Message[CirclePlus::BadRank]; Return[]
        ] /; Tens3DQ[T1] && Tens3DQ[T2];

CirclePlus::BadRank = "Tensors must have same rank.";
Protect[CirclePlus];



Unprotect[CircleMinus];
CircleMinus[T1_, T2_] := 
    CirclePlus[T1, SmallCircle[-1, T2]] /; Tens3DQ[T1] && Tens3DQ[T2];
Protect[CircleMinus];




Unprotect[SmallCircle];
SmallCircle[a_, b_] := DefineTensor[
        If[Tens3DQ[a], b*Components[a, a[var], a[basis]], 
          a*Components[b, b[var], b[basis]]],
        If[Tens3DQ[a], a[var], b[var]],
        If[Tens3DQ[a], a[basis], b[basis]]
        ] /; (Tens3DQ[a] && ! Tens3DQ[b] && ! ArrayQ[b] ) || (Tens3DQ[b] && ! 
              Tens3DQ[a] && ! ArrayQ[a]);
Protect[SmallCircle];


Unprotect[CircleTimes];
SetAttributes[CircleTimes, {Flat, OneIdentity}];
CircleTimes[a_, b_] := DefineTensor[
        Outer[Times, Components[a, a[var], a[basis]], 
          Components[b, b[var], a[basis]]], Flatten[{a[var], b[var]}], 
        a[basis]
        ] /; Tens3DQ[a]  &&  Tens3DQ[b] ;
Protect[CircleTimes];

(*
  Unprotect[Plus];
  Plus[T1_, T2_] := CirclePlus[T1, T2] /; Tens3DQ[T1] && Tens3DQ[T2];
  Protect[Plus];
  *)


(*
  Unprotect[Times];
  Times[a_, b_] := 
    If[Tens3DQ[a] && Tens3DQ[b], CircleTimes[a, b] , SmallCircle[a, b]] /; 
      Tens3DQ[a] || Tens3DQ[b];
  Protect[Times];
  *)



Unprotect[Dot];
Dot[T1_, T2_] := Module[{},
        If[Rank[T1] == 1 && Rank[T2] == 1,
          
          Components[T1, Append[Drop[T1[var], -1], 1], T1[basis]].Components[
              T2, Prepend[Drop[T2[var], 1], -1], T1[basis]],
          DefineTensor[
            
            Components[T1, Append[Drop[T1[var], -1], 1], 
                T1[basis]].Components[T2, Prepend[Drop[T2[var], 1], -1], 
                T1[basis]],
            Flatten[{Drop[T1[var], -1], Drop[T2[var], 1]}], T1[basis]
            ]
          ]
        ] /; Tens3DQ[T1]  &&  Tens3DQ[T2]  && Rank[T1] > 0 && Rank[T2] > 0;
Protect[Dot];


Unprotect[AutoContract];
AutoContract[T_, i1_:1, i2_:2] := Module[{Co},
        Co = 
          Components[T, ReplacePart[ReplacePart[T[var], 1, i1], -1, i2], 
            T[basis]];
        If[Rank[T] == 2, Simplify[Tr[Co]],
          DefineTensor[
            Array[
              
              Sum[Co[[ 
                      Apply[Sequence, 
                        Insert[Insert[{##}, i, i1], i, i2]] ]], {i, 3}] & ,
              Map[DimV*#1^0 &, Range[Rank[T] - 2]]
              ]
            ,
            
            If[i2 > i1, Drop[Drop[T[var], {i2}], {i1}], 
              Drop[Drop[T[var], {i1}], {i2}]],
            T[basis]
            ]
          ]
        ] /; 
      Tens3DQ[T] && IntegerQ[i1] && IntegerQ[i2] && i1 != i2 && i1 > 0 && 
        i2 > 0 && i1 <= Rank[T] && i2 <= Rank[T];
Protect[AutoContract];



Unprotect[Colon];
Colon[T1_, T2_] := Module[{co1, co2},
        co1 = 
          Components[T1, Flatten[Append[Drop[T1[var], -2], {1, 1}]], 
            T1[basis] ];
        co2 = 
          Components[T2, Flatten[Prepend[Drop[T2[var], 2], {-1, -1}]], 
            T1[basis]];
        If[T1[rank] == 2 && T2[rank] == 2
          ,
          Flatten[co1].Flatten[co2]
          ,
          DefineTensor[
            Array[
              Sum[Sum[
                    
                    co1[[   
                          Apply[Sequence, 
                            Take[Flatten[Insert[{ ##}, {i, j}, T1[rank] - 1]],
                               T1[rank]]]  ]]*
                      
                      co2[[    
                          Apply[Sequence, 
                            Take[Flatten[
                                Insert[{ ##}, {i, j}, T1[rank] - 1]], -T2[
                                  rank]]]   ]],
                    {i, DimV}], {j, DimV}] &
              ,
              Array[3 #^0 &, T1[rank] + T2[rank] - 4]
              ]
            ,
            Flatten[{  Drop[T1[var], -2], Drop[T2[var], 2] }]
            ,
            T1[basis]
            ]
          ]
        ] /; Tens3DQ[T1]  &&  Tens3DQ[T2]  && Rank[T1] > 1 && Rank[T2] > 1;
Protect[Colon];


Unprotect[Therefore];
Therefore[T1_, T2_] := Module[{co1, co2},
        co1 = 
          Components[T1, Flatten[Append[Drop[T1[var], -3], {1, 1, 1}]], 
            T1[basis] ];
        co2 = 
          Components[T2, Flatten[Prepend[Drop[T2[var], 3], {-1, -1, -1}]], 
            T1[basis]];
        If[T1[rank] == 3 && T2[rank] == 3
          ,
          Simplify[Flatten[co1].Flatten[co2]]
          ,
          DefineTensor[
            Simplify[Array[
                Sum[Sum[Sum[
                        
                        co1[[   
                              Apply[Sequence, 
                                Take[Flatten[
                                    Insert[{ ##}, {i, j, k}, T1[rank] - 2]], 
                                  T1[rank]]]  ]]*
                          
                          co2[[    
                              Apply[Sequence, 
                                Take[Flatten[
                                    Insert[{ ##}, {i, j, k}, 
                                      T1[rank] - 2]], -T2[rank]]]   ]],
                        {i, DimV}], {j, DimV}], {k, DimV}] &
                ,
                Array[3 #^0 &, T1[rank] + T2[rank] - 6]
                ]
              ]
            ,
            Flatten[{  Drop[T1[var], -3], Drop[T2[var], 3] }]
            ,
            T1[basis]
            ]
          ]
        ] /; Tens3DQ[T1]  &&  Tens3DQ[T2]  && Rank[T1] > 2 && Rank[T2] > 2;
Protect[Therefore];



Unprotect[Proportion];
Proportion[T1_, T2_] := Module[{co1, co2},
        co1 = 
          Components[T1, Flatten[Append[Drop[T1[var], -4], {1, 1, 1, 1}]], 
            T1[basis] ];
        co2 = 
          Components[T2, Flatten[Prepend[Drop[T2[var], 4], {-1, -1, -1, -1}]],
             T1[basis]];
        If[T1[rank] == 4 && T2[rank] == 4
          ,
          Simplify[Flatten[co1].Flatten[co2]]
          ,
          DefineTensor[
            Simplify[Array[
                Sum[Sum[Sum[Sum[
                          
                          co1[[   
                                Apply[Sequence, 
                                  Take[Flatten[
                                      Insert[{ ##}, {i, j, k, l}, 
                                        T1[rank] - 3]], T1[rank]]]  ]]*
                            
                            co2[[    
                                Apply[Sequence, 
                                  Take[Flatten[
                                      Insert[{ ##}, {i, j, k, l}, 
                                        T1[rank] - 3]], -T2[rank]]]   ]],
                          {i, DimV}], {j, DimV}], {k, DimV}], {l, DimV}] &
                ,
                Array[3 #^0 &, T1[rank] + T2[rank] - 8]
                ]
              ]
            ,
            Flatten[{  Drop[T1[var], -4], Drop[T2[var], 4] }]
            ,
            T1[basis]
            ]
          ]
        ] /; Tens3DQ[T1]  &&  Tens3DQ[T2]  && Rank[T1] > 3 && Rank[T2] > 3;
Protect[Proportion];


Unprotect[Wedge];
Wedge[v1_, v2_] :=
    (OrientationTensor.v2).v1 /; 
      Tens3DQ[v1]  &&  Tens3DQ[v2]  && Rank[v1] == 1 && Rank[v2] == 1;
Protect[Wedge];


Unprotect[FirstInvariant];
Unprotect[I1];
Unprotect[J1];
FirstInvariant [T_] := If[T[rank] == 2,
        AutoContract[T, 1, 2],
        Message[FirstInvariant::rank], Return[]
        ] /; Tens3DQ[T];
I1 = FirstInvariant;
J1 = FirstInvariant;
Protect[J1];
Protect[I1];
Protect[FirstInvariant];
FirstInvariant::rank = "Tensor rank must be 2.";


Unprotect[SecondInvariant];
Unprotect[I2];
SecondInvariant[T_] := Module[{Co},
        If[Rank[T] == 2,
          Co = Components[T, {1, -1}, T[basis]];
          Co[[1, 1]]*Co[[2, 2]] - Co[[1, 2]]*Co[[2, 1]] +
            Co[[2, 2]]*Co[[3, 3]] - Co[[2, 3]]*Co[[3, 2]] +
            Co[[3, 3]]*Co[[1, 1]] - Co[[3, 1]]*Co[[1, 3]],
          Message[SecondInvariant::rank]; Return[]
          ]
        ] /; Tens3DQ[T] ;
SecondInvariant::rank = "Tensor rank must be 2.";
I2 = SecondInvariant;
Protect[I2];
Protect[SecondInvariant];

Unprotect[J2];
J2[T_] := If[Rank[T] == 2, AutoContract[Dot[T, T], 1, 2]
        , Message[J2::rank]; Return[]
        ] /; Tens3DQ[T];
J2::rank = "Tensor rank must be 2.";
Protect[J2];

Unprotect[J3];
J3[T_] := If[Rank[T] == 2, AutoContract[T.T.T, 1, 2]
        , Message[J3::rank]; Return[]
        ] /; Tens3DQ[T];
J3::rank = "Tensor rank must be 2.";
Protect[J3];


Unprotect[ThirdInvariant];
Unprotect[I3];
ThirdInvariant[T_] := 
    If[Rank[T] == 2, Det[Components[T, {1, -1}, T[basis]]], 
      Message[ThirdInvariant::rank]; Return[], Message[ThirdInvariant::rank]; 
      Return[]];
I3 = ThirdInvariant;
ThirdInvariant::rank = "Tensor rank must be 2.";
Protect[I3];
Protect[ThirdInvariant];

Unprotect[Det];
Det[T_] := Module[{Co},
        If[Mod[Rank[T], 2] == 0,
          
          Co = Partition[
              Flatten[Components[T, 
                  Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]], 
              3^(T[rank]/2)];
          Det[Co],
          Message[Det::rank]; Return[]
          ]
        ] /; Tens3DQ[T];
Protect[Det];
Det::rank = "Tensor rank must be even.";




Unprotect[Transpose];
Transpose[T_, L___ : {}] := Module[{Co},
        Co = Components[T, Table[-1, {T[rank]}], T[basis]];
        If[L == {},
          DefineTensor[Transpose[Co], Table[-1, {T[rank]}], T[basis]]
          ,
          DefineTensor[Transpose[Co, L], Table[-1, {T[rank]}], T[basis]]
          ]
        ] /; Tens3DQ[T];
Protect[Transpose];


Unprotect[Sym];
Unprotect[SymmetricPart];
Sym = SymmetricPart;
SymmetricPart[T_] := If[Rank[T] == 2,
        SmallCircle[Rational[1, 2], CirclePlus[T, Transpose[T]]]
        ,
        Message[SymmetricPart::rank]
        ] /; Tens3DQ[T];
Protect[Sym];
Protect[SymmetricPart];
SymmetricPart::rank = "Tensor rank must be 2.";


Unprotect[Asym];
Unprotect[AntisymmetricPart];
Asym = AntisymmetricPart;
AntisymmetricPart[T_] := If[Rank[T] == 2,
        SmallCircle[Rational[1, 2], CircleMinus[T, Transpose[T]]]
        ,
        Message[AntisymmetricPart::rank]
        ] /; Tens3DQ[T];
Protect[AntisymmetricPart];
Protect[Asym];
AntisymmetricPart::rank = "Tensor rank must be 2.";


Unprotect[Sph];
Unprotect[SphericalPart];
Sph = SphericalPart;
SphericalPart[T_] := If[Rank[T] == 2,
        SmallCircle[Times[Power[DimV, -1], I1[T]], MetricTensor]
        ,
        Message[SphericalPart::rank]
        ] /; Tens3DQ[T];
Protect[Sph];
Protect[SphericalPart];
SphericalPart::rank = "Tensor rank must be 2.";


Unprotect[Dev];
Unprotect[TracelessPart];
Dev = TracelessPart;
TracelessPart[T_] := If[Rank[T] == 2,
        CircleMinus[T, Sph[T]]
        ,
        Message[TracelessPart::rank]
        ] /; Tens3DQ[T];
Protect[Dev];
Protect[TracelessPart];
TracelessPart::rank = "Tensor rank must be 2.";


Unprotect[DefineBasis];
DefineBasis[v1_, v2_, v3_, silent_:0] := Module[{s, Basis, a, ch},
        s = Simplify[(v1\[Wedge]v2).v3];
        If[Simplify[s == 0], 
          Message[DefineBasis::dependence]; Basis = Null
          ,
          
          Basis[vecs] = 
            Transpose[{Components[v1, {1}, CanonicalBasis], 
                Components[v2, {1}, CanonicalBasis], 
                Components[v3, {1}, CanonicalBasis]}, {2, 1}];
          a = Array[0 #1 &, {3, 3}];
          a[[1, 1]] = v1.v1;
          a[[1, 2]] = v1.v2;
          a[[1, 3]] = v1.v3;
          a[[2, 1]] = a[[1, 2]];
          a[[2, 2]] = v2.v2;
          a[[2, 3]] = v2.v3;
          a[[3, 1]] = a[[1, 3]];
          a[[3, 2]] = a[[2, 3]];
          a[[3, 3]] = v3.v3;
          Basis[gcc] = Simplify[a];
          Basis[gCC] = Simplify[Inverse[Basis[gcc]]];
          Basis[validbasis] = True;
          Basis[coords] = {}
          ,
          If[silent < 1, Print["Can't find orientation : Sign of ", s]];
          
          Basis[vecs] = 
            Transpose[{Components[v1, {1}, CanonicalBasis], 
                Components[v2, {1}, CanonicalBasis], 
                Components[v3, {1}, CanonicalBasis]}, {2, 1}];
          a = Array[0 #1 &, {3, 3}];
          a[[1, 1]] = v1.v1;
          a[[1, 2]] = v1.v2;
          a[[1, 3]] = v1.v3;
          a[[2, 1]] = a[[1, 2]];
          a[[2, 2]] = v2.v2;
          a[[2, 3]] = v2.v3;
          a[[3, 1]] = a[[1, 3]];
          a[[3, 2]] = a[[2, 3]];
          a[[3, 3]] = v3.v3;
          Basis[gcc] = Simplify[a];
          Basis[gCC] = Simplify[Inverse[Basis[gcc]]];
          Basis[validbasis] = True;
          Basis[coords] = {}
          ];
        If[silent < 1,
          
          If[Simplify[s > 0], ch = "Direct ", ch = "Indirect ", 
            ch = "Unknown orientation "];
          
          If[Basis[gcc][[1, 1]] == 1 && Basis[gcc][[2, 2]] == 1 && 
              Basis[gcc][[3, 3]] == 1, ch = ch <> "normalized " ];
          
          If[Basis[gcc][[1, 2]] == 0 && Basis[gcc][[2, 3]] == 0 && 
              Basis[gcc][[1, 3]] == 0, ch = ch <> "orthogonal " ];
          If[silent == -1, ch = ch <> "natural "];
          ch = ch <> "basis.";
          Print[ch]
          ];
        Basis
        ] /; 
      Tens3DQ[v1] && Rank[v1] == 1 &&  Tens3DQ[v2] && Rank[v2] == 1 &&  
        Tens3DQ[v3] && Rank[v3] == 1 ;
Protect[DefineBasis];
DefineBasis::dependence = "The three vectors are not independent.";


Unprotect[BasisVectors];
BasisVectors[
      B_] := {DefineTensor[{1, 0, 0}, {1}, B], 
        DefineTensor[{0, 1, 0}, {1}, B], DefineTensor[{0, 0, 1}, {1}, B]} /; 
      BasisQ[B];
Protect[BasisVectors];


Unprotect[DualBasisVectors];
DualBasisVectors[
      B_] := {DefineTensor[{1, 0, 0}, {-1}, B], 
        DefineTensor[{0, 1, 0}, {-1}, B], DefineTensor[{0, 0, 1}, {-1}, B]} /;
       BasisQ[B];
Protect[DualBasisVectors];


Unprotect[Eigensystem];
Eigensystem[T_] := Module[{M, values, vectors},
        If[EvenQ[T[rank]],
          
          M = Partition[
              Flatten[Components[T, 
                  Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]], 
              3^(T[rank]/2)];
          {values, vectors} = Eigensystem[M];
          For[i = 1, i < Length[vectors] + 1,
            
            vectors[[i]] = 
              DefineTensor[
                Nest[Partition[#, 3] &, vectors[[i]], T[rank]/2 - 1], 
                Array[#^0 &, T[rank]/2], T[basis]]
            ; i++];
          Return[{values, vectors}]
          ,
          Message[Tens3DEigensystem::rank]; Return[]
          ]
        ] /; Tens3DQ[T];
Protect[Eigensystem];
Tens3DEigensystem::rank = "Tensor rank must be even.";


Unprotect[Eigenvalues];
Eigenvalues[T_] := Module[{M, values, vectors},
        If[EvenQ[T[rank]],
          
          M = Partition[
              Flatten[Components[T, 
                  Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]], 
              3^(T[rank]/2)];
          Eigenvalues[M],
          Message[Tens3DEigenvalues::rank]; Return[]
          ]
        ] /; Tens3DQ[T];
Protect[Eigenvalues];
Tens3DEigenvalues::rank = "Tensor rank must be even.";

Unprotect[Eigentensors];
Eigentensors[T_] := Module[{M, values, vectors},
        If[EvenQ[T[rank]],
          
          M = Partition[
              Flatten[Components[T, 
                  Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]], 
              3^(T[rank]/2)];
          vectors = Eigenvectors[M];
          For[i = 1, i < Length[vectors] + 1,
            
            vectors[[i]] = 
              DefineTensor[
                Nest[Partition[#, 3] &, vectors[[i]], T[rank]/2 - 1], 
                Array[#^0 &, T[rank]/2], T[basis]]
            ; i++];
          Return[vectors]
          ,
          Message[Tens3DEigentensors::rank]; Return[]
          ]
        ] /; Tens3DQ[T];
Protect[Eigentensors];
Tens3DEigentensors::rank = "Tensor rank must be even.";

Unprotect[Inverse];
Inverse[T_] := Module[{M},
        If[EvenQ[T[rank]],
          
          M = Partition[
              Flatten[Components[T, 
                  Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]], 
              3^(T[rank]/2)];
          M = Flatten[Inverse[M]];
          
          DefineTensor[Nest[Partition[#, 3] &, M, T[rank] - 1], 
            Array[If[# <= T[rank]/2, 1, -1] &, {T[rank]}], T[basis]]
          ,
          Message[Tens3DEigenvectors::rank]; Return[]
          ]
        ] /; Tens3DQ[T];
Protect[Inverse];
Tens3DInverse::rank = "Tensor rank must be even.";




Unprotect[RightPolarDecomposition];
RightPolarDecomposition[T_] := Module[{val, vec, U, Q},
        If[T[rank] != 2, Message[RightPolarDecomposition::rank]; Return[],
          {val, vec} = Eigensystem[Transpose[T].T];
          
          U = DefineTensor[DiagonalMatrix[Map[Sqrt, val]], {1, -1}, 
              DefineBasis[Apply[Sequence, vec], 1]];
          Q = T.Inverse[U];
          {Q, U}
          ]
        ] /; Tens3DQ[T];
Protect[RightPolarDecomposition];
RightPolarDecomposition::rank = "Tensor rank must be 2.";


Unprotect[LeftPolarDecomposition];
LeftPolarDecomposition[T_] := Module[{val, vec, V, Q},
        If[T[rank] != 2, Message[LeftPolarDecomposition::rank]; Return[],
          {val, vec} = Eigensystem[T.Transpose[T]];
          
          V = DefineTensor[DiagonalMatrix[Map[Sqrt, val]], {1, -1}, 
              DefineBasis[Apply[Sequence, vec], 1]];
          Q = Inverse[V].T;
          {V, Q}
          ]
        ] /; Tens3DQ[T];
Protect[LeftPolarDecomposition];
LeftPolarDecomposition::rank = "Tensor rank must be 2.";

Unprotect[IdentityTensor];
IdentityTensor[n_] := If[n == 2, MetricTensor,
        DefineTensor[
          
          Array[If[Drop[{##}, -n/2] == Drop[{##}, n/2] , 1, 0] &, 
            Array[3 #^0 &, n]],
          Array[If[# <= n/2, 1, -1] &, {n}], CanonicalBasis]
        ] /; Mod[n, 2] == 0;
Protect[IdentityTensor];


Unprotect[EuclidianNorm];
EuclidianNorm[T_] := Which[
        T[rank] == 1, Simplify[Sqrt[T.T]],
        T[rank] == 2, Simplify[Sqrt[Colon[T, T]]],
        T[rank] == 3, Simplify [Sqrt[Therefore[T, T]]],
        T[rank] == 4, Simplify[Sqrt[Proportion[T, T]]],
        T[rank] > 4, Message[EuclidianNorm::rank]; Return[]
        ] /; Tens3DQ[T]; 
Protect[EuclidianNorm];
EuclidianNorm::rank = "Sorry, Function EuclidianNorm is limited to rank 4.";


Unprotect[DefineOrthogonalTensor];
DefineOrthogonalTensor[angle_, axis_, d_] := Module[{ax},
        ax = 
          SmallCircle[Simplify[Times[1, Power[EuclidianNorm[axis], -1]]], 
            axis];
        CircleMinus[
          CirclePlus[SmallCircle[Cos[angle], MetricTensor], 
            SmallCircle[Plus[d, Times[-1, Cos[angle]]], CircleTimes[ax, ax]]],
           SmallCircle[Sin[angle], Dot[OrientationTensor, ax]]]
        ] /; Tens3DQ[axis] && (d == 1 || d == -1);
Protect[DefineOrthogonalTensor];


Unprotect[IdentifyOrthogonalTensor];
IdentifyOrthogonalTensor[Q_] :=
    If[Rank[Q] == 2 && 
          FullSimplify[
              EuclidianNorm[Q.Transpose[Q] \[CircleMinus] MetricTensor]] == 
            0,
        {
          ArcCos[(AutoContract[Q] - Simplify[Det[Q]])/2],
          
          Colon[OrientationTensor, 
            SmallCircle[Asym[Q], 
              Times[-1, 
                Power[EuclidianNorm[
                    Colon[OrientationTensor, Asym[Q]]], -1]]]],
          FullSimplify[Det[Q]]
          }
        ,
        Message[IdentifyOrthogonalTensor::badinput, Q]; Return[]
        ] /; Tens3DQ[Q];
Protect[IdentifyOrthogonalTensor];
IdentifyOrthogonalTensor::badinput = \
"`1` is not a rank 2 orthogonal tensor.";


Unprotect[DefineCoordinateSystem];
DefineCoordinateSystem[OM_, L : {c1_Symbol, c2_Symbol, c3_Symbol}] := 
    Module[{compOM, v1, v2, v3, B},
        compOM = Components[OM, {1}, CanonicalBasis];
        v1 = DefineTensor[D[compOM, c1], {1}, CanonicalBasis];
        v2 = DefineTensor[D[compOM, c2], {1}, CanonicalBasis];
        v3 = DefineTensor[D[compOM, c3], {1}, CanonicalBasis];
        B = DefineBasis[v1, v2, v3, -1];
        If[BasisQ[B],
          B[coords] = {L[[1]], L[[2]], c3};
          B[chris] = Simplify[Array[
                 
                Sum[B[gCC][[mu, #2]]( 
                          D[B[gcc][[#3, mu]], L[[#1]]] + 
                            D[B[gcc][[#1, mu]], L[[#3]]] - 
                            D[B[gcc][[#1, #3]], L[[mu]]] ), {mu, 3}]/2 &
                , {3, 3, 3}]],
          Message[DefineCoordinateSystem::dependent]; Return[]
          ];
        B
        ]  /; Tens3DQ[OM] && Rank[OM] == 1;
DefineCoordinateSystem::dependent = "Natural Basis doesn't exists.";
Protect[DefineCoordinateSystem];


Unprotect[PrintChristoffel];
PrintChristoffel[B_] := Module[{L, ch, x},
        ch = {};
        If[B[coords] == {}, Message[PrintChristoffel::basis, B]; Return[]
          ,
          L = B[coords];
          For[i = 1, i < 4, i++,
            For[j = 1, j < 4, j++,
              For[k = 1, k < 4, k++,
                
                x = SubsuperscriptBox["\[CapitalGamma]", 
                    ToString[L[[i]]] <> ToString[L[[k]]], ToString[L[[j]]] ];
                ch = Append[ch, x];
                ch = Append[ch, "="];
                ch = Append[ch, RowBox[{Evaluate[B[chris][[i, j, k]]]} ]];
                If[i != 3 || j != 3 || k != 3, ch = Append[ch, " , "]]
                ]
              ]
            ];
          Print[DisplayForm[RowBox[ch]]]
          ]
        ] /; BasisQ[B];
PrintChristoffel::basis = \
"Basis `1` is not a natural basis of a coordinate system.";
Protect[PrintChristoffel];


Unprotect[ChristoffelArray];
ChristoffelArray[B_] := 
    If[B[coords] == {}, Message[ChristoffelArray::basis, B]; Return[]
        ,
        Print["Note : Indices : ", B[coords], 
          " , First(down) , Second(up) , Third(down)" ];
        B[chris]] /; BasisQ[B];
ChristoffelArray::basis = \
"Basis `1` is not a natural basis of a coordinate system.";
Protect[ChristoffelArray];


Unprotect[NormalizedBasis];
NormalizedBasis[B_] := Module[{v1, v2, v3},
        {v1, v2, v3} = BasisVectors[B];
        v1 = 
          SmallCircle[FullSimplify[Times[1, Power[EuclidianNorm[v1], -1]]], 
            v1];
        v2 = 
          SmallCircle[FullSimplify[Times[1, Power[EuclidianNorm[v2], -1]]], 
            v2];
        v3 = 
          SmallCircle[FullSimplify[Times[1, Power[EuclidianNorm[v3], -1]]], 
            v3];
        DefineBasis[v1, v2, v3]
        ] /; BasisQ[B];
Protect[NormalizedBasis];



Unprotect[Gradient];
Gradient[T_, B_] := Module[{compT, compGT, m},
        If[Tens3DQ[T],
          If[ Length[B[coords]] == 0,
            Message[Gradient::basis, B]; Return[]
            ,
            compT = Components[T, T[var], B];
            
            compGT = 
              Array[ D[compT[[ Apply[Sequence, Delete[{##}, -1]] ]], 
                    B[coords][[ {##}[[T[rank] + 1]] ]] ] &, 
                Map[3#^0 &, Range[T[rank] + 1]]];
            For[i = 1, i <= T[rank], i++,
              If[T[var][[i]] == 1,
                
                compGT = 
                  compGT + 
                    Array[Sum[
                          B[chris][[m, {##}[[ 
                                    i ]], {##}[[T[rank] + 1]]]] compT[[ 
                                Apply[Sequence, 
                                  ReplacePart[Delete[{##}, -1], m, i]]]], {m, 
                            3}] &, Map[3#^0 &, Range[T[rank] + 1]]]
                ,
                compGT =
                  
                  compGT - 
                    Array[Sum[
                          B[chris][[{##}[[i]], m,  {##}[[T[rank] + 1]] ]]*
                             
                            compT[[    
                                Apply[Sequence, 
                                  ReplacePart[Delete[{##}, -1], m, i]]   ]],
                          {m, 3}] &,
                      Map[3#^0 &, Range[T[rank] + 1]]]
                ]
              ];
            DefineTensor[compGT, Append[T[var], -1], B]
            ]
          ,
          If[Length[B[coords]] == 0,
            Message[Gradient::basis, B]; Return[]
            ,
            If[ArrayQ[T],
              Message[Gradient::arg]; Return[]
              ,
              DefineTensor[ Array[  D[T, B[coords][[#]] ] & , 3] , {-1} , B]
              ]
            ]
          ]
        ] /; BasisQ[B];
Gradient::arg = "Invalid first argument.";
Gradient::basis = "Basis `1` is not a natural basis of a coordinate system.";
Protect[Gradient]; 

Unprotect[Divergence];
Divergence[T_, B_] := If[T[rank] >= 1,
        Colon[Gradient[T, B], MetricTensor]
        ,
        Message[Divergence::rank, T]; Return[]
        ] /; Tens3DQ[T];
Divergence::rank = "First argument `1` must have a rank >= 1.";
Protect[Divergence];

Unprotect[Curl];
Curl[T_, B_] := 
    If[T[rank] >= 1, 
        SmallCircle[-1, Colon[Gradient[T, B], OrientationTensor]], 
        Message[Curl::rank, T]; Return[]] /; Tens3DQ[T];
Curl::rank = "First argument `1` must have a rank >= 1.";
Protect[Curl];

Unprotect[Laplacian];
Laplacian[T_, B_] := Divergence[Gradient[T, B], B];
Protect[Laplacian];


Unprotect[D];
D[T_, x__] := DefineTensor[
        D[Components[T, T[var], CanonicalBasis], x]
        , T[var], CanonicalBasis] /; Tens3DQ[T];
Protect[D];

Unprotect[CompactDerivativeForm];
CompactDerivativeForm[expr_] := Module[{derivative},
      derivative /: MakeBoxes[derivative[n__][f_][x__], StandardForm] := 
        RowBox[{
            SubscriptBox[
              "\[PartialD]",
              RowBox[
                Delete[Flatten[Map[({#, "\[InvisibleComma]"}) &,
                      Flatten[MapThread[Table, { {x}, Map[List, {n}] }]]
                      ]], -1]
                ]
              ]
            ,
            ToBoxes[f]
            }
          ];
      expr /. Derivative -> derivative
      ];
Protect[CompactDerivativeForm];


Unprotect[OrthogonalTransform];
OrthogonalTransform[T_, Q_] := Module [{a, q, l},
        If[EuclidianNorm[Q.Transpose[Q]\[CircleMinus]MetricTensor ] == 0
          ,
          a = Components[T, Table[1, {T[rank]}], Q[basis]];
          q = Components[Q, {1, -1}, Q[basis]];
          For[i = 1, i <= T[rank], i++,
            l = Range[T[rank]]; l[[i]] = 1; l[[1]] = i;
            a = Transpose[q.Transpose[a, l], l]
            ];
          DefineTensor[a, Table[1, {T[rank]}], Q[basis]]
          ,
          Message[OrthogonalTransform::arg]; Return[]
          ,
          Print["Note : Can not find if second argument is orthogonal."];
          a = Components[T, Table[1, {T[rank]}], Q[basis]];
          q = Components[Q, {1, -1}, Q[basis]];
          For[i = 1, i <= T[rank], i++,
            l = Range[T[rank]]; l[[i]] = 1; l[[1]] = i;
            a = Transpose[q.Transpose[a, l], l]
            ];
          DefineTensor[a, Table[1, {T[rank]}], Q[basis]]
          ]
        ] /; Tens3DQ [T] && Tens3DQ [Q];
Protect[OrthogonalTransform];
OrthogonalTransform::arg = "Second argument is not an orthogonal Tensor.";

End[ ];

EndPackage[];
