(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     22278,        735]*)
(*NotebookOutlinePosition[     22957,        758]*)
(*  CellTagsIndexPosition[     22913,        754]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[{
  "BrowserCategory[\"Tens3D\", None,{\n    Item[\"Introduction\",\"General.nb\
\",",
  StyleBox["CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  ",",
  StyleBox["IndexTag -> \"General\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    Item[Delimiter],\n    Item[\"Predefined objects\",\"Predef.nb\",",
  StyleBox["CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  ",",
  StyleBox["IndexTag -> \"Predef\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    BrowserCategory[\"Algebra\",None,{\n    \t\
Item[\"Introduction\",\"Algebraic.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Algebraic",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[Delimiter],\n    \tBrowserCategory[\"Creating \
tensors\",None,{\n    \t\tItem[\"Defining tensors by \
components\",\"DefineTensor.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "DefineTensor",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"General tensors\",\"DefineGeneralTensor.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "DefineGeneralTensor",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Test a tensor\",\"Tens3DQ.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Ten3DQ",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Rank of a tensor\",\"Rank.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Rank",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Defining orthonal tensors\",\"Orthogonal.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Orthogonal",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Defining Identity tensors\",\"Identity.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Identity",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    \t}],\n    \tItem[Delimiter],\n    \tBrowserCategory[\"Working on \
basis\",None,{\n    \t\tItem[\"DefineBasis\",\"DefineBasis.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "DefineBasis",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"BasisVectors\",\"BasisVectors.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "BasisVectors",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"DualBasisVectors\",\"BasisVectors.nb\"",
  StyleBox[", CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"NormalizedBasis\",\"NormalizedBasis.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "NormalizedBasis",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"BasisQ\",\"BasisQ.nb\",",
  StyleBox["CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "BasisQ",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    \t}],\n    \tItem[Delimiter],\n    \tBrowserCategory[\"General \
operations\",None,{\n    \t\tItem[\"Components\",\"Components.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Components",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Addition\",\"CirclePlus.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "CirclePlus",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Substraction\",\"CircleMinus.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "CircleMinus",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Product by scalar\",\"SmallCircle.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "SmallCircle",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\t",
  "Item[\"Transpositions\",\"Transpose.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Transpose",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],",
  "\n    \t\tItem[\"Tensorial Product\",\"CircleTimes.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "CircleTimes",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Contracted Products\",\"Contracted.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Contracted",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Contraction\",\"AutoContract.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Autocontract",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"EuclidianNorm\",\"EuclidianNorm.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "EuclidianNorm",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Cross product\",\"Wedge.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Wedge",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Orthogonal \
transformation\",\"OrthogonalTransform.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "OrthogonalTransform",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Partial derivative\",\"Deriv.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Deriv",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    \t}],\n    \tItem[Delimiter],\n    \tBrowserCategory[\"Even rank \
tensors operations\",None,{\n    \t\tItem[\"Eigensystem\",\"Eigen.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Eigen",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Eigenvalues\",\"Eigen.nb\"",
  StyleBox[", CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Eigentensors\",\"Eigen.nb\"",
  StyleBox[", CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Inverse\",\"Inverse.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Inverse",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Determinant\",\"Det.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Det",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    \t}],\n    \tBrowserCategory[\"Rank 2 tensors operations\",None,{\n \
   \t\tItem[\"Invariants\",\"Invariant.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Invariant",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Symmetrical Decomposition\",\"Symmetric.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"SymmetricT3D\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Spherical Decomposition\",\"Spheric.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Spheric",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Polar Decomposition\",\"PolarDecomposition.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "PolarDecomposition",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Defining orthonal tensors\",\"Orthogonal.nb\"",
  StyleBox[", CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \t\tItem[\"Caracterising orthonal tensors\",\"Orthogonal.nb\"",
  StyleBox[", CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    \t}]\n    }],\n    BrowserCategory[\"Analysis\",None,{\n    \tItem[\
\"Introduction\",\"Analysis.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Analysis",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[Delimiter],\n    \tItem[\"Coordinates \
Systems\",\"DefineCoordinateSystem.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "DefineCoordinateSystem",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[\"Christoffel coefficients\",\"Christoffel.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Christoffel",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[Delimiter],\n    \tItem[\"Gradient\",\"Gradient.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Gradient",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[\"Divergence\",\"Divergence.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Divergence",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[\"Curl\",\"Curl.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Curl",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "],\n    \tItem[\"Laplacian\",\"Laplacian.nb\"",
  StyleBox[", CopyTag -> None,IndexTag -> \"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "Laplacian",
  StyleBox["\"",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n    }],\n    Item[Delimiter],\n    Item[\"Examples\",\"Samples.nb\",",
  StyleBox["CopyTag -> None",
    PageWidth->Infinity,
    InitializationCell->True,
    ShowSpecialCharacters->False,
    FormatType->InputForm,
    FontFamily->"Courier New",
    FontSize->10],
  "]\n  }]"
}], "Input",
  PageWidth->Infinity,
  InitializationCell->True,
  ShowSpecialCharacters->False]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 979}},
AutoGeneratedPackage->Automatic,
WindowSize->{1117, 744},
WindowMargins->{{19, Automatic}, {Automatic, 83}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 20520, 682, 1326, "Input",
  InitializationCell->True]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

