(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     11037,        427]*)
(*NotebookOutlinePosition[     19452,        703]*)
(*  CellTagsIndexPosition[     17501,        636]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Master Index Entries for Tens3D", "Chapter"],

Cell["Tens3D Package", "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell["Tens3D", "IndexSection"],

Cell[BoxData[
    ButtonBox["Tens3D",
      ButtonData:>{"General"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Tens3D"],

Cell[BoxData[
    ButtonBox["CanonicalBasis",
      ButtonData:>{"Predef"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CanonicalBasis"],

Cell[BoxData[
    ButtonBox["MetricTensor",
      ButtonData:>{"Predef"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"MetricTensor"],

Cell[BoxData[
    ButtonBox["OrientationTensor",
      ButtonData:>{"Predef"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"OrientationTensor"],

Cell[BoxData[
    ButtonBox["Rank",
      ButtonData:>{"Rank"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Rank"],

Cell[BoxData[
    ButtonBox["DefineTensor",
      ButtonData:>{"DefineTensor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineTensor"],

Cell[BoxData[
    ButtonBox["DefineGeneralTensor",
      ButtonData:>{"DefineGeneralTensor"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineGeneralTensor"],

Cell[BoxData[
    ButtonBox["Components",
      ButtonData:>{"Components"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Components"],

Cell[BoxData[
    ButtonBox["Tens3DQ",
      ButtonData:>{"Tens3DQ"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Tens3DQ"],

Cell[BoxData[
    ButtonBox["BasisQ",
      ButtonData:>{"BasisQ"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BasisQ"],

Cell[BoxData[
    ButtonBox["DefineBasis",
      ButtonData:>{"DefineBasis"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineBasis"],

Cell[BoxData[
    ButtonBox["CircleTimes",
      ButtonData:>{"CircleTimes"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CircleTimes"],

Cell[BoxData[
    ButtonBox["CirclePlus",
      ButtonData:>{"CirclePlus"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CirclePlus"],

Cell[BoxData[
    ButtonBox["CircleMinus",
      ButtonData:>{"CircleMinus"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CircleMinus"],

Cell[BoxData[
    ButtonBox["SmallCircle",
      ButtonData:>{"SmallCircle"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SmallCircle"],

Cell[BoxData[
    ButtonBox["Dot",
      ButtonData:>{"Contracted"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Dot"],

Cell[BoxData[
    ButtonBox["Colon",
      ButtonData:>{"Contracted"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Colon"],

Cell[BoxData[
    ButtonBox["AutoContract",
      ButtonData:>{"AutoContract"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AutoContract"],

Cell[BoxData[
    ButtonBox["Therefore",
      ButtonData:>{"Contracted"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Therefore"],

Cell[BoxData[
    ButtonBox["Proportion",
      ButtonData:>{"Contracted"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Proportion"],

Cell[BoxData[
    ButtonBox["Wedge",
      ButtonData:>{"Wedge"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Wedge"],

Cell[BoxData[
    ButtonBox["FirstInvariant",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FirstInvariant"],

Cell[BoxData[
    ButtonBox["I1",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"I1"],

Cell[BoxData[
    ButtonBox["J1",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"J1"],

Cell[BoxData[
    ButtonBox["SecondInvariant",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SecondInvariant"],

Cell[BoxData[
    ButtonBox["I2",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"I2"],

Cell[BoxData[
    ButtonBox["J2",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"J2"],

Cell[BoxData[
    ButtonBox["ThirdInvariant",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ThirdInvariant"],

Cell[BoxData[
    ButtonBox["I3",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"I3"],

Cell[BoxData[
    ButtonBox["J3",
      ButtonData:>{"Invariant"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"J3"],

Cell[BoxData[
    ButtonBox["SymmetricPart",
      ButtonData:>{"SymmetricT3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SymmetricPart"],

Cell[BoxData[
    ButtonBox["Sym",
      ButtonData:>{"SymmetricT3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Sym"],

Cell[BoxData[
    ButtonBox["AntisymmetricPart",
      ButtonData:>{"SymmetricT3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AntisymmetricPart"],

Cell[BoxData[
    ButtonBox["Asym",
      ButtonData:>{"SymmetricT3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Asym"],

Cell[BoxData[
    ButtonBox["SphericalPart",
      ButtonData:>{"Spheric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SphericalPart"],

Cell[BoxData[
    ButtonBox["Sph",
      ButtonData:>{"Spheric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Sph"],

Cell[BoxData[
    ButtonBox["TracelessPart",
      ButtonData:>{"Spheric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"TracelessPart"],

Cell[BoxData[
    ButtonBox["Dev",
      ButtonData:>{"Spheric"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Dev"],

Cell[BoxData[
    ButtonBox["BasisVectors",
      ButtonData:>{"BasisVectors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BasisVectors"],

Cell[BoxData[
    ButtonBox["DualBasisVectors",
      ButtonData:>{"BasisVectors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DualBasisVectors"],

Cell[BoxData[
    ButtonBox["Eigensystem",
      ButtonData:>{"Eigen"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Eigensystem"],

Cell[BoxData[
    ButtonBox["Eigenvalues",
      ButtonData:>{"Eigen"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Eigenvalues"],

Cell[BoxData[
    ButtonBox["Eigentensors",
      ButtonData:>{"Eigen"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Eigentensors"],

Cell[BoxData[
    ButtonBox["Inverse",
      ButtonData:>{"Inverse"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Inverse"],

Cell[BoxData[
    ButtonBox["RightPolarDecomposition",
      ButtonData:>{"PolarDecomposition"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"RightPolarDecomposition"],

Cell[BoxData[
    ButtonBox["LeftPolarDecomposition",
      ButtonData:>{"PolarDecomposition"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"LeftPolarDecomposition"],

Cell[BoxData[
    ButtonBox["IdentityTensor",
      ButtonData:>{"Identity"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IdentityTensor"],

Cell[BoxData[
    ButtonBox["EuclidianNorm",
      ButtonData:>{"EuclidianNorm"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"EuclidianNorm"],

Cell[BoxData[
    ButtonBox["DefineOrthogonalTensor",
      ButtonData:>{"Orthogonal"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineOrthogonalTensor"],

Cell[BoxData[
    ButtonBox["IdentifyOrthogonalTensor",
      ButtonData:>{"Orthogonal"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IdentifyOrthogonalTensor"],

Cell[BoxData[
    ButtonBox["OrthogonalTransform",
      ButtonData:>{"OrthogonalTransform"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"OrthogonalTransform"],

Cell[BoxData[
    ButtonBox["DefineCoordinateSystem",
      ButtonData:>{"DefineCoordinateSystem"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DefineCoordinateSystem"],

Cell[BoxData[
    ButtonBox["PrintChristoffel",
      ButtonData:>{"Christoffel"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PrintChristoffel"],

Cell[BoxData[
    ButtonBox["ChristoffelArray",
      ButtonData:>{"Christoffel"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ChristoffelArray"],

Cell[BoxData[
    ButtonBox["NormalizedBasis",
      ButtonData:>{"NormalizedBasis"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"NormalizedBasis"],

Cell[BoxData[
    ButtonBox["Gradient",
      ButtonData:>{"Gradient"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Gradient"],

Cell[BoxData[
    ButtonBox["Divergence",
      ButtonData:>{"Divergence"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Divergence"],

Cell[BoxData[
    ButtonBox["Curl",
      ButtonData:>{"Curl"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Curl"],

Cell[BoxData[
    ButtonBox["Laplacian",
      ButtonData:>{"Laplacian"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Laplacian"],

Cell[BoxData[
    ButtonBox["Det",
      ButtonData:>{"Det"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Det"],

Cell[BoxData[
    ButtonBox["Transpose",
      ButtonData:>{"Transpose"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Transpose"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 979}},
ScreenStyleEnvironment->"Brackets",
WindowToolbars->"EditBar",
WindowSize->{788, 728},
WindowMargins->{{Automatic, 54}, {25, Automatic}},
ShowCellBracket->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "MasterIndexHeading"->{
    Cell[1829, 55, 72, 1, 51, "IndexSection",
      CellTags->"MasterIndexHeading"]},
  "Tens3D"->{
    Cell[1937, 60, 134, 4, 20, "Index",
      CellTags->"Tens3D"]},
  "CanonicalBasis"->{
    Cell[2074, 66, 149, 4, 20, "Index",
      CellTags->"CanonicalBasis"]},
  "MetricTensor"->{
    Cell[2226, 72, 145, 4, 20, "Index",
      CellTags->"MetricTensor"]},
  "OrientationTensor"->{
    Cell[2374, 78, 155, 4, 20, "Index",
      CellTags->"OrientationTensor"]},
  "Rank"->{
    Cell[2532, 84, 127, 4, 20, "Index",
      CellTags->"Rank"]},
  "DefineTensor"->{
    Cell[2662, 90, 151, 4, 20, "Index",
      CellTags->"DefineTensor"]},
  "DefineGeneralTensor"->{
    Cell[2816, 96, 172, 4, 20, "Index",
      CellTags->"DefineGeneralTensor"]},
  "Components"->{
    Cell[2991, 102, 145, 4, 20, "Index",
      CellTags->"Components"]},
  "Tens3DQ"->{
    Cell[3139, 108, 136, 4, 20, "Index",
      CellTags->"Tens3DQ"]},
  "BasisQ"->{
    Cell[3278, 114, 133, 4, 20, "Index",
      CellTags->"BasisQ"]},
  "DefineBasis"->{
    Cell[3414, 120, 148, 4, 20, "Index",
      CellTags->"DefineBasis"]},
  "CircleTimes"->{
    Cell[3565, 126, 148, 4, 20, "Index",
      CellTags->"CircleTimes"]},
  "CirclePlus"->{
    Cell[3716, 132, 145, 4, 20, "Index",
      CellTags->"CirclePlus"]},
  "CircleMinus"->{
    Cell[3864, 138, 148, 4, 20, "Index",
      CellTags->"CircleMinus"]},
  "SmallCircle"->{
    Cell[4015, 144, 148, 4, 20, "Index",
      CellTags->"SmallCircle"]},
  "Dot"->{
    Cell[4166, 150, 131, 4, 20, "Index",
      CellTags->"Dot"]},
  "Colon"->{
    Cell[4300, 156, 135, 4, 20, "Index",
      CellTags->"Colon"]},
  "AutoContract"->{
    Cell[4438, 162, 151, 4, 20, "Index",
      CellTags->"AutoContract"]},
  "Therefore"->{
    Cell[4592, 168, 143, 4, 20, "Index",
      CellTags->"Therefore"]},
  "Proportion"->{
    Cell[4738, 174, 145, 4, 20, "Index",
      CellTags->"Proportion"]},
  "Wedge"->{
    Cell[4886, 180, 130, 4, 20, "Index",
      CellTags->"Wedge"]},
  "FirstInvariant"->{
    Cell[5019, 186, 152, 4, 20, "Index",
      CellTags->"FirstInvariant"]},
  "I1"->{
    Cell[5174, 192, 128, 4, 20, "Index",
      CellTags->"I1"]},
  "J1"->{
    Cell[5305, 198, 128, 4, 20, "Index",
      CellTags->"J1"]},
  "SecondInvariant"->{
    Cell[5436, 204, 154, 4, 20, "Index",
      CellTags->"SecondInvariant"]},
  "I2"->{
    Cell[5593, 210, 128, 4, 20, "Index",
      CellTags->"I2"]},
  "J2"->{
    Cell[5724, 216, 128, 4, 20, "Index",
      CellTags->"J2"]},
  "ThirdInvariant"->{
    Cell[5855, 222, 152, 4, 20, "Index",
      CellTags->"ThirdInvariant"]},
  "I3"->{
    Cell[6010, 228, 128, 4, 20, "Index",
      CellTags->"I3"]},
  "J3"->{
    Cell[6141, 234, 128, 4, 20, "Index",
      CellTags->"J3"]},
  "SymmetricPart"->{
    Cell[6272, 240, 153, 4, 20, "Index",
      CellTags->"SymmetricPart"]},
  "Sym"->{
    Cell[6428, 246, 133, 4, 20, "Index",
      CellTags->"Sym"]},
  "AntisymmetricPart"->{
    Cell[6564, 252, 161, 4, 20, "Index",
      CellTags->"AntisymmetricPart"]},
  "Asym"->{
    Cell[6728, 258, 135, 4, 20, "Index",
      CellTags->"Asym"]},
  "SphericalPart"->{
    Cell[6866, 264, 148, 4, 20, "Index",
      CellTags->"SphericalPart"]},
  "Sph"->{
    Cell[7017, 270, 128, 4, 20, "Index",
      CellTags->"Sph"]},
  "TracelessPart"->{
    Cell[7148, 276, 148, 4, 20, "Index",
      CellTags->"TracelessPart"]},
  "Dev"->{
    Cell[7299, 282, 128, 4, 20, "Index",
      CellTags->"Dev"]},
  "BasisVectors"->{
    Cell[7430, 288, 151, 4, 20, "Index",
      CellTags->"BasisVectors"]},
  "DualBasisVectors"->{
    Cell[7584, 294, 159, 4, 20, "Index",
      CellTags->"DualBasisVectors"]},
  "Eigensystem"->{
    Cell[7746, 300, 142, 4, 20, "Index",
      CellTags->"Eigensystem"]},
  "Eigenvalues"->{
    Cell[7891, 306, 142, 4, 20, "Index",
      CellTags->"Eigenvalues"]},
  "Eigentensors"->{
    Cell[8036, 312, 144, 4, 20, "Index",
      CellTags->"Eigentensors"]},
  "Inverse"->{
    Cell[8183, 318, 136, 4, 20, "Index",
      CellTags->"Inverse"]},
  "RightPolarDecomposition"->{
    Cell[8322, 324, 179, 4, 20, "Index",
      CellTags->"RightPolarDecomposition"]},
  "LeftPolarDecomposition"->{
    Cell[8504, 330, 177, 4, 20, "Index",
      CellTags->"LeftPolarDecomposition"]},
  "IdentityTensor"->{
    Cell[8684, 336, 151, 4, 20, "Index",
      CellTags->"IdentityTensor"]},
  "EuclidianNorm"->{
    Cell[8838, 342, 154, 4, 20, "Index",
      CellTags->"EuclidianNorm"]},
  "DefineOrthogonalTensor"->{
    Cell[8995, 348, 169, 4, 20, "Index",
      CellTags->"DefineOrthogonalTensor"]},
  "IdentifyOrthogonalTensor"->{
    Cell[9167, 354, 173, 4, 20, "Index",
      CellTags->"IdentifyOrthogonalTensor"]},
  "OrthogonalTransform"->{
    Cell[9343, 360, 172, 4, 20, "Index",
      CellTags->"OrthogonalTransform"]},
  "DefineCoordinateSystem"->{
    Cell[9518, 366, 181, 4, 20, "Index",
      CellTags->"DefineCoordinateSystem"]},
  "PrintChristoffel"->{
    Cell[9702, 372, 158, 4, 20, "Index",
      CellTags->"PrintChristoffel"]},
  "ChristoffelArray"->{
    Cell[9863, 378, 158, 4, 20, "Index",
      CellTags->"ChristoffelArray"]},
  "NormalizedBasis"->{
    Cell[10024, 384, 160, 4, 20, "Index",
      CellTags->"NormalizedBasis"]},
  "Gradient"->{
    Cell[10187, 390, 139, 4, 20, "Index",
      CellTags->"Gradient"]},
  "Divergence"->{
    Cell[10329, 396, 145, 4, 20, "Index",
      CellTags->"Divergence"]},
  "Curl"->{
    Cell[10477, 402, 127, 4, 20, "Index",
      CellTags->"Curl"]},
  "Laplacian"->{
    Cell[10607, 408, 142, 4, 20, "Index",
      CellTags->"Laplacian"]},
  "Det"->{
    Cell[10752, 414, 124, 4, 20, "Index",
      CellTags->"Det"]},
  "Transpose"->{
    Cell[10879, 420, 142, 4, 20, "Index",
      CellTags->"Transpose"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"MasterIndexHeading", 11765, 446},
  {"Tens3D", 11865, 449},
  {"CanonicalBasis", 11955, 452},
  {"MetricTensor", 12051, 455},
  {"OrientationTensor", 12150, 458},
  {"Rank", 12241, 461},
  {"DefineTensor", 12327, 464},
  {"DefineGeneralTensor", 12428, 467},
  {"Components", 12527, 470},
  {"Tens3DQ", 12615, 473},
  {"BasisQ", 12699, 476},
  {"DefineBasis", 12787, 479},
  {"CircleTimes", 12880, 482},
  {"CirclePlus", 12972, 485},
  {"CircleMinus", 13064, 488},
  {"SmallCircle", 13157, 491},
  {"Dot", 13242, 494},
  {"Colon", 13321, 497},
  {"AutoContract", 13409, 500},
  {"Therefore", 13501, 503},
  {"Proportion", 13591, 506},
  {"Wedge", 13677, 509},
  {"FirstInvariant", 13767, 512},
  {"I1", 13854, 515},
  {"J1", 13929, 518},
  {"SecondInvariant", 14017, 521},
  {"I2", 14105, 524},
  {"J2", 14180, 527},
  {"ThirdInvariant", 14267, 530},
  {"I3", 14354, 533},
  {"J3", 14429, 536},
  {"SymmetricPart", 14515, 539},
  {"Sym", 14602, 542},
  {"AntisymmetricPart", 14693, 545},
  {"Asym", 14785, 548},
  {"SphericalPart", 14873, 551},
  {"Sph", 14960, 554},
  {"TracelessPart", 15047, 557},
  {"Dev", 15134, 560},
  {"BasisVectors", 15220, 563},
  {"DualBasisVectors", 15319, 566},
  {"Eigensystem", 15417, 569},
  {"Eigenvalues", 15510, 572},
  {"Eigentensors", 15604, 575},
  {"Inverse", 15694, 578},
  {"RightPolarDecomposition", 15795, 581},
  {"LeftPolarDecomposition", 15911, 584},
  {"IdentityTensor", 16018, 587},
  {"EuclidianNorm", 16116, 590},
  {"DefineOrthogonalTensor", 16222, 593},
  {"IdentifyOrthogonalTensor", 16339, 596},
  {"OrthogonalTransform", 16453, 599},
  {"DefineCoordinateSystem", 16565, 602},
  {"PrintChristoffel", 16674, 605},
  {"ChristoffelArray", 16777, 608},
  {"NormalizedBasis", 16879, 611},
  {"Gradient", 16974, 614},
  {"Divergence", 17064, 617},
  {"Curl", 17150, 620},
  {"Laplacian", 17235, 623},
  {"Det", 17319, 626},
  {"Transpose", 17403, 629}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 50, 0, 115, "Chapter"],
Cell[1829, 55, 72, 1, 51, "IndexSection",
  CellTags->"MasterIndexHeading"],
Cell[1904, 58, 30, 0, 51, "IndexSection"],
Cell[1937, 60, 134, 4, 20, "Index",
  CellTags->"Tens3D"],
Cell[2074, 66, 149, 4, 20, "Index",
  CellTags->"CanonicalBasis"],
Cell[2226, 72, 145, 4, 20, "Index",
  CellTags->"MetricTensor"],
Cell[2374, 78, 155, 4, 20, "Index",
  CellTags->"OrientationTensor"],
Cell[2532, 84, 127, 4, 20, "Index",
  CellTags->"Rank"],
Cell[2662, 90, 151, 4, 20, "Index",
  CellTags->"DefineTensor"],
Cell[2816, 96, 172, 4, 20, "Index",
  CellTags->"DefineGeneralTensor"],
Cell[2991, 102, 145, 4, 20, "Index",
  CellTags->"Components"],
Cell[3139, 108, 136, 4, 20, "Index",
  CellTags->"Tens3DQ"],
Cell[3278, 114, 133, 4, 20, "Index",
  CellTags->"BasisQ"],
Cell[3414, 120, 148, 4, 20, "Index",
  CellTags->"DefineBasis"],
Cell[3565, 126, 148, 4, 20, "Index",
  CellTags->"CircleTimes"],
Cell[3716, 132, 145, 4, 20, "Index",
  CellTags->"CirclePlus"],
Cell[3864, 138, 148, 4, 20, "Index",
  CellTags->"CircleMinus"],
Cell[4015, 144, 148, 4, 20, "Index",
  CellTags->"SmallCircle"],
Cell[4166, 150, 131, 4, 20, "Index",
  CellTags->"Dot"],
Cell[4300, 156, 135, 4, 20, "Index",
  CellTags->"Colon"],
Cell[4438, 162, 151, 4, 20, "Index",
  CellTags->"AutoContract"],
Cell[4592, 168, 143, 4, 20, "Index",
  CellTags->"Therefore"],
Cell[4738, 174, 145, 4, 20, "Index",
  CellTags->"Proportion"],
Cell[4886, 180, 130, 4, 20, "Index",
  CellTags->"Wedge"],
Cell[5019, 186, 152, 4, 20, "Index",
  CellTags->"FirstInvariant"],
Cell[5174, 192, 128, 4, 20, "Index",
  CellTags->"I1"],
Cell[5305, 198, 128, 4, 20, "Index",
  CellTags->"J1"],
Cell[5436, 204, 154, 4, 20, "Index",
  CellTags->"SecondInvariant"],
Cell[5593, 210, 128, 4, 20, "Index",
  CellTags->"I2"],
Cell[5724, 216, 128, 4, 20, "Index",
  CellTags->"J2"],
Cell[5855, 222, 152, 4, 20, "Index",
  CellTags->"ThirdInvariant"],
Cell[6010, 228, 128, 4, 20, "Index",
  CellTags->"I3"],
Cell[6141, 234, 128, 4, 20, "Index",
  CellTags->"J3"],
Cell[6272, 240, 153, 4, 20, "Index",
  CellTags->"SymmetricPart"],
Cell[6428, 246, 133, 4, 20, "Index",
  CellTags->"Sym"],
Cell[6564, 252, 161, 4, 20, "Index",
  CellTags->"AntisymmetricPart"],
Cell[6728, 258, 135, 4, 20, "Index",
  CellTags->"Asym"],
Cell[6866, 264, 148, 4, 20, "Index",
  CellTags->"SphericalPart"],
Cell[7017, 270, 128, 4, 20, "Index",
  CellTags->"Sph"],
Cell[7148, 276, 148, 4, 20, "Index",
  CellTags->"TracelessPart"],
Cell[7299, 282, 128, 4, 20, "Index",
  CellTags->"Dev"],
Cell[7430, 288, 151, 4, 20, "Index",
  CellTags->"BasisVectors"],
Cell[7584, 294, 159, 4, 20, "Index",
  CellTags->"DualBasisVectors"],
Cell[7746, 300, 142, 4, 20, "Index",
  CellTags->"Eigensystem"],
Cell[7891, 306, 142, 4, 20, "Index",
  CellTags->"Eigenvalues"],
Cell[8036, 312, 144, 4, 20, "Index",
  CellTags->"Eigentensors"],
Cell[8183, 318, 136, 4, 20, "Index",
  CellTags->"Inverse"],
Cell[8322, 324, 179, 4, 20, "Index",
  CellTags->"RightPolarDecomposition"],
Cell[8504, 330, 177, 4, 20, "Index",
  CellTags->"LeftPolarDecomposition"],
Cell[8684, 336, 151, 4, 20, "Index",
  CellTags->"IdentityTensor"],
Cell[8838, 342, 154, 4, 20, "Index",
  CellTags->"EuclidianNorm"],
Cell[8995, 348, 169, 4, 20, "Index",
  CellTags->"DefineOrthogonalTensor"],
Cell[9167, 354, 173, 4, 20, "Index",
  CellTags->"IdentifyOrthogonalTensor"],
Cell[9343, 360, 172, 4, 20, "Index",
  CellTags->"OrthogonalTransform"],
Cell[9518, 366, 181, 4, 20, "Index",
  CellTags->"DefineCoordinateSystem"],
Cell[9702, 372, 158, 4, 20, "Index",
  CellTags->"PrintChristoffel"],
Cell[9863, 378, 158, 4, 20, "Index",
  CellTags->"ChristoffelArray"],
Cell[10024, 384, 160, 4, 20, "Index",
  CellTags->"NormalizedBasis"],
Cell[10187, 390, 139, 4, 20, "Index",
  CellTags->"Gradient"],
Cell[10329, 396, 145, 4, 20, "Index",
  CellTags->"Divergence"],
Cell[10477, 402, 127, 4, 20, "Index",
  CellTags->"Curl"],
Cell[10607, 408, 142, 4, 20, "Index",
  CellTags->"Laplacian"],
Cell[10752, 414, 124, 4, 20, "Index",
  CellTags->"Det"],
Cell[10879, 420, 142, 4, 20, "Index",
  CellTags->"Transpose"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

