(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4648,        130]*)
(*NotebookOutlinePosition[      5333,        153]*)
(*  CellTagsIndexPosition[      5289,        149]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Tens3D", "Chapter"],

Cell[CellGroupData[{

Cell["What is Tens3D ?", "Section"],

Cell[TextData[{
  "Tens3D is a package designed for tensorial calculations in ",
  StyleBox["classical physics ",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  "(like continuum mechanics, optics, electromagnetism) where the tensors are \
built on a three dimensional vector space.\nIn the most tensorial tools, \
vectors and tensors are defined only by their components without information \
on which basis these components are valid. Moreover, the basis is often \
assumed to be orthonormal. Then the concept of variance of components is not \
present. With Tens3D you can define and use any basis and components may have \
any variance.\n\nWith tens3D, to define a tensor, it is necessary to give :\n\
\t- an array of components,\n\t- the list of the variances of the indices,\n\t\
- the basis on which the components are valid.\n\t\nWith Tens3D tools, you \
may ask for the values of components of a tensor in any variances and on any \
basis (orthonormal or not).\n\nTens3D provides the classical tensorial \
algebra operations (addition, substraction, product by a scalar, tensorial \
product, contracted tensorial products, transposition, etc).\n\nIn addition, \
Tens3D provides tools for analysis on tensorial fields (mappings ",
  StyleBox["M",
    FontSlant->"Italic"],
  " \[Element] \[DoubleStruckCapitalE] \[RightArrow] ",
  StyleBox["T",
    FontSlant->"Italic"],
  " \[Element] ",
  Cell[BoxData[
      \(TraditionalForm\`\[DoubleStruckCapitalT]\_p\)]],
  ", where ",
  StyleBox["M",
    FontSlant->"Italic"],
  " is a point of the ",
  StyleBox["three dimensional",
    FontSlant->"Italic"],
  " space \[DoubleStruckCapitalE] and ",
  StyleBox["T",
    FontSlant->"Italic"],
  " is a rank ",
  StyleBox["p",
    FontSlant->"Italic"],
  " tensor of the space ",
  Cell[BoxData[
      \(TraditionalForm\`\[DoubleStruckCapitalT]\_p\)]],
  ") . The point ",
  StyleBox["M",
    FontSlant->"Italic"],
  "  can be identified by using ",
  StyleBox["any coordinate system",
    FontSlant->"Italic"],
  ".\nYou may calculate new tensoral fields like Gradient, Divergence, Curl, \
and Laplacian of tensorial fields in any coordinate system. \n\nThe \
documentation is organized into three parts :\n\t1 - ",
  StyleBox[ButtonBox["Predefined objects",
    ButtonData:>{"Predef", None},
    ButtonStyle->"AddOnsLink"],
    FontFamily->"Times New Roman"],
  ",\n\t2 - ",
  StyleBox[ButtonBox["Algebra calculations",
    ButtonData:>{"Algebraic", None},
    ButtonStyle->"AddOnsLink"],
    FontFamily->"Times New Roman"],
  ",\n\t3 - ",
  StyleBox[ButtonBox["Analysis calculations on tensorial fields",
    ButtonData:>{"Analysis", None},
    ButtonStyle->"AddOnsLink"],
    FontFamily->"Times New Roman"],
  ".\n\n"
}], "Text",
  CellDingbat->None]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 979}},
WindowSize->{893, 740},
WindowMargins->{{180, Automatic}, {103, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 25, 0, 115, "Chapter"],

Cell[CellGroupData[{
Cell[1826, 57, 35, 0, 80, "Section"],
Cell[1864, 59, 2756, 67, 665, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

