(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    237853,       8938]*)
(*NotebookOutlinePosition[    238924,       8973]*)
(*  CellTagsIndexPosition[    238804,       8966]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Style Definitions for Online Help", "Title"],

Cell["\<\
These styles are carefully tuned for all aspects of the online help. \
It's recommended that they remain unchanged.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Working"],
  PageWidth->WindowWidth,
  ShowCellBracket->False,
  CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
  ShowAutoStyles->False,
  ScriptMinSize->9],

Cell[StyleData[All, "Brackets"],
  PageWidth->WindowWidth,
  ShowCellBracket->True,
  CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
  ShowAutoStyles->False,
  ScriptMinSize->9],

Cell[StyleData[All, "Presentation"],
  PageWidth->WindowWidth,
  ShowCellBracket->False,
  CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
  ShowAutoStyles->False,
  ScriptMinSize->9],

Cell[StyleData[All, "SlideShow"],
  PageWidth->WindowWidth,
  ScrollingOptions->{"PagewiseDisplay"->True,
  "VerticalScrollRange"->Fit},
  ShowCellBracket->False,
  ScriptMinSize->9],

Cell[StyleData[All, "Printout"],
  PageWidth->PaperWidth,
  ShowCellBracket->False,
  ShowAutoStyles->False,
  ScriptMinSize->5,
  PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "EnhancedPrintout"],
  PageWidth->PaperWidth,
  ShowCellBracket->True,
  ScriptMinSize->5,
  FontFamily->"Palatino",
  PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "EnhancedPrintoutNonGray"],
  PageWidth->PaperWidth,
  ShowCellBracket->False,
  ScriptMinSize->5,
  FontFamily->"Palatino",
  PrivateFontOptions->{"FontType"->"Outline"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
  The options defined for the style below will be used at the \
Notebook level.  \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Notebook"],
  PageHeaders->{{Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
          TextData[ {"Printed from the ", 
            StyleBox[ "Mathematica", FontSlant -> "Italic"], 
            " Help Browser"}], "PageHeader"]}, {Cell[ 
          TextData[ {"Printed from the ", 
            StyleBox[ "Mathematica", FontSlant -> "Italic"], 
            " Help Browser"}], "PageHeader"], None, Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"]}},
  PageFooters->{{None, Cell[ 
          
          TextData[ {
            "\[Copyright]1988-2005 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
          
          TextData[ {
            "\[Copyright]1988-2005 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
  PageHeaderLines->{True, True},
  PageFooterLines->{True, True},
  PrintingOptions->{"FacingPages"->True},
  CellLabelAutoDelete->False,
  CellFrameLabelMargins->6,
  StyleMenuListing->None],

Cell[StyleData["Notebook", "Printout"],
  PageHeaders->{{Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
          TextData[ {"Printed from the ", 
            StyleBox[ "Mathematica", FontSlant -> "Italic"], 
            " Help Browser"}], "PageHeader"]}, {Cell[ 
          TextData[ {"Printed from the ", 
            StyleBox[ "Mathematica", FontSlant -> "Italic"], 
            " Help Browser"}], "PageHeader"], None, Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"]}},
  PageFooters->{{None, Cell[ 
          
          TextData[ {
            "\[Copyright]1988-2005 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
          
          TextData[ {
            "\[Copyright]1988-2005 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
  PageHeaderLines->{True, True},
  PageFooterLines->{True, True},
  PrintingOptions->{"FacingPages"->True}],

Cell[StyleData["Notebook", "EnhancedPrintout"],
  PageFooters->{{None, None, None}, {None, None, None}},
  PageHeaderLines->{True, True},
  PageFooterLines->{False, False},
  PrintingOptions->{"PrintingMargins"->{{54, 54}, {36, 72}},
  "PageSize"->{594, 657},
  "PrintRegistrationMarks"->True,
  "FirstPageHeader"->False,
  "FacingPages"->True,
  "FirstPageFace"->Right}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Headings", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Chapter"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{27, 27}, {10, 40}},
  CellGroupingRules->{"TitleGrouping", 0},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Chapter",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}},
  FontFamily->"Helvetica",
  FontSize->28,
  FontWeight->"Plain",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Chapter", "Presentation"],
  FontSize->36],

Cell[StyleData["Chapter", "Printout"],
  CellMargins->{{2, 10}, {6, 30}},
  FontSize->24],

Cell[StyleData["Chapter", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {6, 30}},
  FontFamily->"Frutiger-Roman",
  FontSize->24,
  FontColor->GrayLevel[0]],

Cell[StyleData["Chapter", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {6, 30}},
  FontFamily->"Frutiger-Roman",
  FontSize->24]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
  CellMargins->{{27, 27}, {9, 30}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  FontFamily->"Helvetica",
  FontSize->20,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Section", "Presentation"],
  FontSize->30],

Cell[StyleData["Section", "SlideShow"],
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowCellBracket->False,
  CellMargins->{{0, 0}, {5, 0}},
  PageBreakBelow->False,
  CellFrameMargins->{{36, 36}, {Inherited, 15}},
  FontFamily->"Helvetica",
  FontSize->18,
  FontWeight->"Bold",
  FontColor->GrayLevel[1],
  Background->RGBColor[0.408011, 0.440726, 0.8]],

Cell[StyleData["Section", "Printout"],
  CellMargins->{{2, 0}, {0, 18}},
  PageBreakBelow->False,
  FontSize->18],

Cell[StyleData["Section", "EnhancedPrintout"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{2, 2}, {5, 30}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->8,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  FontFamily->"Frutiger-Bold",
  FontSize->16,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["Section", "EnhancedPrintoutNonGray"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{2, Inherited}, {5, 30}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->8,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  FontFamily->"Frutiger-Bold",
  FontSize->16,
  FontWeight->"Plain"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
  CellDingbat->None,
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 40},
  PageBreakBelow->False,
  CellFrameLabelMargins->6,
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
              FontSize -> Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
      "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}},
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726],
  Background->None],

Cell[StyleData["Subsection", "Presentation"],
  FontSize->24],

Cell[StyleData["Subsection", "SlideShow"],
  CellDingbat->None,
  CellMargins->{{70, 0}, {4, 12}},
  FontSize->12],

Cell[StyleData["Subsection", "Printout"],
  CellMargins->{{2, 0}, {5, 24}},
  FontSize->12],

Cell[StyleData["Subsection", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {5, 20}},
  FontFamily->"Frutiger-Bold",
  FontSize->12,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{9, 0}, {5, 20}},
  FontFamily->"Frutiger-Bold",
  FontSize->12,
  FontWeight->"Plain"]
}, Open  ]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 50},
  PageBreakBelow->False,
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Subsubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["Subsubsection", "Printout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontSize->10],

Cell[StyleData["Subsubsection", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionColor"],
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 50},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0.297993, 0, 0.454994]],

Cell[StyleData["SubsubsectionColor", "Presentation"],
  FontSize->18],

Cell[StyleData["SubsubsectionColor", "Printout"],
  CellMargins->{{2, 0}, {0, 18}},
  PageBreakBelow->False,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionIcon"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{46, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->8},
  CellGroupingRules->{"SectionGrouping", 40},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  CounterIncrements->"Subsection",
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["SubsectionIcon", "Presentation"],
  FontSize->24],

Cell[StyleData["SubsectionIcon", "Printout"],
  CellDingbat->"\[FilledSquare]",
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{16, 0}, {0, 18}},
  PageBreakBelow->False,
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionIcon"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{46, 27}, {0, 8}},
  CellElementSpacings->{"ClosedGroupTopMargin"->4},
  CellGroupingRules->{"SectionGrouping", 50},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  CounterIncrements->"Subsubsection",
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["SubsubsectionIcon", "Presentation"],
  FontSize->18],

Cell[StyleData["SubsubsectionIcon", "Printout"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{2, 0}, {0, 18}},
  PageBreakBelow->False,
  FontSize->10]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Text", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
  CellMargins->{{27, 27}, {0, 8}},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  ParagraphSpacing->{0, 8},
  CounterIncrements->"Text",
  FontSize->12],

Cell[StyleData["Text", "Presentation"],
  FontSize->18],

Cell[StyleData["Text", "SlideShow"],
  CellMargins->{{36, 24}, {4, 4}},
  Hyphenation->False,
  FontSize->14],

Cell[StyleData["Text", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["Text", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["Text", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CompactText"],
  CellMargins->{{27, 27}, {0, 8}},
  ParagraphSpacing->{0, 0},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["CompactText", "Presentation"],
  FontSize->15],

Cell[StyleData["CompactText", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontSize->8],

Cell[StyleData["CompactText", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->8],

Cell[StyleData["CompactText", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Compact12Text"],
  CellMargins->{{27, 27}, {0, 8}},
  ParagraphSpacing->{0, 0},
  StyleMenuListing->None],

Cell[StyleData["Compact12Text", "Presentation"],
  FontSize->18],

Cell[StyleData["Compact12Text", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["Compact12Text", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["Compact12Text", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextSans"],
  CellMargins->{{27, 27}, {0, 8}},
  CellHorizontalScrolling->True,
  ParagraphSpacing->{0, 8},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10],

Cell[StyleData["TextSans", "Presentation"],
  FontSize->15],

Cell[StyleData["TextSans", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontSize->8],

Cell[StyleData["TextSans", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Frutiger-Roman",
  FontSize->8],

Cell[StyleData["TextSans", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontFamily->"Frutiger-Roman",
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedText"],
  CellMargins->{{66, 4}, {4, 4}},
  LineSpacing->{1, 3},
  ParagraphIndent->-22,
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],

Cell[StyleData["ItemizedText", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedText", "Printout"],
  CellMargins->{{16, 4}, {2, 4}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ItemizedText", "EnhancedPrintout"],
  CellMargins->{{16, 4}, {2, 4}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedText", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  LineSpacing->{1, 1},
  ParagraphIndent->-18,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedTextNote"],
  CellMargins->{{88, 4}, {4, 0}},
  LineSpacing->{1, 2},
  CounterIncrements->"ItemizedTextNote",
  StyleMenuListing->None],

Cell[StyleData["ItemizedTextNote", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedTextNote", "Printout"],
  CellMargins->{{34, 4}, {4, 1}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ItemizedTextNote", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {4, 1}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedTextNote", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 4}, {4, 1}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndentedText"],
  CellMargins->{{66, 4}, {0, 6}},
  LineSpacing->{1, 3},
  CounterIncrements->"IndentedText",
  StyleMenuListing->None],

Cell[StyleData["IndentedText", "Presentation"],
  FontSize->18],

Cell[StyleData["IndentedText", "SlideShow"],
  CellMargins->{{80, 24}, {5, 5}},
  Hyphenation->False,
  FontSize->13],

Cell[StyleData["IndentedText", "Printout"],
  CellMargins->{{16, 4}, {2, 4}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["IndentedText", "EnhancedPrintout"],
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["IndentedText", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedList"],
  CellMargins->{{58, 4}, {4, 4}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            StyleBox[ 
              CounterBox[ "ItemizedList"], "TB"], 
            StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, 
          CellSize -> {24, Inherited}, TextAlignment -> Right], 
        Inherited}, {Inherited, Inherited}},
  LineSpacing->{1, 3},
  CounterIncrements->"ItemizedList",
  StyleMenuListing->None],

Cell[StyleData["ItemizedList", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedList", "Printout"],
  CellMargins->{{9, 4}, {2, 4}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ItemizedList", "EnhancedPrintout"],
  CellMargins->{{9, 4}, {2, 4}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedList", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedSubList"],
  CellMargins->{{92, 4}, {4, 4}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            StyleBox[ 
              CounterBox[ "ItemizedSubList"], "TB"], 
            StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, 
          CellSize -> {24, Inherited}, TextAlignment -> Right], 
        Inherited}, {Inherited, Inherited}},
  CounterIncrements->"ItemizedSubList",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["ItemizedSubList", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedSubList", "Printout"],
  CellMargins->{{34, 4}, {4, 1}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ItemizedSubList", "EnhancedPrintout"],
  CellMargins->{{26, 4}, {2, 4}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedSubList", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedSubListNote"],
  CellMargins->{{110, 4}, {4, 4}},
  CounterIncrements->"ItemizedSubList",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["ItemizedSubListNote", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedSubListNote", "Printout"],
  CellMargins->{{34, 4}, {4, 1}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ItemizedSubListNote", "EnhancedPrintout"],
  CellMargins->{{56, 4}, {2, 4}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedSubListNote", "EnhancedPrintoutNonGray"],
  CellMargins->{{48, 4}, {2, 4}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BulletedList"],
  CellMargins->{{76, 4}, {4, 4}},
  CellFrameLabels->{{
    Cell[ "\[Bullet]", "BulletedList", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  LineSpacing->{1, 3},
  CounterIncrements->"BulletText",
  StyleMenuListing->None],

Cell[StyleData["BulletedList", "Presentation"],
  FontSize->18],

Cell[StyleData["BulletedList", "Printout"],
  CellMargins->{{16, 4}, {4, 1}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["BulletedList", "EnhancedPrintout"],
  CellMargins->{{26, 4}, {2, 4}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["BulletedList", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ListNote"],
  CellMargins->{{88, 4}, {4, 0}},
  LineSpacing->{1, 2},
  CounterIncrements->"ListNote",
  StyleMenuListing->None],

Cell[StyleData["ListNote", "Presentation"],
  FontSize->18],

Cell[StyleData["ListNote", "Printout"],
  CellMargins->{{34, 4}, {4, 1}},
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["ListNote", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {4, 1}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ListNote", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 4}, {4, 1}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MathCaption"],
  CellFrame->{{0, 0}, {0, 0.5}},
  CellMargins->{{66, 12}, {2, 20}},
  PageBreakBelow->False,
  CellFrameMargins->{{8, 8}, {8, 2}},
  CellFrameColor->GrayLevel[0.700008],
  CellFrameLabelMargins->4,
  LineSpacing->{1, 1},
  ParagraphSpacing->{0, 8},
  FontColor->GrayLevel[0.2]],

Cell[StyleData["MathCaption", "Presentation"],
  FontSize->18],

Cell[StyleData["MathCaption", "SlideShow"],
  ShowCellBracket->False,
  CellMargins->{{36, 36}, {6, 6}}],

Cell[StyleData["MathCaption", "Printout"],
  CellMargins->{{9, 0}, {0, 14}},
  Hyphenation->True,
  FontSize->9,
  FontColor->GrayLevel[0]],

Cell[StyleData["MathCaption", "EnhancedPrintout"],
  CellMargins->{{9, 0}, {0, 14}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->9,
  FontColor->GrayLevel[0]],

Cell[StyleData["MathCaption", "EnhancedPrintoutNonGray"],
  CellMargins->{{9, 0}, {0, 14}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SmallText"],
  CellMargins->{{27, 27}, {0, 8}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0.7, 0},
  CounterIncrements->"SmallText",
  FontSize->9],

Cell[StyleData["SmallText", "Presentation"],
  FontSize->14],

Cell[StyleData["SmallText", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  TextJustification->1,
  Hyphenation->True,
  FontSize->7],

Cell[StyleData["SmallText", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->7],

Cell[StyleData["SmallText", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {5, 5}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Input/Output", "Section"],

Cell["\<\
The cells in this section define styles used for input and output to \
the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these \
style names.    \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {3, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellLabelAutoDelete->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultInputFormatType,
  ShowSpecialCharacters->Automatic,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Mathematica",
  FormatType->StandardForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  FontWeight->"Bold"],

Cell[StyleData["Input", "Presentation"],
  FontSize->18],

Cell[StyleData["Input", "SlideShow"],
  ShowCellBracket->True,
  CellMargins->{{100, 50}, {0, 6}},
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellFrameMargins->{{8, 8}, {4, 8}},
  Background->RGBColor[1, 1, 0.8]],

Cell[StyleData["Input", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {4, 6}},
  FontSize->9],

Cell[StyleData["Input", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {4, 6}},
  FontSize->9],

Cell[StyleData["Input", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {4, 6}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Output"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {8, 2}},
  CellEditDuplicate->True,
  CellGroupingRules->"OutputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  CellLabelAutoDelete->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultOutputFormatType,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->None,
  FormatType->StandardForm],

Cell[StyleData["Output", "Presentation"],
  FontSize->18],

Cell[StyleData["Output", "SlideShow"],
  ShowCellBracket->True,
  CellMargins->{{100, 50}, {6, 0}},
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellFrameMargins->{{8, 8}, {8, 4}},
  Background->RGBColor[1, 1, 0.8]],

Cell[StyleData["Output", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 4}},
  FontSize->9],

Cell[StyleData["Output", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 4}},
  FontSize->9],

Cell[StyleData["Output", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 4}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputOnly"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {8, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellLabelAutoDelete->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultInputFormatType,
  ShowSpecialCharacters->Automatic,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Mathematica",
  FormatType->StandardForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["InputOnly", "Presentation"],
  FontSize->18],

Cell[StyleData["InputOnly", "SlideShow"],
  ShowCellBracket->True,
  CellMargins->{{100, 50}, {6, 6}},
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  Background->RGBColor[1, 1, 0.8]],

Cell[StyleData["InputOnly", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 6}},
  FontSize->9],

Cell[StyleData["InputOnly", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 6}},
  FontSize->9],

Cell[StyleData["InputOnly", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{39, 0}, {6, 6}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {4, 2}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultOutputFormatType,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->None,
  FormatType->InputForm,
  CounterIncrements->"Message",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontColor->RGBColor[0.6, 0.100008, 0.100008]],

Cell[StyleData["Message", "Presentation"],
  FontSize->18],

Cell[StyleData["Message", "SlideShow"],
  CellMargins->{{100, 50}, {6, 6}},
  FontSize->10,
  FontColor->RGBColor[0.699992, 0.4, 0]],

Cell[StyleData["Message", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontSize->9,
  FontColor->GrayLevel[0]],

Cell[StyleData["Message", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier",
  FontSize->9,
  FontColor->GrayLevel[0]],

Cell[StyleData["Message", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier",
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {4, 2}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultOutputFormatType,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->None,
  FormatType->InputForm,
  StyleMenuListing->None],

Cell[StyleData["Print", "Presentation"],
  FontSize->18],

Cell[StyleData["Print", "SlideShow"],
  CellMargins->{{100, 50}, {6, 6}}],

Cell[StyleData["Print", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{57, Inherited}, {Inherited, Inherited}},
  FontSize->9],

Cell[StyleData["Print", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{57, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier Std",
  FontSize->9],

Cell[StyleData["Print", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{57, Inherited}, {Inherited, Inherited}},
  FontFamily->"Courier Std",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
  ShowCellBracket->True,
  CellMargins->{{66, 4}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  PageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  DefaultFormatType->DefaultFormatTypeForOutput,
  LanguageCategory->None,
  FormatType->InputForm,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Graphics", "Presentation"],
  FontSize->18],

Cell[StyleData["Graphics", "SlideShow"],
  ShowCellBracket->True,
  CellMargins->{{100, 50}, {6, 0}},
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellFrameMargins->{{8, 8}, {4, 4}},
  Background->RGBColor[1, 1, 0.8]],

Cell[StyleData["Graphics", "Printout"],
  ShowCellBracket->False,
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  ImageSize->{250, 250},
  FontSize->9],

Cell[StyleData["Graphics", "EnhancedPrintout"],
  ShowCellBracket->False,
  CellMargins->{{32, Inherited}, {Inherited, Inherited}},
  ImageSize->{250, 250},
  FontFamily->"Courier Std",
  FontSize->9],

Cell[StyleData["Graphics", "EnhancedPrintoutNonGray"],
  ShowCellBracket->False,
  CellMargins->{{32, Inherited}, {Inherited, Inherited}},
  ImageSize->{250, 250},
  FontFamily->"Courier Std",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
  LanguageCategory->None,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontWeight->"Plain",
  FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["CellLabel", "Presentation"],
  FontSize->14],

Cell[StyleData["CellLabel", "SlideShow"],
  FontColor->RGBColor[0.699992, 0.4, 0]],

Cell[StyleData["CellLabel", "Printout"],
  FontFamily->"Courier",
  FontSize->8,
  FontSlant->"Oblique",
  FontColor->GrayLevel[0]],

Cell[StyleData["CellLabel", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSize->8,
  FontSlant->"Oblique",
  FontColor->GrayLevel[0]],

Cell[StyleData["CellLabel", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSize->8,
  FontSlant->"Oblique",
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Name"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontWeight->"Plain",
  FontSlant->"Italic",
  FontColor->RGBColor[0.269993, 0.308507, 0.6]],

Cell[StyleData["Name", "Presentation"],
  FontSize->14],

Cell[StyleData["Name", "Printout"],
  FontSize->7,
  FontSlant->"Oblique",
  FontColor->GrayLevel[0]],

Cell[StyleData["Name", "EnhancedPrintout"],
  FontFamily->"Frutiger-Italic",
  FontSize->7,
  FontSlant->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["Name", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Italic",
  FontSize->7,
  FontSlant->"Plain",
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Section"],

Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same \
Notebook, or between Notebooks. The others point to the various \
sections of the help browser. These styles will modify individual \
words or letters in a cell exclusive of the cell tag.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["Hyperlink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["Hyperlink", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["Hyperlink", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MainBookLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["MainBookLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MainBookLink", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MainBookLink", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MainBookLinkMR"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Courier",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["MainBookLinkMR", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MainBookLinkMR", "EnhancedPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MainBookLinkMR", "EnhancedPrintoutNonGray"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AddOnsLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Courier",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["AddOnsLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["AddOnsLink", "EnhancedPrintout"],
  FontFamily->"WRICourier",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["AddOnsLink", "EnhancedPrintoutNonGray"],
  FontFamily->"WRICourier",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AddOnsLinkText"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Times",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["AddOnsLinkText", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["AddOnsLinkText", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["AddOnsLinkText", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefGuideLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Courier",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefGuideLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["RefGuideLink", "EnhancedPrintout"],
  FontFamily->"WRICourier",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["RefGuideLink", "EnhancedPrintoutNonGray"],
  FontFamily->"WRICourier",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GettingStartedLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["GettingStartedLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["GettingStartedLink", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["GettingStartedLink", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DemosLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "Demos", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["DemosLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["DemosLink", "EnhancedPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["DemosLink", "EnhancedPrintoutNonGray"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TourLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "Tour", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["TourLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["TourLink", "EnhancedPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["TourLink", "EnhancedPrintoutNonGray"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OtherInformationLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["OtherInformationLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["OtherInformationLink", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["OtherInformationLink", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OtherInformationLinkMR"],
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["OtherInformationLinkMR", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintoutNonGray"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MasterIndexLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "MasterIndex", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["MasterIndexLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MasterIndexLink", "EnhancedPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["MasterIndexLink", "EnhancedPrintoutNonGray"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotebookLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Times",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["NotebookLink", "Printout"],
  FontSize->11,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["NotebookLink", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["NotebookLink", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotebookLinkMR"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Courier",
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["NotebookLinkMR", "Printout"],
  FontSize->11,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["NotebookLinkMR", "EnhancedPrintout"],
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["NotebookLinkMR", "EnhancedPrintoutNonGray"],
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Palette Styles", "Section"],

Cell["\<\
The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.\
\>", "Text"],

Cell[StyleData["Paste"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, After]}]&)}],

Cell[StyleData["Evaluate"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, All], 
      FrontEnd`SelectionEvaluate[ 
        FrontEnd`InputNotebook[ ], All]}]&)}],

Cell[StyleData["EvaluateCell"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, All], 
      FrontEnd`SelectionMove[ 
        FrontEnd`InputNotebook[ ], All, Cell, 1], 
      FrontEnd`SelectionEvaluateCreateCell[ 
        FrontEnd`InputNotebook[ ], All]}]&)}],

Cell[StyleData["CopyEvaluate"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`SelectionCreateCell[ 
        FrontEnd`InputNotebook[ ], All], 
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, All], 
      FrontEnd`SelectionEvaluate[ 
        FrontEnd`InputNotebook[ ], All]}]&)}],

Cell[StyleData["CopyEvaluateCell"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`SelectionCreateCell[ 
        FrontEnd`InputNotebook[ ], All], 
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, All], 
      FrontEnd`SelectionEvaluateCreateCell[ 
        FrontEnd`InputNotebook[ ], All]}]&)}]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Formatting", "Section"],

Cell["\<\
These styles are for modifying individual words or letters in a cell \
exclusive of the cell tag.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["JT"],
  StyleMenuListing->None,
  FontFamily->"JFontText"],

Cell[StyleData["JT", "Printout"]],

Cell[StyleData["JT", "EnhancedPrintout"]],

Cell[StyleData["JT", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["JS"],
  StyleMenuListing->None,
  FontFamily->"JFontSans"],

Cell[StyleData["JS", "Printout"]],

Cell[StyleData["JS", "EnhancedPrintout"]],

Cell[StyleData["JS", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["JSB"],
  StyleMenuListing->None,
  FontFamily->"JFontSansBold"],

Cell[StyleData["JSB", "Printout"]],

Cell[StyleData["JSB", "EnhancedPrintout"]],

Cell[StyleData["JSB", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RM"],
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["RM", "Printout"]],

Cell[StyleData["RM", "EnhancedPrintout"]],

Cell[StyleData["RM", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BF"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["BF", "Printout"]],

Cell[StyleData["BF", "EnhancedPrintout"]],

Cell[StyleData["BF", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IT"],
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["IT", "Printout"]],

Cell[StyleData["IT", "EnhancedPrintout"]],

Cell[StyleData["IT", "EnhancedPrintoutNonGray"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TR"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["TR", "Printout"]],

Cell[StyleData["TR", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["TR", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TI"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSlant->"Italic"],

Cell[StyleData["TI", "Printout"]],

Cell[StyleData["TI", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["TI", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TB"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["TB", "Printout"]],

Cell[StyleData["TB", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["TB", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TBI"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["TBI", "Printout"]],

Cell[StyleData["TBI", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["TBI", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MR"],
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["MR", "Printout"]],

Cell[StyleData["MR", "EnhancedPrintout"],
  FontFamily->"Courier Std"],

Cell[StyleData["MR", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MO"],
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["MO", "Printout"],
  FontSlant->"Oblique"],

Cell[StyleData["MO", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSlant->"Oblique"],

Cell[StyleData["MO", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSlant->"Oblique"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MB"],
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["MB", "Printout"]],

Cell[StyleData["MB", "EnhancedPrintout"],
  FontFamily->"Courier Std"],

Cell[StyleData["MB", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MBO"],
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["MBO", "Printout"],
  FontSlant->"Oblique"],

Cell[StyleData["MBO", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSlant->"Oblique"],

Cell[StyleData["MBO", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSlant->"Oblique"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SR"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SR", "Printout"]],

Cell[StyleData["SR", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman"],

Cell[StyleData["SR", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SO"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SO", "Printout"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SO", "EnhancedPrintout"],
  FontFamily->"Frutiger-Italic",
  FontSlant->"Plain"],

Cell[StyleData["SO", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Italic",
  FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SB"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["SB", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["SB", "EnhancedPrintout"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"],

Cell[StyleData["SB", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SBColor"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["SBColor", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["SBColor", "EnhancedPrintout"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"],

Cell[StyleData["SBColor", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SBO"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["SBO", "Printout"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["SBO", "EnhancedPrintout"],
  FontFamily->"Frutiger-BoldItalic",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SBO", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-BoldItalic",
  FontWeight->"Plain",
  FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["M4"],
  ShowCellBracket->True,
  StyleMenuListing->None,
  FontFamily->"Mathematica4",
  CharacterEncoding->"Mathematica4"],

Cell[StyleData["M4", "Printout"],
  ShowCellBracket->True,
  StyleMenuListing->None,
  FontFamily->"Mathematica4",
  CharacterEncoding->"Mathematica4"],

Cell[StyleData["M4", "EnhancedPrintout"],
  ShowCellBracket->True,
  StyleMenuListing->None,
  FontFamily->"Mathematica4",
  CharacterEncoding->"Mathematica4"],

Cell[StyleData["M4", "EnhancedPrintoutNonGray"],
  ShowCellBracket->True,
  StyleMenuListing->None,
  FontFamily->"Mathematica4",
  CharacterEncoding->"Mathematica4"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SO10"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SO10", "Printout"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->8,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SO10", "EnhancedPrintout"],
  StyleMenuListing->None,
  FontFamily->"Frutiger-Italic",
  FontSize->8,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SO10", "EnhancedPrintoutNonGray"],
  StyleMenuListing->None,
  FontFamily->"Frutiger-Italic",
  FontSize->8,
  FontWeight->"Plain",
  FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["S9"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontWeight->"Plain"],

Cell[StyleData["S9", "Printout"],
  FontSize->9,
  FontWeight->"Plain"],

Cell[StyleData["S9", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman",
  FontSize->9,
  FontWeight->"Plain"],

Cell[StyleData["S9", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman",
  FontSize->9,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["S10"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Plain"],

Cell[StyleData["S10", "Printout"],
  FontSize->10,
  FontWeight->"Plain"],

Cell[StyleData["S10", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman",
  FontSize->10,
  FontWeight->"Plain"],

Cell[StyleData["S10", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman",
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SB9"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontWeight->"Bold",
  PrivateFontOptions->{"OperatorSubstitution"->False}],

Cell[StyleData["SB9", "Printout"],
  FontSize->7],

Cell[StyleData["SB9", "EnhancedPrintout"],
  FontFamily->"Frutiger-Bold",
  FontSize->7,
  FontWeight->"Plain"],

Cell[StyleData["SB9", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Bold",
  FontSize->7,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SB10"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Bold"],

Cell[StyleData["SB10", "Printout"],
  FontSize->8],

Cell[StyleData["SB10", "EnhancedPrintout"],
  FontFamily->"Frutiger-Bold",
  FontSize->8,
  FontWeight->"Plain"],

Cell[StyleData["SB10", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Bold",
  FontSize->8,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MR10"],
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  SingleLetterItalics->False,
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->10,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["MR10", "Printout"],
  FontSize->7],

Cell[StyleData["MR10", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSize->7],

Cell[StyleData["MR10", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MO10"],
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  SingleLetterItalics->False,
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->10,
  FontSlant->"Italic"],

Cell[StyleData["MO10", "Printout"],
  FontSize->7],

Cell[StyleData["MO10", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSize->7],

Cell[StyleData["MO10", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["C1"],
  StyleMenuListing->None,
  FontColor->RGBColor[0.4, 0, 1]],

Cell[StyleData["C1", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["C1", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["C1", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["C1MR"],
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontColor->RGBColor[0.4, 0, 1]],

Cell[StyleData["C1MR", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["C1MR", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["C1MR", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SmallCaps"],
  StyleMenuListing->None,
  Magnification->0.8],

Cell[StyleData["SmallCaps", "Printout"]],

Cell[StyleData["SmallCaps", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["SmallCaps", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["KeyboardChars"],
  StyleMenuListing->None,
  FontSize->12],

Cell[StyleData["KeyboardChars", "Printout"],
  FontSize->10],

Cell[StyleData["KeyboardChars", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["KeyboardChars", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Inert"],
  StyleMenuListing->None,
  Background->RGBColor[0.870588, 0.905882, 0.972549]],

Cell[StyleData["Inert", "Printout"],
  StyleMenuListing->None,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell["TMB Specific", "Subsection"],

Cell[StyleData["HeadingNumber"],
  StyleMenuListing->None]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Emphasis Boxes and Pictures", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Box"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnSpacings->1}],

Cell[StyleData["Box", "Presentation"],
  FontSize->18],

Cell[StyleData["Box", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["Box", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["Box", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DoubleBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnSpacings->2,
  RowAlignments->Top}],

Cell[StyleData["DoubleBox", "Presentation"],
  FontSize->18],

Cell[StyleData["DoubleBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["DoubleBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["DoubleBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["1ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnSpacings->1}],

Cell[StyleData["1ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["1ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["1ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["1ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  SingleLetterItalics->False,
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->{0.31, 0.67}}],

Cell[StyleData["2ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["2ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnEvenBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->0.46}],

Cell[StyleData["2ColumnEvenBox", "Presentation"],
  FontSize->18],

Cell[StyleData["2ColumnEvenBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnEvenBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnEvenBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnSmallBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnSpacings->1.5,
  ColumnWidths->0.35,
  ColumnAlignments->{Right, Left}}],

Cell[StyleData["2ColumnSmallBox", "Presentation"],
  FontSize->18],

Cell[StyleData["2ColumnSmallBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnSmallBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["2ColumnSmallBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->0.32}],

Cell[StyleData["3ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["3ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["3ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["3ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnSmallBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnSpacings->1.5,
  ColumnWidths->0.24,
  ColumnAlignments->{Right, Center, Left}}],

Cell[StyleData["3ColumnSmallBox", "Presentation"],
  FontSize->18],

Cell[StyleData["3ColumnSmallBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["3ColumnSmallBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["3ColumnSmallBox", "EnhancedPrintoutNonGray"],
  CellFrame->0.5,
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["4ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  SingleLetterItalics->False,
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->{0.13, 0.35, 0.13, 0.35}}],

Cell[StyleData["4ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["4ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["4ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["4ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["5ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->0.202}],

Cell[StyleData["5ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["5ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[0.900008]],

Cell[StyleData["5ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[0.900008]],

Cell[StyleData["5ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->9,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["6ColumnBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxFrame->0.5,
  BoxMargins->True},
  GridBoxOptions->{ColumnWidths->{0.12, 0.22, 0.12, 0.12, 0.22, 0.12}}
  ],

Cell[StyleData["6ColumnBox", "Presentation"],
  FontSize->18],

Cell[StyleData["6ColumnBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["6ColumnBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["6ColumnBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FramedBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnAlignments->{Left}}],

Cell[StyleData["FramedBox", "Presentation"],
  FontSize->18],

Cell[StyleData["FramedBox", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["FramedBox", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["FramedBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.4, 0.6},
  ColumnAlignments->{Left}}],

Cell[StyleData["DefinitionBox", "Presentation"],
  FontSize->18],

Cell[StyleData["DefinitionBox", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox3Col"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.35, 0.2, 0.45},
  ColumnAlignments->{Left}}],

Cell[StyleData["DefinitionBox3Col", "Presentation"],
  FontSize->18],

Cell[StyleData["DefinitionBox3Col", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox3Col", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox3Col", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox4Col"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.15, 0.35, 0.15, 0.35},
  ColumnAlignments->{Left}}],

Cell[StyleData["DefinitionBox4Col", "Presentation"],
  FontSize->18],

Cell[StyleData["DefinitionBox4Col", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox4Col", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox4Col", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrecedenceTable"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.3, 0.45, 0.2, 0.05},
  ColumnAlignments->{Left}}],

Cell[StyleData["PrecedenceTable", "Presentation"],
  FontSize->18],

Cell[StyleData["PrecedenceTable", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["PrecedenceTable", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["PrecedenceTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox5Col"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->0.2,
  ColumnAlignments->{Left}}],

Cell[StyleData["DefinitionBox5Col", "Presentation"],
  FontSize->18],

Cell[StyleData["DefinitionBox5Col", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox5Col", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox5Col", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionBox6Col"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.13, 0.24, 0.13, 0.13, 0.24, 0.13},
  ColumnAlignments->{Left}}],

Cell[StyleData["DefinitionBox6Col", "Presentation"],
  FontSize->18],

Cell[StyleData["DefinitionBox6Col", "Printout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox6Col", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["DefinitionBox6Col", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TopBox"],
  CellFrame->{{0.5, 0.5}, {0, 0.5}},
  CellMargins->{{27, 12}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["TopBox", "Presentation"],
  FontSize->18],

Cell[StyleData["TopBox", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[StyleData["TopBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1]],

Cell[StyleData["TopBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MiddleBox"],
  CellFrame->{{0.5, 0.5}, {0, 0}},
  CellMargins->{{27, 12}, {0, -7}},
  CellHorizontalScrolling->True,
  PageBreakAbove->False,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["MiddleBox", "Presentation"],
  FontSize->18],

Cell[StyleData["MiddleBox", "Printout"],
  CellMargins->{{2, 0}, {0, 2}},
  CellFrameColor->GrayLevel[0],
  Background->GrayLevel[1]],

Cell[StyleData["MiddleBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 4}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1]],

Cell[StyleData["MiddleBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 4}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BottomBox"],
  CellFrame->{{0.5, 0.5}, {0.5, 0}},
  CellMargins->{{27, 12}, {0, -7}},
  CellHorizontalScrolling->True,
  PageBreakAbove->False,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["BottomBox", "Presentation"],
  FontSize->18],

Cell[StyleData["BottomBox", "Printout"],
  CellMargins->{{2, 0}, {0, -5}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->2.2}],

Cell[StyleData["BottomBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, -5}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->2.2}],

Cell[StyleData["BottomBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, -5}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->2.2}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TopSpanBox"],
  CellFrame->{{0.5, 0.5}, {0, 0.5}},
  CellMargins->{{27, 12}, {-2, 8}},
  CellHorizontalScrolling->True,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.9, 0.03},
  ColumnAlignments->{Left}}],

Cell[StyleData["TopSpanBox", "Presentation"],
  FontSize->18],

Cell[StyleData["TopSpanBox", "Printout"],
  CellMargins->{{2, 0}, {-2, 8}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["TopSpanBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {-4, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]],

Cell[StyleData["TopSpanBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {-4, 8}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MiddleSpanBox"],
  CellFrame->{{0.5, 0.5}, {0, 0}},
  CellMargins->{{27, 12}, {0, 0}},
  CellHorizontalScrolling->True,
  PageBreakAbove->False,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.9, 0.03},
  ColumnAlignments->{Left}}],

Cell[StyleData["MiddleSpanBox", "Presentation"],
  FontSize->18],

Cell[StyleData["MiddleSpanBox", "Printout"],
  CellMargins->{{2, 0}, {-5, 0}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}],

Cell[StyleData["MiddleSpanBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {-7, 0}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}],

Cell[StyleData["MiddleSpanBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {-7, 0}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  FontSize->10,
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
  CellMargins->{{27, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["Picture", "Presentation"],
  FontSize->18],

Cell[StyleData["Picture", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.65],

Cell[StyleData["Picture", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.65],

Cell[StyleData["Picture", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.65]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OpenCloseItemizedPicture"],
  CellMargins->{{88, 4}, {4, 4}},
  PrivateCellOptions->{"DefaultCellGroupOpen"->False},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["OpenCloseItemizedPicture", "Presentation"],
  FontSize->18],

Cell[StyleData["OpenCloseItemizedPicture", "Printout"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False],

Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintout"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False],

Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintoutNonGray"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedPicture"],
  CellMargins->{{88, 4}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemizedPicture", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedPicture", "Printout"],
  CellMargins->{{77, 2}, {4, -4}},
  Magnification->0.5],

Cell[StyleData["ItemizedPicture", "EnhancedPrintout"],
  CellMargins->{{78, 2}, {12, -6}},
  Magnification->0.5],

Cell[StyleData["ItemizedPicture", "EnhancedPrintoutNonGray"],
  CellMargins->{{75, 2}, {4, -6}},
  Magnification->0.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ListGraphic"],
  CellMargins->{{88, 4}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ListGraphic", "Presentation"],
  FontSize->18],

Cell[StyleData["ListGraphic", "Printout"],
  CellMargins->{{77, 2}, {4, -4}},
  Magnification->0.5],

Cell[StyleData["ListGraphic", "EnhancedPrintout"],
  CellMargins->{{78, 2}, {12, -6}},
  Magnification->0.5],

Cell[StyleData["ListGraphic", "EnhancedPrintoutNonGray"],
  CellMargins->{{75, 2}, {4, -6}},
  Magnification->0.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ListNoteBox"],
  CellFrame->0.5,
  CellMargins->{{88, 12}, {8, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
  GridBoxOptions->{ColumnSpacings->1}],

Cell[StyleData["ListNoteBox", "Presentation"],
  FontSize->18],

Cell[StyleData["ListNoteBox", "Printout"],
  CellMargins->{{77, 4}, {6, 2}},
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ListNoteBox", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ListNoteBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{77, 4}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureGroup"],
  CellMargins->{{41, 4}, {0, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureGroup", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureGroup", "Printout"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False],

Cell[StyleData["PictureGroup", "EnhancedPrintout"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False],

Cell[StyleData["PictureGroup", "EnhancedPrintoutNonGray"],
  CellMargins->{{76, 2}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->1,
  "ClosedCellHeight"->0},
  CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Sound"],
  ShowCellBracket->True,
  CellMargins->{{27, Inherited}, {0, 8}},
  StyleMenuListing->None],

Cell[StyleData["Sound", "Presentation"],
  FontSize->18],

Cell[StyleData["Sound", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["Sound", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["Sound", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Caption"],
  CellMargins->{{27, 4}, {0, 3}},
  PageBreakAbove->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["Caption", "Presentation"],
  FontSize->14],

Cell[StyleData["Caption", "Printout"],
  CellMargins->{{2, 4}, {2, 0}},
  FontSize->7],

Cell[StyleData["Caption", "EnhancedPrintout"],
  CellMargins->{{2, 4}, {2, 2}},
  FontFamily->"Frutiger-Roman",
  FontSize->7],

Cell[StyleData["Caption", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {2, -2}},
  FontFamily->"Frutiger-Roman",
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tables", "Section"],

Cell[CellGroupData[{

Cell[StyleData["2ColumnTable"],
  CellMargins->{{35, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->{0.34, 0.64},
  ColumnAlignments->{Left}}],

Cell[StyleData["2ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["2ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["2ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["2ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["2ColumnEvenTable"],
  CellMargins->{{35, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->0.49,
  ColumnAlignments->{Left}}],

Cell[StyleData["2ColumnEvenTable", "Presentation"],
  FontSize->18],

Cell[StyleData["2ColumnEvenTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["2ColumnEvenTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["2ColumnEvenTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnTable"],
  CellMargins->{{35, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->{0.28, 0.28, 0.43},
  ColumnAlignments->{Left}}],

Cell[StyleData["3ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["3ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["3ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9],

Cell[StyleData["3ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Formulas and Programming", "Section"],

Cell[CellGroupData[{

Cell[StyleData["InlineFormula"],
  CellMargins->{{27, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  LanguageCategory->"Formula",
  AutoSpacing->True,
  ScriptLevel->1,
  SingleLetterItalics->True,
  SpanMaxSize->Infinity,
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->Automatic}],

Cell[StyleData["InlineFormula", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["InlineFormula", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["InlineFormula", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InlineOutput"],
  CellMargins->{{27, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  LanguageCategory->None,
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["InlineOutput", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9.5],

Cell[StyleData["InlineOutput", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9.5],

Cell[StyleData["InlineOutput", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}},
  FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DisplayFormula"],
  CellMargins->{{66, Inherited}, {Inherited, 10}},
  CellHorizontalScrolling->True,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  LanguageCategory->"Formula",
  ScriptLevel->0,
  SingleLetterItalics->True,
  SpanMaxSize->Infinity,
  StyleMenuListing->None,
  UnderoverscriptBoxOptions->{LimitsPositioning->True},
  GridBoxOptions->{ColumnWidths->Automatic}],

Cell[StyleData["DisplayFormula", "Presentation"],
  FontSize->18],

Cell[StyleData["DisplayFormula", "Printout"]],

Cell[StyleData["DisplayFormula", "EnhancedPrintout"],
  FontFamily->"Palatino"],

Cell[StyleData["DisplayFormula", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DisplayMath"],
  CellMargins->{{66, 10}, {7, 7}},
  Evaluatable->False,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  DefaultFormatType->DefaultInputFormatType,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  CounterIncrements->"Input"],

Cell[StyleData["DisplayMath", "Presentation"],
  FontSize->18],

Cell[StyleData["DisplayMath", "Printout"],
  CellMargins->{{39, 0}, {6, 6}},
  FontSize->9],

Cell[StyleData["DisplayMath", "EnhancedPrintout"],
  CellMargins->{{39, 0}, {4, 6}},
  FontFamily->"WRICourier",
  FontSize->9],

Cell[StyleData["DisplayMath", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 0}, {4, 6}},
  FontFamily->"WRICourier",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedEquation"],
  CellMargins->{{66, 27}, {7, 7}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
  DefaultFormatType->DefaultInputFormatType,
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  LanguageCategory->"Formula",
  CounterIncrements->"NumberedEquation",
  FormatTypeAutoConvert->False],

Cell[StyleData["NumberedEquation", "Presentation"],
  FontSize->18],

Cell[StyleData["NumberedEquation", "Printout"],
  CellMargins->{{39, 55}, {0, 10}},
  FontSize->10],

Cell[StyleData["NumberedEquation", "EnhancedPrintout"],
  CellMargins->{{39, 55}, {0, 10}},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["NumberedEquation", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 55}, {0, 10}},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationNumber"],
  CellMargins->{{66, Inherited}, {Inherited, Inherited}},
  LineSpacing->{1.83, 0},
  LanguageCategory->"Formula"],

Cell[StyleData["EquationNumber", "Presentation"],
  FontSize->18],

Cell[StyleData["EquationNumber", "Printout"],
  LineSpacing->{1.7, 0}],

Cell[StyleData["EquationNumber", "EnhancedPrintout"],
  LineSpacing->{1.7, 0},
  FontFamily->"Palatino"],

Cell[StyleData["EquationNumber", "EnhancedPrintoutNonGray"],
  LineSpacing->{1.7, 0},
  FontFamily->"Palatino"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Program"],
  CellMargins->{{66, Inherited}, {Inherited, 10}},
  CellHorizontalScrolling->True,
  ShowSpecialCharacters->Automatic,
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FontFamily->"Courier"],

Cell[StyleData["Program", "Presentation"],
  FontSize->18],

Cell[StyleData["Program", "Printout"],
  CellMargins->{{42, 30}, {Inherited, 4}},
  FontSize->9.5],

Cell[StyleData["Program", "EnhancedPrintout"],
  CellMargins->{{42, 30}, {Inherited, 4}},
  FontFamily->"WRICourier",
  FontSize->9.5],

Cell[StyleData["Program", "EnhancedPrintoutNonGray"],
  CellMargins->{{42, 30}, {Inherited, 4}},
  FontFamily->"WRICourier",
  FontSize->9.5]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Unique Help Browser Styles", "Section"],

Cell[CellGroupData[{

Cell["\<\
Standard Styles
\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["InspectorLevel1"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 10}, {2, 7}},
  CellGroupingRules->{"SectionGrouping", 60},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphIndent->-38,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["InspectorLevel1", "Presentation"],
  FontSize->24],

Cell[StyleData["InspectorLevel1", "SlideShow"],
  HyphenationOptions->{"HyphenationCharacter"->"-"}],

Cell[StyleData["InspectorLevel1", "Printout"],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InspectorLevel2"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 14}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["InspectorLevel2", "Presentation"],
  FontSize->21],

Cell[StyleData["InspectorLevel2", "SlideShow"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{48, 10}, {2, 12}},
  CellGroupingRules->{"SectionGrouping", 70},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphIndent->-27,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["InspectorLevel2", "Printout"],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObjectName"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{0, 0}, {0, 0}},
  CellGroupingRules->{"SectionGrouping", 50},
  CellFrameMargins->{{27, 12}, {3, 15}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->18,
  FontWeight->"Bold",
  Background->RGBColor[0.960784, 0.878431, 0.666667]],

Cell[StyleData["ObjectName", "Presentation"],
  FontSize->24],

Cell[StyleData["ObjectName", "SlideShow"],
  CellMargins->{{72, 4}, {1, 14}},
  CellGroupingRules->{"SectionGrouping", 90},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["ObjectName", "Printout"],
  CellMargins->{{0, 0}, {0, 10}},
  CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubObjectNameClosed"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {1, 10}},
  PrivateCellOptions->{"DefaultCellGroupOpen"->False},
  CellGroupingRules->{"SectionGrouping", 90},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["SubObjectNameClosed", "Presentation"],
  FontSize->21],

Cell[StyleData["SubObjectNameClosed", "SlideShow"],
  CellMargins->{{72, 4}, {1, 14}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["SubObjectNameClosed", "Printout"],
  CellMargins->{{2, 0}, {1, 10}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubObjectName"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {1, 10}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->18,
  FontWeight->"Bold"],

Cell[StyleData["SubObjectName", "Presentation"],
  FontSize->24],

Cell[StyleData["SubObjectName", "SlideShow"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{90, 4}, {1, 14}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontFamily->"Courier",
  FontSize->12],

Cell[StyleData["SubObjectName", "Printout"],
  CellMargins->{{2, 0}, {1, 10}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontFamily->"Courier",
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GroupObjectName"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 14}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->18,
  FontWeight->"Bold"],

Cell[StyleData["GroupObjectName", "Presentation"],
  FontSize->24],

Cell[StyleData["GroupObjectName", "SlideShow"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{72, 10}, {2, 12}},
  CellGroupingRules->{"SectionGrouping", 70},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphIndent->-27,
  CounterIncrements->"Outline2",
  FontFamily->"Courier",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["GroupObjectName", "Printout"],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GroupObjectNameClosed"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 14}},
  PrivateCellOptions->{"DefaultCellGroupOpen"->False},
  CellGroupingRules->{"SectionGrouping", 80},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->18,
  FontWeight->"Bold"],

Cell[StyleData["GroupObjectNameClosed", "Presentation"],
  FontSize->24],

Cell[StyleData["GroupObjectNameClosed", "SlideShow"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{72, 10}, {2, 12}},
  CellGroupingRules->{"SectionGrouping", 70},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphIndent->-27,
  CounterIncrements->"Outline2",
  FontFamily->"Courier",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["GroupObjectNameClosed", "Printout"],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ObjectNameWarningMessages"],
  CellMargins->{{27, 4}, {1, 10}},
  CellGroupingRules->{"SectionGrouping", 65},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->18,
  FontWeight->"Bold"],

Cell[StyleData["ObjectNameWarningMessages", "Presentation"],
  FontSize->24],

Cell[StyleData["ObjectNameWarningMessages", "SlideShow"],
  CellMargins->{{10, 4}, {1, 10}},
  CellGroupingRules->{"SectionGrouping", 65},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontFamily->"Courier",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["ObjectNameWarningMessages", "Printout"],
  CellMargins->{{2, 0}, {1, 10}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Command"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{0, 0}, {0, 0}},
  CellFrameMargins->{{27, 12}, {3, 15}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  CounterIncrements->"Section",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->18,
  FontWeight->"Bold",
  Background->RGBColor[0.960784, 0.878431, 0.666667]],

Cell[StyleData["Command", "Presentation"],
  FontSize->24],

Cell[StyleData["Command", "Printout"],
  CellMargins->{{0, 0}, {0, 14}},
  PageBreakBelow->False,
  CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CharacterName"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{0, 0}, {0, 0}},
  CellFrameMargins->{{27, 27}, {8, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216]],

Cell[StyleData["CharacterName", "Presentation"],
  FontSize->18],

Cell[StyleData["CharacterName", "SlideShow"],
  CellMargins->{{72, 4}, {1, 14}},
  CellGroupingRules->{"SectionGrouping", 90},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["CharacterName", "Printout"],
  CellMargins->{{2, 0}, {0, 4}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Usage"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{0, 0}, {0, 0}},
  CellFrameMargins->{{27, 27}, {8, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  Hyphenation->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 6},
  ParagraphIndent->-10,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216]],

Cell[StyleData["Usage", "Presentation"],
  FontSize->18],

Cell[StyleData["Usage", "SlideShow"],
  CellFrame->{{0, 0}, {0.5, 0.5}},
  CellMargins->{{72, 4}, {0, 4}},
  CellFrameMargins->5,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 6},
  ParagraphIndent->-10,
  StyleMenuListing->None],

Cell[StyleData["Usage", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ErrorMessage"],
  CellFrame->{{0, 0}, {0.5, 0.5}},
  ShowCellBracket->True,
  CellMargins->{{27, 4}, {0, 4}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
  CellFrameMargins->5,
  DefaultFormatType->DefaultOutputFormatType,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FormatType->InputForm,
  StyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["ErrorMessage", "Presentation"],
  FontSize->18],

Cell[StyleData["ErrorMessage", "SlideShow"],
  CellMargins->{{72, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None],

Cell[StyleData["ErrorMessage", "Printout"],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Notes"],
  CellMargins->{{27, 27}, {0, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 6},
  ParagraphIndent->-10,
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Notes", "Presentation"],
  FontSize->18],

Cell[StyleData["Notes", "SlideShow"],
  CellMargins->{{72, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 6},
  ParagraphIndent->-10,
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Notes", "Printout"],
  CellMargins->{{24, 0}, {0, 8}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NotesList"],
  CellMargins->{{20, 4}, {2, 8}},
  CellHorizontalScrolling->True,
  ScriptLevel->1,
  SingleLetterItalics->True,
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["NotesList", "Presentation"],
  FontSize->18],

Cell[StyleData["NotesList", "SlideShow"],
  CellMargins->{{82, 4}, {2, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ScriptLevel->1,
  SingleLetterItalics->True,
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["NotesList", "Printout"],
  CellMargins->{{12, 0}, {2, 8}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSection"],
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 10}},
  CellGroupingRules->{"SectionGrouping", 30},
  CellFrameMargins->12,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold"],

Cell[StyleData["ReferenceSection", "Presentation"],
  FontSize->20],

Cell[StyleData["ReferenceSection", "Printout"],
  CellMargins->{{3, 0}, {0, 10}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Reference"],
  CellMargins->{{27, 27}, {0, 8}},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  ParagraphSpacing->{0, 8},
  CounterIncrements->"Reference",
  FontSize->12],

Cell[StyleData["Reference", "Presentation"],
  FontSize->18],

Cell[StyleData["Reference", "SlideShow"],
  CellMargins->{{27, 27}, {4, 4}},
  Hyphenation->False,
  FontSize->14],

Cell[StyleData["Reference", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["Reference", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["Reference", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleSection"],
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 10}},
  CellGroupingRules->{"SectionGrouping", 70},
  CellFrameMargins->12,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold"],

Cell[StyleData["ExampleSection", "Presentation"],
  FontSize->20],

Cell[StyleData["ExampleSection", "Printout"],
  CellMargins->{{3, 0}, {0, 10}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleText"],
  CellMargins->{{27, 40}, {0, 18}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 6},
  StyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.4]],

Cell[StyleData["ExampleText", "Presentation"],
  FontSize->18],

Cell[StyleData["ExampleText", "Printout"],
  CellMargins->{{2, 80}, {0, 8}},
  PageBreakBelow->False,
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->8,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleSubsection"],
  ShowCellBracket->True,
  CellMargins->{{27, 4}, {0, 16}},
  CellGroupingRules->{"SectionGrouping", 80},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Bold"],

Cell[StyleData["ExampleSubsection", "Presentation"],
  FontSize->15],

Cell[StyleData["ExampleSubsection", "Printout"],
  CellMargins->{{12, 0}, {0, 16}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MessagesSection"],
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{27, 4}, {0, 10}},
  CellGroupingRules->{"SectionGrouping", 70},
  CellFrameMargins->12,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold"],

Cell[StyleData["MessagesSection", "Presentation"],
  FontSize->20],

Cell[StyleData["MessagesSection", "Printout"],
  CellMargins->{{3, 0}, {0, 10}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TemplateSection"],
  CellFrame->{{0, 0}, {0, 0.5}},
  CellMargins->{{27, 4}, {0, 10}},
  PrivateCellOptions->{"DefaultCellGroupOpen"->True},
  CellGroupingRules->{"SectionGrouping", 70},
  CellFrameMargins->12,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold"],

Cell[StyleData["TemplateSection", "Presentation"],
  FontSize->20],

Cell[StyleData["TemplateSection", "Printout"],
  CellMargins->{{3, 0}, {0, 10}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LineHead"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{27, 4}, {8, 18}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["LineHead", "Presentation"],
  FontSize->18],

Cell[StyleData["LineHead", "Printout"],
  CellMargins->{{2, 0}, {8, 18}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FlushInput"],
  CellMargins->{{27, 4}, {1, 4}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellLabelAutoDelete->False,
  CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultInputFormatType,
  ShowSpecialCharacters->Automatic,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FormatType->StandardForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["FlushInput", "Presentation"],
  FontSize->18],

Cell[StyleData["FlushInput", "Printout"],
  CellMargins->{{2, 0}, {1, 4}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FlushOutput"],
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  CellEditDuplicate->True,
  CellGroupingRules->"OutputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  CellLabelAutoDelete->False,
  CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultOutputFormatType,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FormatType->StandardForm,
  StyleMenuListing->None],

Cell[StyleData["FlushOutput", "Presentation"],
  FontSize->18],

Cell[StyleData["FlushOutput", "Printout"],
  CellMargins->{{2, Inherited}, {Inherited, Inherited}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DialogItem"],
  CellDingbat->"\[EmptyDiamond]",
  CellMargins->{{27, 4}, {0, 12}},
  CellGroupingRules->{"SectionGrouping", 70},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Bold"],

Cell[StyleData["DialogItem", "Presentation"],
  FontSize->15],

Cell[StyleData["DialogItem", "Printout"],
  CellMargins->{{12, 0}, {0, 12}},
  PageBreakBelow->False,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GroupDivider"],
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  CellEditDuplicate->True,
  CellGroupingRules->{"TitleGrouping", 0},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None],

Cell[StyleData["GroupDivider", "Presentation"],
  FontSize->18]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Highlight"],
  CellFrame->0.5,
  CellMargins->{{27, 4}, {0, 18}},
  CellFrameColor->GrayLevel[0.800015],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  Background->GrayLevel[0.950011]],

Cell[StyleData["Highlight", "Presentation"],
  FontSize->18],

Cell[StyleData["Highlight", "Printout"],
  CellMargins->{{2, 0}, {0, 18}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 3},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserNotes"],
  CellFrame->{{3, 0}, {0, 0}},
  CellMargins->{{27, 4}, {0, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  ParagraphIndent->-7,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10],

Cell[StyleData["UserNotes", "Presentation"],
  FontSize->15],

Cell[StyleData["UserNotes", "Printout"],
  CellMargins->{{2, 0}, {0, 4}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 3},
  FontSize->8],

Cell[StyleData["UserNotes", "EnhancedPrintout"],
  CellMargins->{{0, 0}, {0, 4}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  FontFamily->"Frutiger-Roman",
  FontSize->8],

Cell[StyleData["UserNotes", "EnhancedPrintoutNonGray"],
  CellMargins->{{0, 0}, {0, 4}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  FontFamily->"Frutiger-Roman",
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MoreInfo"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  ParagraphIndent->-7,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  Background->RGBColor[0.964706, 0.929412, 0.839216]],

Cell[StyleData["MoreInfo", "Presentation"],
  FontSize->15],

Cell[StyleData["MoreInfo", "Printout"],
  CellMargins->{{2, 0}, {0, 4}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 3},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserTips"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {0, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  ParagraphIndent->-7,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  Background->RGBColor[0.964706, 0.929412, 0.839216]],

Cell[StyleData["UserTips", "Presentation"],
  FontSize->15],

Cell[StyleData["UserTips", "Printout"],
  CellMargins->{{2, 0}, {0, 4}},
  CellFrameColor->GrayLevel[0.800015],
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 3},
  FontSize->8,
  Background->GrayLevel[0.900008]],

Cell[StyleData["UserTips", "EnhancedPrintout"],
  CellMargins->{{0, 0}, {0, 4}},
  CellFrameColor->GrayLevel[0],
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 3},
  FontFamily->"Frutiger-Roman",
  FontSize->8,
  Background->GrayLevel[0.700008]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Theorem"],
  CellFrame->{{4, 0}, {0, 0}},
  CellMargins->{{27, 62}, {0, 14}},
  CellFrameMargins->4,
  CellFrameColor->RGBColor[0, 0, 0.8],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  LineSpacing->{1, 1},
  ParagraphSpacing->{0, 8}],

Cell[StyleData["Theorem", "Presentation"],
  FontSize->18],

Cell[StyleData["Theorem", "Printout"],
  CellMargins->{{2, 0}, {0, 14}},
  CellFrameMargins->3,
  CellFrameColor->GrayLevel[0.8],
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->9,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Commentary"],
  CellFrame->{{2, 0}, {0, 0}},
  CellMargins->{{36, 10}, {7, 7}},
  PageBreakBelow->False,
  CellFrameMargins->8,
  CellFrameColor->RGBColor[0, 0.2, 1],
  LineSpacing->{1, 3},
  FontSlant->"Italic"],

Cell[StyleData["Commentary", "Presentation"],
  FontSize->18],

Cell[StyleData["Commentary", "Printout"],
  CellMargins->{{36, 0}, {6, 6}},
  CellFrameColor->GrayLevel[0.8],
  FontSize->10],

Cell[StyleData["Commentary", "EnhancedPrintout"],
  CellMargins->{{36, 0}, {6, 6}},
  CellFrameColor->GrayLevel[0.8],
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["Commentary", "EnhancedPrintoutNonGray"],
  CellMargins->{{36, 0}, {6, 6}},
  CellFrameColor->GrayLevel[0.8],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Level1Icon"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{48, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 8},
  StyleMenuListing->None],

Cell[StyleData["Level1Icon", "Presentation"],
  FontSize->18],

Cell[StyleData["Level1Icon", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Level2Icon"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{48, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  ParagraphSpacing->{0, 8},
  StyleMenuListing->None],

Cell[StyleData["Level2Icon", "Presentation"],
  FontSize->18],

Cell[StyleData["Level2Icon", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  HyphenationOptions->{"HyphenationCharacter"->"-"},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CopyrightHead"],
  CellMargins->{{27, 4}, {0, 8}},
  PageBreakAbove->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["CopyrightHead", "Presentation"],
  FontSize->18],

Cell[StyleData["CopyrightHead", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Copyright"],
  CellMargins->{{27, 4}, {0, 8}},
  PageBreakAbove->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10],

Cell[StyleData["Copyright", "Presentation"],
  FontSize->15],

Cell[StyleData["Copyright", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->8],

Cell[StyleData["Copyright", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Frutiger-Roman",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RegisterSubsection"],
  CellDingbat->None,
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 45},
  CellFrameLabelMargins->6,
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  FontFamily->"Helvetica",
  FontSize->16],

Cell[StyleData["RegisterSubsection", "Presentation"],
  FontSize->24],

Cell[StyleData["RegisterSubsection", "SlideShow"],
  CellDingbat->None,
  CellMargins->{{70, 0}, {4, 12}},
  FontSize->12],

Cell[StyleData["RegisterSubsection", "Printout"],
  CellMargins->{{9, 0}, {5, 24}},
  FontSize->12],

Cell[StyleData["RegisterSubsection", "EnhancedPrintout"],
  CellMargins->{{9, 0}, {5, 20}},
  FontFamily->"Frutiger-Roman",
  FontSize->12],

Cell[StyleData["RegisterSubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{9, 0}, {5, 20}},
  FontFamily->"Frutiger-Roman",
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RegisterSubsubsection"],
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 50},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["RegisterSubsubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["RegisterSubsubsection", "Printout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontSize->10],

Cell[StyleData["RegisterSubsubsection", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["RegisterSubsubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RegisterText"],
  CellMargins->{{27, 4}, {0, 8}},
  PageBreakAbove->False,
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["RegisterText", "Presentation"],
  FontSize->15],

Cell[StyleData["RegisterText", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->8],

Cell[StyleData["RegisterText", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Palatino",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaptionHead"],
  CellMargins->{{27, 4}, {0, 8}},
  PageBreakAbove->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["CaptionHead", "Presentation"],
  FontSize->15],

Cell[StyleData["CaptionHead", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->8],

Cell[StyleData["CaptionHead", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Palatino",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaptionText"],
  CellMargins->{{66, 4}, {0, 8}},
  PageBreakAbove->False,
  StyleMenuListing->None],

Cell[StyleData["CaptionText", "Presentation"],
  FontSize->15],

Cell[StyleData["CaptionText", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->8],

Cell[StyleData["CaptionText", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Palatino",
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BulletText"],
  CellMargins->{{76, 4}, {4, 4}},
  CellFrameLabels->{{
    Cell[ "\[Bullet]", "BulletText", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  Hyphenation->False,
  LineSpacing->{1, 3},
  CounterIncrements->"BulletText",
  StyleMenuListing->None],

Cell[StyleData["BulletText", "Presentation"],
  FontSize->18],

Cell[StyleData["BulletText", "Printout"],
  FontSize->10],

Cell[StyleData["BulletText", "EnhancedPrintout"],
  CellMargins->{{16, 4}, {2, 4}},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["BulletText", "EnhancedPrintoutNonGray"],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["HelpLabels"],
  CellMargins->{{88, 4}, {0, 8}},
  StyleMenuListing->None],

Cell[StyleData["HelpLabels", "Presentation"],
  FontSize->15],

Cell[StyleData["HelpLabels", "Printout"],
  CellMargins->{{34, 2}, {6, 6}},
  FontSize->10],

Cell[StyleData["HelpLabels", "EnhancedPrintout"],
  CellMargins->{{34, 2}, {6, 6}},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Manual.nb Merge", "Subsection"],

Cell[CellGroupData[{

Cell["Function List", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["FunctionName"],
  CellDingbat->"\[FilledSquare]",
  CellMargins->{{24, 10}, {10, 12}},
  CellGroupingRules->{"SectionGrouping", 40},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->14,
  FontWeight->"Bold",
  CellTags->"FunctionName"],

Cell[StyleData["FunctionName", "Presentation"],
  FontSize->21],

Cell[StyleData["FunctionName", "Printout"],
  CellMargins->{{9, 0}, {10, 10}},
  FontSize->12],

Cell[StyleData["FunctionName", "EnhancedPrintout"],
  CellMargins->{{9, 0}, {10, 10}},
  FontFamily->"Courier",
  FontSize->12],

Cell[StyleData["FunctionName", "EnhancedPrintoutNonGray"],
  CellMargins->{{9, 0}, {10, 10}},
  FontFamily->"Courier",
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionSubsection"],
  CellDingbat->"\[FilledSquare]",
  CellMargins->{{36, 10}, {0, 6}},
  CellGroupingRules->{"SectionGrouping", 60},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontWeight->"Bold",
  CellTags->"FunctionSubsection"],

Cell[StyleData["FunctionSubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionSubsection", "Printout"],
  CellMargins->{{30, 0}, {0, 6}}],

Cell[StyleData["FunctionSubsection", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {0, 6}},
  FontFamily->"Palatino",
  FontSize->11],

Cell[StyleData["FunctionSubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {0, 6}},
  FontFamily->"Palatino",
  FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionDescription"],
  CellMargins->{{36, 10}, {4, 0}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0.7, 0},
  CounterIncrements->"FunctionDescription",
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["FunctionDescription", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionDescription", "Printout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontSize->11],

Cell[StyleData["FunctionDescription", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["FunctionDescription", "EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionDescriptionRuled"],
  CellFrame->{{0, 0}, {0.25, 0.25}},
  CellMargins->{{36, 10}, {4, 0}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0.7, 0},
  CounterIncrements->"FunctionDescriptionRuled",
  StyleMenuListing->None],

Cell[StyleData["FunctionDescriptionRuled", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionDescriptionRuled", "Printout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontSize->11],

Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionDescriptionRuleTop"],
  CellFrame->{{0, 0}, {0, 0.25}},
  CellMargins->{{36, 10}, {4, 0}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0.7, 0},
  CounterIncrements->"FunctionDescriptionRuleTop",
  StyleMenuListing->None],

Cell[StyleData["FunctionDescriptionRuleTop", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionDescriptionRuleTop", "Printout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontSize->11],

Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["FunctionDescriptionRuleTop", \
"EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionDescriptionRuleBottom"],
  CellFrame->{{0, 0}, {0.25, 0}},
  CellMargins->{{36, 10}, {4, 0}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0.7, 0},
  CounterIncrements->"FunctionDescriptionRuleBottom",
  StyleMenuListing->None],

Cell[StyleData["FunctionDescriptionRuleBottom", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionDescriptionRuleBottom", "Printout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontSize->11],

Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["FunctionDescriptionRuleBottom", \
"EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {4, 0}},
  TextJustification->0,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionExample"],
  CellMargins->{{36, 10}, {4, 0}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["FunctionExample", "Presentation"],
  FontSize->15],

Cell[StyleData["FunctionExample", "Printout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontSize->9],

Cell[StyleData["FunctionExample", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {4, 0}},
  FontFamily->"Palatino",
  FontSize->9],

Cell[StyleData["FunctionExample", "EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {4, 0}},
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FunctionTextNote"],
  CellMargins->{{36, 4}, {0, 4}},
  LineSpacing->{1, 3},
  ParagraphSpacing->{0, 4},
  LineIndent->0,
  StyleMenuListing->None],

Cell[StyleData["FunctionTextNote", "Presentation"],
  FontSize->18],

Cell[StyleData["FunctionTextNote", "Printout"],
  CellMargins->{{36, 4}, {0, 4}},
  FontSize->9],

Cell[StyleData["FunctionTextNote", "EnhancedPrintout"],
  CellMargins->{{36, 4}, {0, 4}},
  FontFamily->"Palatino",
  FontSize->8],

Cell[StyleData["FunctionTextNote", "EnhancedPrintoutNonGray"],
  CellMargins->{{36, 4}, {0, 4}},
  FontFamily->"Palatino",
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["3ColumnFunctionTable"],
  CellMargins->{{36, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->{0.28, 0.28, 0.43},
  ColumnAlignments->{Left}}],

Cell[StyleData["3ColumnFunctionTable", "Presentation"],
  FontSize->18],

Cell[StyleData["3ColumnFunctionTable", "Printout"],
  CellMargins->{{30, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintout"],
  CellMargins->{{30, 0}, {0, 8}},
  FontSize->10],

Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{30, 0}, {0, 8}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Browser Emulation", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TextNormal"],
  CellMargins->{{12, 10}, {7, 7}},
  LineSpacing->{1, 3},
  CounterIncrements->"TextNormal",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["TextNormal", "Presentation"],
  FontSize->18],

Cell[StyleData["TextNormal", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BrowserEmulation"],
  CellMargins->{{12, 1}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 70},
  LineSpacing->{1, 3},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  GridBoxOptions->{ColumnWidths->0.25,
  ColumnAlignments->{Left},
  GridFrame->True,
  GridFrameMargins->0.5,
  ColumnLines->True}],

Cell[StyleData["BrowserEmulation", "Presentation"],
  FontSize->18],

Cell[StyleData["BrowserEmulation", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CategoryDefs"],
  CellMargins->{{300, 10}, {7, 7}},
  LineSpacing->{1, 3},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  Background->RGBColor[1, 0.8, 0.6],
  GridBoxOptions->{ColumnAlignments->{Left},
  GridFrame->False,
  RowLines->True,
  ColumnLines->True}],

Cell[StyleData["CategoryDefs", "Presentation"],
  FontSize->18],

Cell[StyleData["CategoryDefs", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Category1"],
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{12, 10}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 50},
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["Category1", "Presentation"],
  FontSize->24],

Cell[StyleData["Category1", "Printout"],
  CellMargins->{{2, 2}, {6, 6}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Category2"],
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{85, 10}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 60},
  StyleMenuListing->None,
  FontSize->14,
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Category2", "Presentation"],
  FontSize->21],

Cell[StyleData["Category2", "Printout"],
  CellMargins->{{2, 2}, {6, 6}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Category3"],
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{157, 10}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 70},
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0.2, 0, 0.4]],

Cell[StyleData["Category3", "Presentation"],
  FontSize->18],

Cell[StyleData["Category3", "Printout"],
  CellMargins->{{2, 2}, {6, 6}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Category4"],
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{230, 10}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 80},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0.300008, 0.4]],

Cell[StyleData["Category4", "Presentation"],
  FontSize->18],

Cell[StyleData["Category4", "Printout"],
  CellMargins->{{2, 2}, {6, 6}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Misc", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["4ColumnTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->0.25,
  ColumnAlignments->{Left, Center}}],

Cell[StyleData["4ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["4ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["4ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["4ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["5ColumnTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->0.2,
  ColumnAlignments->{Left, Center}}],

Cell[StyleData["5ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["5ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["5ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["5ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["6ColumnTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->0.16,
  ColumnAlignments->{Left, Center}}],

Cell[StyleData["6ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["6ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["6ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["6ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["7ColumnTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->0.14,
  ColumnAlignments->{Left, Center}}],

Cell[StyleData["7ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["7ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["7ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["7ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["8ColumnTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnWidths->0.12,
  ColumnAlignments->{Left, Center}}],

Cell[StyleData["8ColumnTable", "Presentation"],
  FontSize->18],

Cell[StyleData["8ColumnTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["8ColumnTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["8ColumnTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ABItemizedText"],
  CellMargins->{{20, 4}, {0, 5}},
  LineSpacing->{1, 3},
  ParagraphIndent->-21,
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],

Cell[StyleData["ABItemizedText", "Presentation"],
  FontSize->18],

Cell[StyleData["ABItemizedText", "Printout"],
  Hyphenation->True,
  ParagraphIndent->-21,
  FontSize->11],

Cell[StyleData["ABItemizedText", "EnhancedPrintout"],
  Hyphenation->True,
  ParagraphIndent->-21,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ABItemizedText", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  ParagraphIndent->-21,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapNumber"],
  CellMargins->{{27, Inherited}, {20, 40}},
  CellGroupingRules->{"TitleGrouping", 0},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->42,
  FontWeight->"Plain",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["ChapNumber", "Presentation"],
  FontSize->63],

Cell[StyleData["ChapNumber", "Printout"],
  CellMargins->{{2, 10}, {15, 30}},
  FontSize->36],

Cell[StyleData["ChapNumber", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {15, 30}},
  FontFamily->"Frutiger-Roman",
  FontSize->36,
  FontColor->GrayLevel[0]],

Cell[StyleData["ChapNumber", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {15, 30}},
  FontFamily->"Frutiger-Roman",
  FontSize->36,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ChapTitle"],
  CellMargins->{{27, Inherited}, {80, 10}},
  CellGroupingRules->{"TitleGrouping", 0},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->36,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["ChapTitle", "Presentation"],
  FontSize->54],

Cell[StyleData["ChapTitle", "Printout"],
  CellMargins->{{2, 10}, {80, 6}},
  FontSize->30],

Cell[StyleData["ChapTitle", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {80, 6}},
  FontFamily->"Frutiger-Bold",
  FontSize->30,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["ChapTitle", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {80, 6}},
  FontFamily->"Frutiger-Bold",
  FontSize->30,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemDingbat"],
  CellSize->{22, 14},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["ItemDingbat", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemDingbat", "Printout"],
  CellSize->{22, 13.125}],

Cell[StyleData["ItemDingbat", "EnhancedPrintout"],
  CellSize->{22, 11}],

Cell[StyleData["ItemDingbat", "EnhancedPrintoutNonGray"],
  CellSize->{22, 11}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1"],
  CellMargins->{{19, 4}, {4, 4}},
  ParagraphIndent->-22,
  CounterIncrements->"Item1",
  StyleMenuListing->None],

Cell[StyleData["Item1", "Presentation"],
  FontSize->18],

Cell[StyleData["Item1", "Printout"],
  CellMargins->{{12, 0}, {2, 4}},
  FontSize->10],

Cell[StyleData["Item1", "EnhancedPrintout"],
  CellMargins->{{16, 0}, {2, 4}},
  FontSize->10],

Cell[StyleData["Item1", "EnhancedPrintoutNonGray"],
  CellMargins->{{16, 0}, {2, 4}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1Continued"],
  CellMargins->{{41, 4}, {4, 1}},
  CounterIncrements->"Item1Continued",
  StyleMenuListing->None],

Cell[StyleData["Item1Continued", "Presentation"],
  FontSize->18],

Cell[StyleData["Item1Continued", "Printout"],
  CellMargins->{{34, 0}, {4, 1}},
  FontSize->10],

Cell[StyleData["Item1Continued", "EnhancedPrintout"],
  CellMargins->{{39, 0}, {4, 1}},
  FontSize->10],

Cell[StyleData["Item1Continued", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 0}, {4, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2"],
  CellMargins->{{32, 4}, {4, 4}},
  ParagraphIndent->-22,
  CounterIncrements->"Item2",
  StyleMenuListing->None],

Cell[StyleData["Item2", "Presentation"],
  FontSize->18],

Cell[StyleData["Item2", "Printout"],
  CellMargins->{{26, 0}, {4, 4}},
  ParagraphIndent->-22,
  FontSize->10],

Cell[StyleData["Item2", "EnhancedPrintout"],
  CellMargins->{{29, 0}, {2, 4}},
  ParagraphIndent->-22,
  FontSize->10],

Cell[StyleData["Item2", "EnhancedPrintoutNonGray"],
  CellMargins->{{29, 0}, {2, 4}},
  ParagraphIndent->-22,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Continued"],
  CellMargins->{{54, 4}, {4, 1}},
  CounterIncrements->"Item2Continued",
  StyleMenuListing->None],

Cell[StyleData["Item2Continued", "Presentation"],
  FontSize->18],

Cell[StyleData["Item2Continued", "Printout"],
  CellMargins->{{27, 0}, {4, 1}}],

Cell[StyleData["Item2Continued", "EnhancedPrintout"],
  CellMargins->{{52, 0}, {4, 1}},
  FontSize->10],

Cell[StyleData["Item2Continued", "EnhancedPrintoutNonGray"],
  CellMargins->{{52, 0}, {4, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3"],
  CellMargins->{{45, 4}, {4, 4}},
  ParagraphIndent->-23,
  CounterIncrements->"Item3",
  StyleMenuListing->None],

Cell[StyleData["Item3", "Presentation"],
  FontSize->18],

Cell[StyleData["Item3", "Printout"],
  CellMargins->{{27, 0}, {2, 4}}],

Cell[StyleData["Item3", "EnhancedPrintout"],
  CellMargins->{{42, 0}, {2, 4}},
  FontSize->10],

Cell[StyleData["Item3", "EnhancedPrintoutNonGray"],
  CellMargins->{{42, 0}, {2, 4}},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Continued"],
  CellMargins->{{67, 4}, {4, 1}},
  CounterIncrements->"Item3Continued",
  StyleMenuListing->None],

Cell[StyleData["Item3Continued", "Presentation"],
  FontSize->18],

Cell[StyleData["Item3Continued", "Printout"],
  CellMargins->{{27, 0}, {4, 1}}],

Cell[StyleData["Item3Continued", "EnhancedPrintout"],
  CellMargins->{{65, 0}, {4, 1}},
  FontSize->10],

Cell[StyleData["Item3Continued", "EnhancedPrintoutNonGray"],
  CellMargins->{{65, 0}, {4, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedBulletText"],
  CellMargins->{{19, 4}, {0, 5}},
  LineSpacing->{1, 3},
  ParagraphIndent->-22,
  CounterIncrements->"ItemizedBulletText",
  StyleMenuListing->None],

Cell[StyleData["ItemizedBulletText", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedBulletText", "Printout"],
  Hyphenation->True,
  ParagraphIndent->-20,
  FontSize->11],

Cell[StyleData["ItemizedBulletText", "EnhancedPrintout"],
  Hyphenation->True,
  ParagraphIndent->-19,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedBulletText", "EnhancedPrintoutNonGray"],
  Hyphenation->True,
  ParagraphIndent->-19,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NoteBox"],
  CellFrame->0.5,
  CellMargins->{{27, 12}, {8, 8}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
  GridBoxOptions->{ColumnSpacings->1}],

Cell[StyleData["NoteBox", "Presentation"],
  FontSize->18],

Cell[StyleData["NoteBox", "Printout"],
  CellMargins->{{2, 4}, {6, 2}},
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["NoteBox", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["NoteBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 4}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedNoteBox"],
  CellFrame->0.5,
  CellMargins->{{41, 4}, {8, 2}},
  CellHorizontalScrolling->True,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
  GridBoxOptions->{ColumnSpacings->1}],

Cell[StyleData["ItemizedNoteBox", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedNoteBox", "Printout"],
  CellMargins->{{39, 4}, {6, 2}},
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedNoteBox", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedNoteBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 4}, {6, 2}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedTopBox"],
  CellFrame->{{0.5, 0.5}, {0, 0.5}},
  CellMargins->{{37, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  CellFrameMargins->{{8, 8}, {0, 8}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["ItemizedTopBox", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedTopBox", "Printout"],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedTopBox", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {0, 6}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedTopBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 4}, {0, 6}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedBottomBox"],
  CellFrame->{{0.5, 0.5}, {0.5, 0}},
  CellMargins->{{37, 4}, {4, 0}},
  CellHorizontalScrolling->True,
  CellFrameMargins->{{8, 8}, {8, 0}},
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  LineIndent->0,
  StyleMenuListing->None,
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["ItemizedBottomBox", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedBottomBox", "Printout"],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedBottomBox", "EnhancedPrintout"],
  CellMargins->{{39, 4}, {6, 0}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[0.900008]],

Cell[StyleData["ItemizedBottomBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{39, 4}, {6, 0}},
  CellFrameColor->GrayLevel[0],
  FontSize->10,
  Background->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MiddleSpacedBox"],
  CellFrame->{{0.5, 0.5}, {0, 0}},
  CellMargins->{{27, 12}, {0, -7}},
  CellHorizontalScrolling->True,
  PageBreakAbove->False,
  PageBreakBelow->False,
  CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  FontWeight->"Plain",
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->1,
  ColumnWidths->{0.31, 0.62},
  ColumnAlignments->{Left}}],

Cell[StyleData["MiddleSpacedBox", "Presentation"],
  FontSize->18],

Cell[StyleData["MiddleSpacedBox", "Printout"],
  CellMargins->{{2, 0}, {0, 0}},
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}],

Cell[StyleData["MiddleSpacedBox", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 0}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}],

Cell[StyleData["MiddleSpacedBox", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 0}},
  CellFrameColor->GrayLevel[0],
  FontFamily->"Palatino",
  Background->GrayLevel[1],
  GridBoxOptions->{RowMinHeight->1.8}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedNote"],
  CellMargins->{{41, 4}, {0, 12}},
  LineSpacing->{1, 2},
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],

Cell[StyleData["ItemizedNote", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedNote", "Printout"],
  CellMargins->{{38, 4}, {0, 9}},
  Hyphenation->True,
  FontSize->11],

Cell[StyleData["ItemizedNote", "EnhancedPrintout"],
  CellMargins->{{38, 4}, {0, 0}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedNote", "EnhancedPrintoutNonGray"],
  CellMargins->{{38, 4}, {0, 0}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedNoteBelow"],
  CellMargins->{{41, 4}, {0, 8}},
  LineSpacing->{1, 2},
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],

Cell[StyleData["ItemizedNoteBelow", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedNoteBelow", "Printout"],
  CellMargins->{{38, 4}, {0, 12}},
  Hyphenation->True,
  FontSize->11],

Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintout"],
  CellMargins->{{38, 4}, {0, 8}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintoutNonGray"],
  CellMargins->{{38, 4}, {0, 8}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedTextBelowPic"],
  CellMargins->{{19, 4}, {0, 8}},
  LineSpacing->{1, 3},
  ParagraphIndent->-22,
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],

Cell[StyleData["ItemizedTextBelowPic", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedTextBelowPic", "Printout"],
  CellMargins->{{20, 4}, {2, 12}},
  Hyphenation->True,
  ParagraphIndent->-18,
  FontSize->11],

Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintout"],
  CellMargins->{{20, 4}, {2, 12}},
  Hyphenation->True,
  ParagraphIndent->-17,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintoutNonGray"],
  CellMargins->{{20, 4}, {2, 12}},
  Hyphenation->True,
  ParagraphIndent->-17,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemizedTextNote2"],
  CellMargins->{{41, 4}, {0, 4}},
  LineSpacing->{1, 2},
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],

Cell[StyleData["ItemizedTextNote2", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemizedTextNote2", "Printout"],
  CellMargins->{{38, 4}, {0, 2}},
  Hyphenation->True,
  FontSize->11],

Cell[StyleData["ItemizedTextNote2", "EnhancedPrintout"],
  CellMargins->{{38, 4}, {0, 2}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["ItemizedTextNote2", "EnhancedPrintoutNonGray"],
  CellMargins->{{38, 4}, {0, 2}},
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedItem1"],
  CellMargins->{{48, 4}, {4, 4}},
  CellGroupingRules->{"SectionGrouping", 15},
  ParagraphIndent->-23,
  CounterIncrements->"NumberedItem1",
  StyleMenuListing->None],

Cell[StyleData["NumberedItem1", "Presentation"],
  FontSize->18],

Cell[StyleData["NumberedItem1", "Printout"],
  CellMargins->{{12, 0}, {0, 8}}],

Cell[StyleData["NumberedItem1", "EnhancedPrintout"],
  CellMargins->{{12, 0}, {0, 8}}],

Cell[StyleData["NumberedItem1", "EnhancedPrintoutNonGray"],
  CellMargins->{{12, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedItem2"],
  CellMargins->{{71, 4}, {3, 3}},
  CellGroupingRules->{"SectionGrouping", 15},
  ParagraphIndent->-21,
  CounterIncrements->"NumberedItem2",
  StyleMenuListing->None],

Cell[StyleData["NumberedItem2", "Presentation"],
  FontSize->18],

Cell[StyleData["NumberedItem2", "Printout"],
  CellMargins->{{27, 0}, {0, 4}}],

Cell[StyleData["NumberedItem2", "EnhancedPrintout"],
  CellMargins->{{27, 0}, {0, 4}}],

Cell[StyleData["NumberedItem2", "EnhancedPrintoutNonGray"],
  CellMargins->{{27, 0}, {0, 4}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NumberedItem3"],
  CellMargins->{{94, 4}, {2, 2}},
  CellGroupingRules->{"SectionGrouping", 15},
  ParagraphIndent->-23,
  CounterIncrements->"NumberedItem3",
  StyleMenuListing->None],

Cell[StyleData["NumberedItem3", "Presentation"],
  FontSize->18],

Cell[StyleData["NumberedItem3", "Printout"],
  CellMargins->{{27, 0}, {0, 4}}],

Cell[StyleData["NumberedItem3", "EnhancedPrintout"],
  CellMargins->{{27, 0}, {0, 4}}],

Cell[StyleData["NumberedItem3", "EnhancedPrintoutNonGray"],
  CellMargins->{{27, 0}, {0, 4}},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageHeaderBold"],
  CellMargins->{{0, 0}, {2, 0}},
  StyleMenuListing->None,
  FontSize->8,
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["PageHeaderBold", "Printout"]],

Cell[StyleData["PageHeaderBold", "EnhancedPrintout"],
  FontFamily->"Frutiger-BoldItalic",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["PageHeaderBold", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-BoldItalic",
  FontWeight->"Plain",
  FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SingleRowTable"],
  CellMargins->{{10, 4}, {0, 8}},
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  AutoIndent->False,
  AutoSpacing->False,
  LineIndent->0,
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->1.5,
  ColumnSpacings->2,
  ColumnAlignments->{Left}}],

Cell[StyleData["SingleRowTable", "Presentation"],
  FontSize->18],

Cell[StyleData["SingleRowTable", "Printout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["SingleRowTable", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}}],

Cell[StyleData["SingleRowTable", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {0, 8}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
  CellMargins->{{27, 4}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["Subsubsubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["Subsubsubsection", "Printout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontSize->10],

Cell[StyleData["Subsubsubsection", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["Subsubsubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {3, 8}},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
  CellMargins->{{27, Inherited}, {20, 15}},
  CellGroupingRules->{"TitleGrouping", 20},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Subsubtitle",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontSlant->"Italic"],

Cell[StyleData["Subsubtitle", "Presentation"],
  FontSize->21],

Cell[StyleData["Subsubtitle", "Printout"],
  CellMargins->{{2, 10}, {8, 10}},
  FontSize->12],

Cell[StyleData["Subsubtitle", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {8, 10}},
  FontFamily->"Frutiger-Roman",
  FontSize->12],

Cell[StyleData["Subsubtitle", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {8, 10}},
  FontFamily->"Frutiger-Roman",
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
  CellMargins->{{27, Inherited}, {20, 15}},
  CellGroupingRules->{"TitleGrouping", 10},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Subtitle",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24],

Cell[StyleData["Subtitle", "Presentation"],
  FontSize->36],

Cell[StyleData["Subtitle", "Printout"],
  CellMargins->{{2, 10}, {10, 15}},
  FontSize->24],

Cell[StyleData["Subtitle", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {10, 15}},
  FontFamily->"Frutiger-Roman",
  FontSize->24],

Cell[StyleData["Subtitle", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {10, 15}},
  FontFamily->"Frutiger-Roman",
  FontSize->24]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextBelow"],
  CellMargins->{{27, 4}, {0, 14}},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  ParagraphSpacing->{0, 8},
  StyleMenuListing->None,
  FontSize->12],

Cell[StyleData["TextBelow", "Presentation"],
  FontSize->18],

Cell[StyleData["TextBelow", "Printout"],
  CellMargins->{{2, 2}, {6, 12}},
  TextJustification->1,
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["TextBelow", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 12}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["TextBelow", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {6, 12}},
  TextJustification->1,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Title"],
  CellMargins->{{27, Inherited}, {20, 40}},
  CellGroupingRules->{"TitleGrouping", 0},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {
      "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->36,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["Title", "Presentation"],
  FontSize->54],

Cell[StyleData["Title", "Printout"],
  CellMargins->{{2, 10}, {15, 30}},
  FontSize->30],

Cell[StyleData["Title", "EnhancedPrintout"],
  CellMargins->{{2, 10}, {15, 30}},
  FontFamily->"Frutiger-Bold",
  FontSize->30.5,
  FontWeight->"Plain"],

Cell[StyleData["Title", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 10}, {15, 30}},
  FontFamily->"Frutiger-Bold",
  FontSize->30.5,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Undersubsection"],
  CellMargins->{{10, 4}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm]},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["Undersubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["Undersubsection", "Printout"],
  CellMargins->{{2, 0}, {7, 10}},
  FontSize->10],

Cell[StyleData["Undersubsection", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {7, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain"],

Cell[StyleData["Undersubsection", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {7, 8}},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SectionFirst"],
  CellMargins->{{27, 27}, {12, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CounterIncrements->"Section",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->20,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["SectionFirst", "Presentation"],
  FontSize->30],

Cell[StyleData["SectionFirst", "Printout"],
  CellMargins->{{2, 0}, {0, 6}},
  PageBreakBelow->False,
  FontSize->18],

Cell[StyleData["SectionFirst", "EnhancedPrintout"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{2, Inherited}, {5, 6}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->8,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  FontFamily->"Frutiger-Bold",
  FontSize->16,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["SectionFirst", "EnhancedPrintoutNonGray"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{2, Inherited}, {5, 6}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->8,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  FontFamily->"Frutiger-Bold",
  FontSize->16,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionFirst"],
  CellDingbat->None,
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 40},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["SubsectionFirst", "Presentation"],
  FontSize->24],

Cell[StyleData["SubsectionFirst", "SlideShow"],
  CellDingbat->None,
  CellMargins->{{70, 0}, {4, 6}},
  FontSize->12],

Cell[StyleData["SubsectionFirst", "Printout"],
  CellMargins->{{9, 0}, {5, 6}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontSize->12],

Cell[StyleData["SubsectionFirst", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {5, 6}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontFamily->"Frutiger-Bold",
  FontSize->12,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["SubsectionFirst", "EnhancedPrintoutNonGray"],
  CellMargins->{{9, 0}, {5, 6}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontFamily->"Frutiger-Bold",
  FontSize->12,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionFirst"],
  CellMargins->{{27, 27}, {0, 18}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  CellGroupingRules->{"SectionGrouping", 50},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["SubsubsectionFirst", "Presentation"],
  FontSize->18],

Cell[StyleData["SubsubsectionFirst", "Printout"],
  CellMargins->{{2, 0}, {3, 3}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontSize->10],

Cell[StyleData["SubsubsectionFirst", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {3, 3}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["SubsubsectionFirst", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {3, 3}},
  CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionFirst"],
  CellMargins->{{10, 4}, {0, 12}},
  CellElementSpacings->{"ClosedGroupTopMargin"->18},
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["SubsubsubsectionFirst", "Presentation"],
  FontSize->18],

Cell[StyleData["SubsubsubsectionFirst", "Printout"],
  CellMargins->{{2, 0}, {3, 3}},
  FontSize->10],

Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {3, 3}},
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 0}, {3, 3}},
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell["Spacer Cell", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Spacer"],
  CellMargins->{{10, 10}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->2,
  "ClosedCellHeight"->1},
  CellOpen->False,
  StyleMenuListing->None],

Cell[StyleData["Spacer", "Printout"],
  CellOpen->True,
  FontSize->3]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DiscretionaryHyphen"],
  StyleMenuListing->None,
  FontSize->0.0625,
  FontColor->GrayLevel[1]],

Cell[StyleData["DiscretionaryHyphen", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintout"],
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintoutNonGray"],
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller1"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller1", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller1", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.63],

Cell[StyleData["PictureSmaller1", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.63],

Cell[StyleData["PictureSmaller1", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.63]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller2"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller2", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller2", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.61],

Cell[StyleData["PictureSmaller2", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.61],

Cell[StyleData["PictureSmaller2", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.61]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller3"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller3", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller3", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.59],

Cell[StyleData["PictureSmaller3", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.59],

Cell[StyleData["PictureSmaller3", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.59]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller4"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller4", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller4", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.57],

Cell[StyleData["PictureSmaller4", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.57],

Cell[StyleData["PictureSmaller4", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.57]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller5"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller5", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller5", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.55],

Cell[StyleData["PictureSmaller5", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.55],

Cell[StyleData["PictureSmaller5", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.55]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureSmaller6"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureSmaller6", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureSmaller6", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.53],

Cell[StyleData["PictureSmaller6", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.53],

Cell[StyleData["PictureSmaller6", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.53]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPicture"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPicture", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPicture", "Printout"],
  CellMargins->{{55, Inherited}, {8, -4}},
  Magnification->0.65],

Cell[StyleData["ItemPicture", "EnhancedPrintout"],
  CellMargins->{{60, Inherited}, {10, -3}},
  Magnification->0.65],

Cell[StyleData["ItemPicture", "EnhancedPrintoutNonGray"],
  CellMargins->{{60, Inherited}, {10, -3}},
  Magnification->0.65]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller1"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller1", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller1", "Printout"],
  CellMargins->{{56, Inherited}, {9, -3}},
  Magnification->0.63],

Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintout"],
  CellMargins->{{63, Inherited}, {10, -3}},
  Magnification->0.63],

Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintoutNonGray"],
  CellMargins->{{63, Inherited}, {10, -3}},
  Magnification->0.63]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller2"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller2", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller2", "Printout"],
  CellMargins->{{58, Inherited}, {8, -4}},
  Magnification->0.61],

Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintout"],
  CellMargins->{{65, Inherited}, {11, -3}},
  Magnification->0.61],

Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintoutNonGray"],
  CellMargins->{{65, Inherited}, {11, -3}},
  Magnification->0.61]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller3"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller3", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller3", "Printout"],
  CellMargins->{{61, Inherited}, {10, -2}},
  Magnification->0.59],

Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintout"],
  CellMargins->{{67, Inherited}, {11, -3}},
  Magnification->0.59],

Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintoutNonGray"],
  CellMargins->{{67, Inherited}, {11, -3}},
  Magnification->0.59]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller4"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller4", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller4", "Printout"],
  CellMargins->{{63, Inherited}, {10, -2}},
  Magnification->0.57],

Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintout"],
  CellMargins->{{69, Inherited}, {12, -4}},
  Magnification->0.57],

Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintoutNonGray"],
  CellMargins->{{69, Inherited}, {12, -4}},
  Magnification->0.57]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller5"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller5", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller5", "Printout"],
  CellMargins->{{65, Inherited}, {11, -2}},
  Magnification->0.55],

Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintout"],
  CellMargins->{{71, Inherited}, {13, -2}},
  Magnification->0.55],

Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintoutNonGray"],
  CellMargins->{{71, Inherited}, {13, -2}},
  Magnification->0.55]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureSmaller6"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureSmaller6", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureSmaller6", "Printout"],
  CellMargins->{{67, Inherited}, {12, -2}},
  Magnification->0.53],

Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintout"],
  CellMargins->{{74, Inherited}, {13, -3}},
  Magnification->0.53],

Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintoutNonGray"],
  CellMargins->{{74, Inherited}, {13, -3}},
  Magnification->0.53]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger1"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger1", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger1", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.68],

Cell[StyleData["PictureBigger1", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.68],

Cell[StyleData["PictureBigger1", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.68]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger2"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger2", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger2", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.71],

Cell[StyleData["PictureBigger2", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.71],

Cell[StyleData["PictureBigger2", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.71]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger3"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger3", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger3", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.74],

Cell[StyleData["PictureBigger3", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.74],

Cell[StyleData["PictureBigger3", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.74]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger4"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger4", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger4", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.77],

Cell[StyleData["PictureBigger4", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.77],

Cell[StyleData["PictureBigger4", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.77]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger5"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger5", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger5", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.8],

Cell[StyleData["PictureBigger5", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.8],

Cell[StyleData["PictureBigger5", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureBigger6"],
  CellMargins->{{10, Inherited}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PictureBigger6", "Presentation"],
  FontSize->18],

Cell[StyleData["PictureBigger6", "Printout"],
  CellMargins->{{2, Inherited}, {4, 4}},
  Magnification->0.83],

Cell[StyleData["PictureBigger6", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.83],

Cell[StyleData["PictureBigger6", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {4, 2}},
  Magnification->0.83]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger1"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger1", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger1", "Printout"],
  CellMargins->{{50, Inherited}, {9, -3}},
  Magnification->0.68],

Cell[StyleData["ItemPictureBigger1", "EnhancedPrintout"],
  CellMargins->{{57, Inherited}, {10, -3}},
  Magnification->0.68],

Cell[StyleData["ItemPictureBigger1", "EnhancedPrintoutNonGray"],
  CellMargins->{{57, Inherited}, {10, -3}},
  Magnification->0.68]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger2"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger2", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger2", "Printout"],
  CellMargins->{{48, Inherited}, {8, -4}},
  Magnification->0.71],

Cell[StyleData["ItemPictureBigger2", "EnhancedPrintout"],
  CellMargins->{{54, Inherited}, {10, -3}},
  Magnification->0.71],

Cell[StyleData["ItemPictureBigger2", "EnhancedPrintoutNonGray"],
  CellMargins->{{54, Inherited}, {10, -3}},
  Magnification->0.71]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger3"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger3", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger3", "Printout"],
  CellMargins->{{46, Inherited}, {10, -2}},
  Magnification->0.74],

Cell[StyleData["ItemPictureBigger3", "EnhancedPrintout"],
  CellMargins->{{52, Inherited}, {10, -3}},
  Magnification->0.74],

Cell[StyleData["ItemPictureBigger3", "EnhancedPrintoutNonGray"],
  CellMargins->{{52, Inherited}, {10, -3}},
  Magnification->0.74]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger4"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger4", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger4", "Printout"],
  CellMargins->{{45, Inherited}, {10, -2}},
  Magnification->0.77],

Cell[StyleData["ItemPictureBigger4", "EnhancedPrintout"],
  CellMargins->{{50, Inherited}, {10, -3}},
  Magnification->0.77],

Cell[StyleData["ItemPictureBigger4", "EnhancedPrintoutNonGray"],
  CellMargins->{{50, Inherited}, {10, -3}},
  Magnification->0.77]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger5"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger5", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger5", "Printout"],
  CellMargins->{{43, Inherited}, {11, -2}},
  Magnification->0.8],

Cell[StyleData["ItemPictureBigger5", "EnhancedPrintout"],
  CellMargins->{{49, Inherited}, {10, -3}},
  Magnification->0.8],

Cell[StyleData["ItemPictureBigger5", "EnhancedPrintoutNonGray"],
  CellMargins->{{49, Inherited}, {10, -3}},
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ItemPictureBigger6"],
  CellMargins->{{41, Inherited}, {4, 2}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ItemPictureBigger6", "Presentation"],
  FontSize->18],

Cell[StyleData["ItemPictureBigger6", "Printout"],
  CellMargins->{{43, Inherited}, {12, -2}},
  Magnification->0.83],

Cell[StyleData["ItemPictureBigger6", "EnhancedPrintout"],
  CellMargins->{{46, Inherited}, {8, -2}},
  Magnification->0.83],

Cell[StyleData["ItemPictureBigger6", "EnhancedPrintoutNonGray"],
  CellMargins->{{46, Inherited}, {8, -2}},
  Magnification->0.83]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ScreenGraphic"],
  CellMargins->{{12, Inherited}, {0, 8}},
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["ScreenGraphic", "Presentation"],
  FontSize->18],

Cell[StyleData["ScreenGraphic", "Printout"],
  CellMargins->{{2, Inherited}, {0, 8}}],

Cell[StyleData["ScreenGraphic", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->2,
  "ClosedCellHeight"->2},
  CellOpen->False],

Cell[StyleData["ScreenGraphic", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->2,
  "ClosedCellHeight"->2},
  CellOpen->False]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrintGraphic"],
  CellMargins->{{12, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->2,
  "ClosedCellHeight"->2},
  CellOpen->False,
  CellHorizontalScrolling->True,
  StyleMenuListing->None],

Cell[StyleData["PrintGraphic", "Presentation"],
  FontSize->18],

Cell[StyleData["PrintGraphic", "Printout"],
  CellMargins->{{2, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->2,
  "ClosedCellHeight"->2},
  CellOpen->False],

Cell[StyleData["PrintGraphic", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->12},
  CellOpen->True],

Cell[StyleData["PrintGraphic", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, Inherited}, {0, 8}},
  CellElementSpacings->{"CellMinHeight"->12},
  CellOpen->True]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SmallTextSans"],
  CellMargins->{{10, 4}, {8, 8}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["SmallTextSans", "Presentation"],
  FontSize->14],

Cell[StyleData["SmallTextSans", "Printout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  FontSize->7],

Cell[StyleData["SmallTextSans", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {0, 8}},
  Hyphenation->True,
  LineSpacing->{1, 1},
  ParagraphSpacing->{0, -2},
  FontFamily->"Frutiger-Roman",
  FontSize->7]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["AuthorTools", "Section"],

Cell[CellGroupData[{

Cell[StyleData["BilateralCell"],
  CellMargins->{{27, 4}, {0, 8}},
  StyleMenuListing->None,
  FontSize->12,
  GridBoxOptions->{ColumnWidths->{0.33, 0.6},
  RowAlignments->Top,
  ColumnAlignments->{Left}}],

Cell[StyleData["BilateralCell", "Presentation"],
  FontSize->18],

Cell[StyleData["BilateralCell", "SlideShow"],
  CellMargins->{{36, 24}, {4, 4}},
  Background->GrayLevel[0.900008]],

Cell[StyleData["BilateralCell", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontSize->10],

Cell[StyleData["BilateralCell", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Palatino",
  FontSize->10],

Cell[StyleData["BilateralCell", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->1,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RuledPageBreak"],
  CellFrame->{{0, 0}, {0.25, 0}},
  CellMargins->{{27, 4}, {12, 0}},
  CellFrameMargins->{{0, 0}, {1, 0}},
  FontSize->8],

Cell[StyleData["RuledPageBreak", "Presentation"],
  FontSize->12],

Cell[StyleData["RuledPageBreak", "SlideShow"],
  CellMargins->{{36, 24}, {4, 4}}],

Cell[StyleData["RuledPageBreak", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  PageBreakBelow->True,
  FontSize->1],

Cell[StyleData["RuledPageBreak", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  PageBreakBelow->True],

Cell[StyleData["RuledPageBreak", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {6, 6}},
  PageBreakBelow->True]
}, Closed]],

Cell[StyleData["PaletteTitle"],
  CellFrame->{{0, 0}, {1, 0}},
  CellMargins->{{4, 0}, {Inherited, 0}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold",
  FontColor->GrayLevel[1],
  Background->RGBColor[0, 0.32549, 0.537255],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "AddOns", #2]}]&),
  ButtonEvaluator->None,
  ButtonStyle->"PaletteButton",
  ButtonMargins->3}],

Cell[StyleData["PaletteButton"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[1],
  ButtonBoxOptions->{ButtonEvaluator->"Local",
  Active->True,
  ButtonMargins->6,
  Background->RGBColor[0.329412, 0.584314, 0.694118]}],

Cell[StyleData["PaletteButton2"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[1],
  ButtonBoxOptions->{ButtonEvaluator->"Local",
  Active->True,
  ButtonMargins->4,
  Background->RGBColor[0.537255, 0.72549, 0.843137]}]
}, Closed]],

Cell[CellGroupData[{

Cell["Outline Styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Outline1"],
  CellMargins->{{27, 10}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 50},
  ParagraphIndent->-38,
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}, {"Outline3", 0}, {
      "Outline4", 0}},
  FontSize->18,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],

Cell[StyleData["Outline1", "Presentation"],
  FontSize->27],

Cell[StyleData["Outline1", "Printout"],
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline2"],
  CellMargins->{{57, 10}, {6, 6}},
  CellGroupingRules->{"SectionGrouping", 60},
  ParagraphIndent->-27,
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}, {"Outline4", 0}},
  FontSize->15,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[StyleData["Outline2", "Presentation"],
  FontSize->23],

Cell[StyleData["Outline2", "Printout"],
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline3"],
  CellMargins->{{87, 10}, {5, 5}},
  CellGroupingRules->{"SectionGrouping", 70},
  ParagraphIndent->-21,
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}},
  FontSize->12,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Outline3", "Presentation"],
  FontSize->18],

Cell[StyleData["Outline3", "Printout"],
  CounterBoxOptions->{CounterFunction:>Identity}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline4"],
  CellMargins->{{117, 10}, {4, 4}},
  CellGroupingRules->{"SectionGrouping", 80},
  ParagraphIndent->-18,
  CounterIncrements->"Outline4",
  FontSize->10,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["Outline4", "Presentation"],
  FontSize->15],

Cell[StyleData["Outline4", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Slide Show Styles", "Section"],

Cell[CellGroupData[{

Cell[StyleData["SlideShowNavigationBar"],
  Editable->False,
  CellFrame->True,
  CellMargins->{{0, 0}, {3, 3}},
  CellElementSpacings->{"CellMinHeight"->0.8125},
  CellGroupingRules->{"SectionGrouping", -5},
  CellFrameMargins->False,
  CellFrameColor->GrayLevel[1],
  CellFrameLabelMargins->False,
  TextAlignment->Center,
  CounterIncrements->"SlideShowNavigationBar",
  StyleMenuListing->None,
  FontSize->10,
  Background->GrayLevel[0.8],
  Magnification->1,
  GridBoxOptions->{GridBaseline->Center,
  RowSpacings->0,
  ColumnSpacings->0,
  ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
  RowAlignments->Baseline,
  ColumnAlignments->{
    Center, Center, Center, Center, Center, Center, Right, Center}}],

Cell[StyleData["SlideShowNavigationBar", "SlideShow"],
  Deletable->False,
  ShowCellBracket->False,
  CellMargins->{{-1, -1}, {-1, -1}},
  PageBreakAbove->True,
  CellFrameMargins->{{1, 1}, {0, 0}}],

Cell[StyleData["SlideShowNavigationBar", "Printout"],
  CellMargins->{{18, 4}, {4, 4}},
  LineSpacing->{1, 3},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideShowSection"],
  CellFrame->{{0, 0}, {0, 0.5}},
  CellMargins->{{0, 0}, {10, 0}},
  CellGroupingRules->{"SectionGrouping", 40},
  PageBreakBelow->False,
  CellFrameMargins->{{12, 4}, {6, 12}},
  InputAutoReplacements->{"TeX"->StyleBox[ 
          RowBox[ {"T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "LaTeX"->StyleBox[ 
          RowBox[ {"L", 
            StyleBox[ 
              AdjustmentBox[ 
              "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, 
                BoxBaselineShift -> -0.20000000000000001], FontSize -> 
              Smaller], "T", 
            AdjustmentBox[ 
            "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
      "mma"->"Mathematica", "Mma"->"Mathematica", 
      "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
          RowBox[ {"grid", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
      "webMathematica"->FormBox[ 
          RowBox[ {"web", 
            AdjustmentBox[ 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
          TextForm], Inherited},
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->18,
  FontWeight->"Plain",
  FontColor->GrayLevel[1],
  Background->RGBColor[0.408011, 0.440726, 0.8]],

Cell[StyleData["SlideShowSection", "Presentation"],
  FontSize->27],

Cell[StyleData["SlideShowSection", "SlideShow"],
  ShowCellBracket->False,
  PageBreakAbove->True],

Cell[StyleData["SlideShowSection", "Printout"],
  CellMargins->{{18, 30}, {0, 30}},
  CellFrameMargins->5,
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideHyperlink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontSize->26,
  FontColor->GrayLevel[0.400015],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonMinHeight->0.85,
  ButtonMargins->0.5,
  ButtonNote->None}],

Cell[StyleData["SlideHyperlink", "SlideShow"]],

Cell[StyleData["SlideHyperlink", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideTOCLink"],
  CellMargins->{{24, Inherited}, {Inherited, Inherited}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontFamily->"Helvetica",
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonMargins->1.5,
  ButtonNote->ButtonData}],

Cell[StyleData["SlideTOCLink", "SlideShow"]],

Cell[StyleData["SlideTOCLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideTOC"],
  CellDingbat->"\[Bullet]",
  CellMargins->{{18, Inherited}, {Inherited, Inherited}},
  StyleMenuListing->None,
  FontFamily->"Helvetica"],

Cell[StyleData["SlideTOC", "SlideShow"],
  FontSize->14],

Cell[StyleData["SlideTOC", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Title Page, Contents, and Index", "Section"],

Cell[CellGroupData[{

Cell[StyleData["ContentsTitle"],
  CellMargins->{{21, 4}, {12, 24}},
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold",
  FontColor->RGBColor[0.592157, 0.313726, 0.313726]],

Cell[StyleData["ContentsTitle", "Presentation"],
  FontSize->36],

Cell[StyleData["ContentsTitle", "Printout"],
  CellMargins->{{12, 0}, {102, 89}},
  PageBreakBelow->False,
  FontSize->30.5,
  FontColor->GrayLevel[0]],

Cell[StyleData["ContentsTitle", "EnhancedPrintout"],
  CellMargins->{{2, Inherited}, {15, 30}},
  PageBreakBelow->False,
  FontFamily->"Frutiger-Bold",
  FontSize->30.5,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ContentsSection"],
  ShowGroupOpenCloseIcon->True,
  CellMargins->{{35, 4}, {3, 18}},
  CellGroupingRules->{"SectionGrouping", 70},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["ContentsSection", "Presentation"],
  FontSize->18],

Cell[StyleData["ContentsSection", "Printout"],
  CellMargins->{{20, 0}, {3, 18}},
  PageBreakBelow->False,
  FontSize->11],

Cell[StyleData["ContentsSection", "EnhancedPrintout"],
  CellMargins->{{20, 0}, {3, 18}},
  PageBreakBelow->False,
  FontFamily->"Frutiger-Bold",
  FontSize->11,
  FontWeight->"Plain"],

Cell[StyleData["ContentsSection", "EnhancedPrintoutNonGray"],
  CellMargins->{{20, 0}, {3, 18}},
  PageBreakBelow->False,
  FontFamily->"Frutiger-Bold",
  FontSize->11,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexSection"],
  CellDingbat->"\[FilledSquare]",
  CellMargins->{{20, 4}, {5, 20}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["IndexSection", "Presentation"],
  FontSize->18],

Cell[StyleData["IndexSection", "Printout"],
  CellMargins->{{12, 0}, {5, 20}},
  PageBreakBelow->False,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Contents"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{50, 4}, {0, 5}},
  CellGroupingRules->{"SectionGrouping", 90},
  StyleMenuListing->None],

Cell[StyleData["Contents", "Presentation"],
  FontSize->18],

Cell[StyleData["Contents", "Printout"],
  CellMargins->{{40, 4}, {0, 5}},
  FontSize->11],

Cell[StyleData["Contents", "EnhancedPrintout"],
  CellMargins->{{40, 5}, {0, 5}},
  FontFamily->"Palatino",
  FontSize->11],

Cell[StyleData["Contents", "EnhancedPrintoutNonGray"],
  CellMargins->{{40, 5}, {0, 5}},
  FontFamily->"Palatino",
  FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Index"],
  CellMargins->{{21, 4}, {0, 0}},
  ParagraphIndent->-48,
  StyleMenuListing->None],

Cell[StyleData["Index", "Presentation"],
  FontSize->18],

Cell[StyleData["Index", "Printout"],
  CellMargins->{{13, 0}, {0, 0}},
  FontSize->9],

Cell[StyleData["Index", "EnhancedPrintout"],
  CellMargins->{{13, 0}, {0, 0}},
  FontFamily->"Palatino",
  FontSize->9],

Cell[StyleData["Index", "EnhancedPrintoutNonGray"],
  CellMargins->{{13, 0}, {0, 0}},
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexSubentry"],
  CellMargins->{{36, 4}, {0, 0}},
  ParagraphIndent->-48],

Cell[StyleData["IndexSubentry", "Presentation"],
  FontSize->18],

Cell[StyleData["IndexSubentry", "Printout"],
  CellMargins->{{24, 0}, {0, 0}},
  FontSize->9],

Cell[StyleData["IndexSubentry", "EnhancedPrintout"],
  CellMargins->{{24, 0}, {0, 0}},
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Index2Column"],
  CellMargins->{{21, 4}, {0, 8}},
  ParagraphIndent->-20,
  TabSpacings->1,
  StyleMenuListing->None,
  FontSize->10,
  GridBoxOptions->{ColumnWidths->0.5,
  ColumnAlignments->{Left}}],

Cell[StyleData["Index2Column", "Presentation"],
  FontSize->15],

Cell[StyleData["Index2Column", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->8],

Cell[StyleData["Index2Column", "EnhancedPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  LineSpacing->{1, 0.2},
  FontFamily->"Palatino",
  FontSize->8],

Cell[StyleData["Index2Column", "EnhancedPrintoutNonGray"],
  CellMargins->{{2, 2}, {1, 1}},
  LineSpacing->{1, 0.2},
  FontFamily->"Palatino",
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Leader"],
  TabFilling->".",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontWeight->"Plain"],

Cell[StyleData["Leader", "Printout"],
  FontSize->10],

Cell[StyleData["Leader", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LeaderNoDots"],
  TabFilling->" ",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontWeight->"Plain"],

Cell[StyleData["LeaderNoDots", "Printout"],
  FontSize->10],

Cell[StyleData["LeaderNoDots", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  FontColor->RGBColor[0.269993, 0.308507, 0.6],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["PageLink", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["PageLink", "EnhancedPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPage"],
  CellSize->{22, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Plain"],

Cell[StyleData["TOCPage", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCPage", "Printout"],
  FontSize->10],

Cell[StyleData["TOCPage", "EnhancedPrintout"],
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTitle"],
  CellMargins->{{20, 0}, {1, 8}},
  CellGroupingRules->{"SectionGrouping", 70},
  TabSpacings->46,
  CounterIncrements->"TOCTitle",
  CounterAssignments->{{"TOCSection", 0}},
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["TOCTitle", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCTitle", "Printout"],
  CellMargins->{{12, 0}, {1, 8}},
  PageBreakBelow->False,
  TabSpacings->47.4,
  FontSize->11],

Cell[StyleData["TOCTitle", "EnhancedPrintout"],
  CellMargins->{{2, 0}, {2, 10}},
  PageBreakBelow->False,
  TabSpacings->49.3,
  FontFamily->"Frutiger-Bold",
  FontSize->10,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSection"],
  CellMargins->{{48, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 75},
  TabSpacings->42.9,
  CounterIncrements->"TOCSection",
  CounterAssignments->{{"TOCSubsection", 0}},
  FontFamily->"Helvetica",
  FontSize->12],

Cell[StyleData["TOCSection", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCSection", "Printout"],
  CellMargins->{{30, 0}, {1, 1}},
  PageBreakBelow->False,
  FontSize->12],

Cell[StyleData["TOCSection", "EnhancedPrintout"],
  CellMargins->{{26, 0}, {1, 3}},
  PageBreakBelow->False,
  TabSpacings->46.45,
  FontFamily->"Frutiger-Roman",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsection"],
  CellMargins->{{76, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 80},
  TabSpacings->39.8,
  CounterIncrements->"TOCSubsection",
  CounterAssignments->{{"TOCSubsubsection", 0}},
  FontSize->12],

Cell[StyleData["TOCSubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCSubsection", "Printout"],
  CellMargins->{{70, 0}, {1, 1}},
  PageBreakBelow->False,
  FontSize->10],

Cell[StyleData["TOCSubsection", "EnhancedPrintout"],
  CellMargins->{{38, 0}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->45.15,
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsection"],
  CellMargins->{{104, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 85},
  TabSpacings->36.7,
  CounterIncrements->"TOCSubsubsection",
  FontSize->12],

Cell[StyleData["TOCSubsubsection", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCSubsubsection", "Printout"],
  CellMargins->{{96, 0}, {1, 1}},
  PageBreakBelow->False,
  FontSize->9],

Cell[StyleData["TOCSubsubsection", "EnhancedPrintout"],
  CellMargins->{{96, 0}, {1, 1}},
  PageBreakBelow->False,
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTitleDingbat"],
  CellSize->{34, Inherited},
  TextAlignment->Right],

Cell[StyleData["TOCTitleDingbat", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSectionDingbat"],
  CellSize->{38, Inherited},
  TextAlignment->Right],

Cell[StyleData["TOCSectionDingbat", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsectionDingbat"],
  CellSize->{54, Inherited},
  TextAlignment->Right],

Cell[StyleData["TOCSubsectionDingbat", "EnhancedPrintout"],
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTitleCondensed"],
  CellMargins->{{20, 0}, {1, 8}},
  CellGroupingRules->{"SectionGrouping", 70},
  TabSpacings->50.4,
  CounterIncrements->"TOCTitleCondensed",
  CounterAssignments->{{"TOCSectionCondensed", 0}, {
      "TOCSubsectionCondensed", 0}},
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["TOCTitleCondensed", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCTitleCondensed", "Printout"],
  CellMargins->{{12, 0}, {1, 8}},
  PageBreakBelow->False,
  FontSize->11],

Cell[StyleData["TOCTitleCondensed", "EnhancedPrintout"],
  CellMargins->{{12, 0}, {1, 8}},
  PageBreakBelow->False,
  FontFamily->"Frutiger-Bold",
  FontSize->11,
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSectionCondensed"],
  CellMargins->{{48, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 75},
  TabSpacings->47.4,
  CounterIncrements->"TOCSectionCondensed",
  CounterAssignments->{{"TOCSubsection", 0}},
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Bold",
  FontColor->GrayLevel[0.2]],

Cell[StyleData["TOCSectionCondensed", "Presentation"],
  FontSize->15],

Cell[StyleData["TOCSectionCondensed", "Printout"],
  CellMargins->{{36, 0}, {1, 1}},
  PageBreakBelow->False,
  FontSize->11],

Cell[StyleData["TOCSectionCondensed", "EnhancedPrintout"],
  CellMargins->{{36, 0}, {1, 1}},
  PageBreakBelow->False,
  FontFamily->"Palatino",
  FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsectionCondensed"],
  PageWidth->470,
  CellMargins->{{76, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 80},
  TextJustification->1,
  FontSize->12],

Cell[StyleData["TOCSubsectionCondensed", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCSubsectionCondensed", "Printout"],
  CellMargins->{{72, 0}, {1, 1}},
  PageBreakBelow->False,
  Hyphenation->True,
  FontSize->10],

Cell[StyleData["TOCSubsectionCondensed", "EnhancedPrintout"],
  CellMargins->{{72, 0}, {1, 1}},
  PageBreakBelow->False,
  Hyphenation->True,
  FontFamily->"Palatino",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsectionCondensed"],
  CellMargins->{{104, 0}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 85},
  TabSpacings->39.3,
  CounterIncrements->"TOCSubsubsectionCondensed",
  FontSize->12],

Cell[StyleData["TOCSubsubsectionCondensed", "Presentation"],
  FontSize->18],

Cell[StyleData["TOCSubsubsectionCondensed", "Printout"],
  CellMargins->{{96, 0}, {1, 1}},
  PageBreakBelow->False,
  FontSize->9],

Cell[StyleData["TOCSubsubsectionCondensed", "EnhancedPrintout"],
  CellMargins->{{96, 0}, {1, 1}},
  PageBreakBelow->False,
  FontFamily->"Palatino",
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TitlePageGraphic"],
  CellMargins->{{0, 0}, {100, 20}},
  Evaluatable->False,
  PageBreakBelow->False,
  TextAlignment->Center],

Cell[StyleData["TitlePageGraphic", "Presentation"],
  FontSize->18],

Cell[StyleData["TitlePageGraphic", "Printout"],
  CellMargins->{{0, 0}, {230, 88}}],

Cell[StyleData["TitlePageGraphic", "EnhancedPrintout"],
  CellMargins->{{0, 0}, {230, 88}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TitlePageLogo"],
  CellMargins->{{0, 0}, {0, 0}}],

Cell[StyleData["TitlePageLogo", "Presentation"],
  FontSize->18],

Cell[StyleData["TitlePageLogo", "Printout"]],

Cell[StyleData["TitlePageLogo", "EnhancedPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Horizontal Lines", "Section"],

Cell[CellGroupData[{

Cell[StyleData["Line1"],
  CellFrame->{{0, 0}, {0, 0.5}},
  CellMargins->{{10, 4}, {-16, 9}},
  StyleMenuListing->None,
  FontSize->2],

Cell[StyleData["Line1", "Presentation"],
  FontSize->3],

Cell[StyleData["Line1", "Printout"],
  CellMargins->{{2, 0}, {-16, 9}}]
}, Closed]],

Cell["\<\

The item above is horizontal 0.5 pt line\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["ProgramTop"],
  CellFrame->{{0.5, 0.5}, {0, 0.5}},
  CellMargins->{{27, 4}, {-18, 18}},
  LineSpacing->{1, -4},
  StyleMenuListing->None,
  FontSize->4],

Cell[StyleData["ProgramTop", "Presentation"],
  FontSize->6],

Cell[StyleData["ProgramTop", "Printout"],
  CellMargins->{{2, 0}, {-18, 18}}]
}, Closed]],

Cell["\<\

The item above is a ProgramTop line
\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["ProgramBottom"],
  CellFrame->{{0.5, 0.5}, {0.5, 0}},
  CellMargins->{{27, 4}, {-10, -2}},
  LineSpacing->{1, -4},
  StyleMenuListing->None,
  FontSize->4],

Cell[StyleData["ProgramBottom", "Presentation"],
  FontSize->6],

Cell[StyleData["ProgramBottom", "Printout"],
  CellMargins->{{2, 0}, {-10, -2}}]
}, Closed]],

Cell["\<\

The item above is a ProgramBottom line
\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["SessionLabel"],
  CellFrame->{{0.5, 0}, {0, 0.5}},
  CellMargins->{{27, 4}, {-4, 18}},
  LineSpacing->{1, 0},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["SessionLabel", "Presentation"],
  FontSize->14],

Cell[StyleData["SessionLabel", "Printout"],
  CellMargins->{{2, 0}, {-4, 18}},
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Headers and Footers", "Section"],

Cell[CellGroupData[{

Cell[StyleData["PageHeader"],
  CellMargins->{{0, 0}, {2, 0}},
  StyleMenuListing->None,
  FontSize->8,
  FontSlant->"Italic"],

Cell[StyleData["PageHeader", "Printout"]],

Cell[StyleData["PageHeader", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman"],

Cell[StyleData["PageHeader", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageNumber"],
  CellMargins->{{0, 0}, {2, 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->8,
  FontWeight->"Bold"],

Cell[StyleData["PageNumber", "Printout"]],

Cell[StyleData["PageNumber", "EnhancedPrintout"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"],

Cell[StyleData["PageNumber", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Bold",
  FontWeight->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageFooter"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->6],

Cell[StyleData["PageFooter", "Printout"]],

Cell[StyleData["PageFooter", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman"],

Cell[StyleData["PageFooter", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman"]
}, Closed]],

Cell[CellGroupData[{

Cell["For compatibility", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Header"],
  CellMargins->{{0, 0}, {2, 0}},
  StyleMenuListing->None,
  FontSize->8,
  FontSlant->"Italic"],

Cell[StyleData["Header", "Printout"]],

Cell[StyleData["Header", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman",
  FontSlant->"Plain"],

Cell[StyleData["Header", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman",
  FontSlant->"Plain"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Footer"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->6],

Cell[StyleData["Footer", "Printout"]],

Cell[StyleData["Footer", "EnhancedPrintout"],
  FontFamily->"Frutiger-Roman"],

Cell[StyleData["Footer", "EnhancedPrintoutNonGray"],
  FontFamily->"Frutiger-Roman"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FormatType Styles", "Section"],

Cell["\<\
The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the \
styles defined below, then that style is applied between the cell's \
style and its own options. This is particularly true of Input and \
Output.\
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["CellExpression"],
  PageWidth->Infinity,
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  ShowSpecialCharacters->False,
  AllowInlineCells->False,
  Hyphenation->False,
  AutoItalicWords->{},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  Background->GrayLevel[1]],

Cell[StyleData["CellExpression", "EnhancedPrintout"],
  FontFamily->"Courier Std",
  FontSize->10],

Cell[StyleData["CellExpression", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputForm"],
  InputAutoReplacements->{},
  AllowInlineCells->False,
  Hyphenation->False,
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["InputForm", "EnhancedPrintout"],
  FontFamily->"Courier Std"],

Cell[StyleData["InputForm", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OutputForm"],
  PageWidth->Infinity,
  TextAlignment->Left,
  LineSpacing->{0.6, 1},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["OutputForm", "EnhancedPrintout"],
  FontFamily->"Courier Std"],

Cell[StyleData["OutputForm", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["StandardForm"],
  InputAutoReplacements->{
    "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
      ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
      Inherited},
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  LineSpacing->{1.25, 0},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["StandardForm", "EnhancedPrintout"],
  FontFamily->"Courier Std"],

Cell[StyleData["StandardForm", "EnhancedPrintoutNonGray"],
  FontFamily->"Courier Std"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Automatic Styles", "Section"],

Cell["\<\
The cells below define styles that are used to affect the display of \
certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly \
bracket, and parenthesis characters are displayed (typically by \
coloring them to make them stand out).\
\>", "Text"],

Cell[StyleData["UnmatchedBracket"],
  StyleMenuListing->None]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 979}},
WindowSize->{496, 740},
WindowMargins->{{110, Automatic}, {74, Automatic}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "FunctionName"->{
    Cell[140813, 5236, 290, 9, 70, 31, 0, "StyleData", "FunctionName", "All",
      StyleMenuListing->None,
      CellTags->"FunctionName"]},
  "FunctionSubsection"->{
    Cell[141570, 5267, 259, 7, 70, 37, 0, "StyleData", "FunctionSubsection", 
    "All",
      StyleMenuListing->None,
      CellTags->"FunctionSubsection"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"FunctionName", 238452, 8953},
  {"FunctionSubsection", 238620, 8957}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 50, 0, 184, "Title"],
Cell[1829, 55, 139, 3, 59, "Text"],

Cell[CellGroupData[{
Cell[1993, 62, 42, 0, 92, "Section"],
Cell[2038, 64, 196, 5, 44, 31, 0, "StyleData", "All", "Working"],
Cell[2237, 71, 196, 5, 44, 32, 0, "StyleData", "All", "Brackets"],
Cell[2436, 78, 201, 5, 44, 36, 0, "StyleData", "All", "Presentation"],
Cell[2640, 85, 182, 5, 44, 33, 0, "StyleData", "All", "SlideShow"],
Cell[2825, 92, 175, 5, 44, 32, 0, "StyleData", "All", "Printout"],
Cell[3003, 99, 183, 5, 44, 40, 0, "StyleData", "All", "EnhancedPrintout"],
Cell[3189, 106, 191, 5, 44, 47, 0, "StyleData", "All", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[3417, 116, 35, 0, 54, "Section"],
Cell[3455, 118, 105, 3, 59, "Text"],

Cell[CellGroupData[{
Cell[3585, 125, 1051, 26, 44, 27, 0, "StyleData", "Notebook", "All",
  StyleMenuListing->None],
Cell[4639, 153, 979, 23, 38, 39, 0, "StyleData", "Notebook", "Printout"],
Cell[5621, 178, 371, 9, 38, 47, 0, "StyleData", "Notebook", \
"EnhancedPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[6041, 193, 27, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[6093, 197, 1720, 41, 130, 26, 0, "StyleData", "Chapter", "All",
  CounterIncrements->"Chapter",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
      "Subtitle", 0}, {"Subsubtitle", 0}}],
Cell[7816, 240, 58, 1, 70, 42, 0, "StyleData", "Chapter", "Presentation"],
Cell[7877, 243, 89, 2, 70, 38, 0, "StyleData", "Chapter", "Printout"],
Cell[7969, 247, 156, 4, 70, 46, 0, "StyleData", "Chapter", \
"EnhancedPrintout"],
Cell[8128, 253, 136, 3, 70, 53, 0, "StyleData", "Chapter", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[8301, 261, 1561, 37, 62, 26, 0, "StyleData", "Section", "All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}}],
Cell[9865, 300, 58, 1, 110, 42, 0, "StyleData", "Section", "Presentation"],
Cell[9926, 303, 346, 10, 79, 39, 0, "StyleData", "Section", "SlideShow"],
Cell[10275, 315, 113, 3, 66, 38, 0, "StyleData", "Section", "Printout"],
Cell[10391, 320, 401, 11, 95, 46, 0, "StyleData", "Section", \
"EnhancedPrintout",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}}],
Cell[10795, 333, 389, 10, 95, 53, 0, "StyleData", "Section", \
"EnhancedPrintoutNonGray",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}}]
}, Open  ]],

Cell[CellGroupData[{
Cell[11221, 348, 1653, 40, 63, 29, 0, "StyleData", "Subsection", "All",
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}}],
Cell[12877, 390, 61, 1, 74, 45, 0, "StyleData", "Subsection", \
"Presentation"],
Cell[12941, 393, 114, 3, 55, 42, 0, "StyleData", "Subsection", "SlideShow"],
Cell[13058, 398, 91, 2, 71, 41, 0, "StyleData", "Subsection", "Printout"],
Cell[13152, 402, 180, 5, 66, 49, 0, "StyleData", "Subsection", \
"EnhancedPrintout"],
Cell[13335, 409, 160, 4, 66, 56, 0, "StyleData", "Subsection", \
"EnhancedPrintoutNonGray"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13532, 418, 1523, 36, 57, 32, 0, "StyleData", "Subsubsection", "All"],
Cell[15058, 456, 64, 1, 70, 48, 0, "StyleData", "Subsubsection", \
"Presentation"],
Cell[15125, 459, 93, 2, 70, 44, 0, "StyleData", "Subsubsection", "Printout"],
Cell[15221, 463, 182, 5, 70, 52, 0, "StyleData", "Subsubsection", \
"EnhancedPrintout"],
Cell[15406, 470, 162, 4, 70, 59, 0, "StyleData", "Subsubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[15605, 479, 1522, 36, 53, 37, 0, "StyleData", "SubsubsectionColor", \
"All",
  StyleMenuListing->None],
Cell[17130, 517, 69, 1, 70, 53, 0, "StyleData", "SubsubsectionColor", \
"Presentation"],
Cell[17202, 520, 124, 3, 70, 49, 0, "StyleData", "SubsubsectionColor", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[17363, 528, 1565, 37, 49, 33, 0, "StyleData", "SubsectionIcon", "All",
  CounterIncrements->"Subsection"],
Cell[18931, 567, 65, 1, 70, 49, 0, "StyleData", "SubsectionIcon", \
"Presentation"],
Cell[18999, 570, 188, 5, 70, 45, 0, "StyleData", "SubsectionIcon", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[19224, 580, 1570, 37, 39, 36, 0, "StyleData", "SubsubsectionIcon", "All",
  
  CounterIncrements->"Subsubsection"],
Cell[20797, 619, 68, 1, 70, 52, 0, "StyleData", "SubsubsectionIcon", \
"Presentation"],
Cell[20868, 622, 156, 4, 70, 48, 0, "StyleData", "SubsubsectionIcon", \
"Printout"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[21073, 632, 23, 0, 92, "Section"],

Cell[CellGroupData[{
Cell[21121, 636, 1344, 32, 70, 23, 0, "StyleData", "Text", "All",
  CounterIncrements->"Text"],
Cell[22468, 670, 55, 1, 70, 39, 0, "StyleData", "Text", "Presentation"],
Cell[22526, 673, 109, 3, 70, 36, 0, "StyleData", "Text", "SlideShow"],
Cell[22638, 678, 129, 4, 70, 35, 0, "StyleData", "Text", "Printout"],
Cell[22770, 684, 163, 5, 70, 43, 0, "StyleData", "Text", "EnhancedPrintout"],
Cell[22936, 691, 170, 5, 70, 50, 0, "StyleData", "Text", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[23143, 701, 135, 4, 70, 30, 0, "StyleData", "CompactText", "All",
  StyleMenuListing->None],
Cell[23281, 707, 62, 1, 70, 46, 0, "StyleData", "CompactText", \
"Presentation"],
Cell[23346, 710, 111, 3, 70, 42, 0, "StyleData", "CompactText", "Printout"],
Cell[23460, 715, 145, 4, 70, 50, 0, "StyleData", "CompactText", \
"EnhancedPrintout"],
Cell[23608, 721, 152, 4, 70, 57, 0, "StyleData", "CompactText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[23797, 730, 121, 3, 70, 32, 0, "StyleData", "Compact12Text", "All",
  StyleMenuListing->None],
Cell[23921, 735, 64, 1, 70, 48, 0, "StyleData", "Compact12Text", \
"Presentation"],
Cell[23988, 738, 114, 3, 70, 44, 0, "StyleData", "Compact12Text", \
"Printout"],
Cell[24105, 743, 148, 4, 70, 52, 0, "StyleData", "Compact12Text", \
"EnhancedPrintout"],
Cell[24256, 749, 155, 4, 70, 59, 0, "StyleData", "Compact12Text", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[24448, 758, 192, 6, 70, 27, 0, "StyleData", "TextSans", "All",
  StyleMenuListing->None],
Cell[24643, 766, 59, 1, 70, 43, 0, "StyleData", "TextSans", "Presentation"],
Cell[24705, 769, 108, 3, 70, 39, 0, "StyleData", "TextSans", "Printout"],
Cell[24816, 774, 148, 4, 70, 47, 0, "StyleData", "TextSans", \
"EnhancedPrintout"],
Cell[24967, 780, 155, 4, 70, 54, 0, "StyleData", "TextSans", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[25159, 789, 175, 5, 70, 31, 0, "StyleData", "ItemizedText", "All",
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],
Cell[25337, 796, 63, 1, 70, 47, 0, "StyleData", "ItemizedText", \
"Presentation"],
Cell[25403, 799, 114, 3, 70, 43, 0, "StyleData", "ItemizedText", "Printout"],
Cell[25520, 804, 171, 5, 70, 51, 0, "StyleData", "ItemizedText", \
"EnhancedPrintout"],
Cell[25694, 811, 168, 5, 70, 58, 0, "StyleData", "ItemizedText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[25899, 821, 159, 4, 70, 35, 0, "StyleData", "ItemizedTextNote", "All",
  CounterIncrements->"ItemizedTextNote",
  StyleMenuListing->None],
Cell[26061, 827, 67, 1, 70, 51, 0, "StyleData", "ItemizedTextNote", \
"Presentation"],
Cell[26131, 830, 118, 3, 70, 47, 0, "StyleData", "ItemizedTextNote", \
"Printout"],
Cell[26252, 835, 175, 5, 70, 55, 0, "StyleData", "ItemizedTextNote", \
"EnhancedPrintout"],
Cell[26430, 842, 182, 5, 70, 62, 0, "StyleData", "ItemizedTextNote", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[26649, 852, 151, 4, 70, 31, 0, "StyleData", "IndentedText", "All",
  CounterIncrements->"IndentedText",
  StyleMenuListing->None],
Cell[26803, 858, 63, 1, 70, 47, 0, "StyleData", "IndentedText", \
"Presentation"],
Cell[26869, 861, 117, 3, 70, 44, 0, "StyleData", "IndentedText", \
"SlideShow"],
Cell[26989, 866, 114, 3, 70, 43, 0, "StyleData", "IndentedText", "Printout"],
Cell[27106, 871, 195, 5, 70, 51, 0, "StyleData", "IndentedText", \
"EnhancedPrintout"],
Cell[27304, 878, 144, 4, 70, 58, 0, "StyleData", "IndentedText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[27485, 887, 448, 11, 70, 31, 0, "StyleData", "ItemizedList", "All",
  CounterIncrements->"ItemizedList",
  StyleMenuListing->None],
Cell[27936, 900, 63, 1, 70, 47, 0, "StyleData", "ItemizedList", \
"Presentation"],
Cell[28002, 903, 113, 3, 70, 43, 0, "StyleData", "ItemizedList", "Printout"],
Cell[28118, 908, 170, 5, 70, 51, 0, "StyleData", "ItemizedList", \
"EnhancedPrintout"],
Cell[28291, 915, 144, 4, 70, 58, 0, "StyleData", "ItemizedList", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[28472, 924, 521, 12, 70, 34, 0, "StyleData", "ItemizedSubList", "All",
  CounterIncrements->"ItemizedSubList",
  StyleMenuListing->None],
Cell[28996, 938, 66, 1, 70, 50, 0, "StyleData", "ItemizedSubList", \
"Presentation"],
Cell[29065, 941, 117, 3, 70, 46, 0, "StyleData", "ItemizedSubList", \
"Printout"],
Cell[29185, 946, 151, 4, 70, 54, 0, "StyleData", "ItemizedSubList", \
"EnhancedPrintout"],
Cell[29339, 952, 124, 3, 70, 61, 0, "StyleData", "ItemizedSubList", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[29500, 960, 226, 5, 70, 38, 0, "StyleData", "ItemizedSubListNote", "All",
  
  CounterIncrements->"ItemizedSubList",
  StyleMenuListing->None],
Cell[29729, 967, 70, 1, 70, 54, 0, "StyleData", "ItemizedSubListNote", \
"Presentation"],
Cell[29802, 970, 121, 3, 70, 50, 0, "StyleData", "ItemizedSubListNote", \
"Printout"],
Cell[29926, 975, 155, 4, 70, 58, 0, "StyleData", "ItemizedSubListNote", \
"EnhancedPrintout"],
Cell[30084, 981, 162, 4, 70, 65, 0, "StyleData", "ItemizedSubListNote", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[30283, 990, 283, 7, 70, 31, 0, "StyleData", "BulletedList", "All",
  CounterIncrements->"BulletText",
  StyleMenuListing->None],
Cell[30569, 999, 63, 1, 70, 47, 0, "StyleData", "BulletedList", \
"Presentation"],
Cell[30635, 1002, 114, 3, 70, 43, 0, "StyleData", "BulletedList", \
"Printout"],
Cell[30752, 1007, 171, 5, 70, 51, 0, "StyleData", "BulletedList", \
"EnhancedPrintout"],
Cell[30926, 1014, 144, 4, 70, 58, 0, "StyleData", "BulletedList", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[31107, 1023, 143, 4, 70, 27, 0, "StyleData", "ListNote", "All",
  CounterIncrements->"ListNote",
  StyleMenuListing->None],
Cell[31253, 1029, 59, 1, 70, 43, 0, "StyleData", "ListNote", "Presentation"],
Cell[31315, 1032, 110, 3, 70, 39, 0, "StyleData", "ListNote", "Printout"],
Cell[31428, 1037, 167, 5, 70, 47, 0, "StyleData", "ListNote", \
"EnhancedPrintout"],
Cell[31598, 1044, 174, 5, 70, 54, 0, "StyleData", "ListNote", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[31809, 1054, 309, 9, 70, 30, 0, "StyleData", "MathCaption", "All"],
Cell[32121, 1065, 62, 1, 70, 46, 0, "StyleData", "MathCaption", \
"Presentation"],
Cell[32186, 1068, 104, 2, 70, 43, 0, "StyleData", "MathCaption", \
"SlideShow"],
Cell[32293, 1072, 139, 4, 70, 42, 0, "StyleData", "MathCaption", "Printout"],
Cell[32435, 1078, 173, 5, 70, 50, 0, "StyleData", "MathCaption", \
"EnhancedPrintout"],
Cell[32611, 1085, 180, 5, 70, 57, 0, "StyleData", "MathCaption", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[32828, 1095, 165, 5, 70, 28, 0, "StyleData", "SmallText", "All",
  CounterIncrements->"SmallText"],
Cell[32996, 1102, 60, 1, 70, 44, 0, "StyleData", "SmallText", \
"Presentation"],
Cell[33059, 1105, 133, 4, 70, 40, 0, "StyleData", "SmallText", "Printout"],
Cell[33195, 1111, 167, 5, 70, 48, 0, "StyleData", "SmallText", \
"EnhancedPrintout"],
Cell[33365, 1118, 174, 5, 70, 55, 0, "StyleData", "SmallText", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[33588, 1129, 31, 0, 54, "Section"],
Cell[33622, 1131, 252, 5, 70, "Text"],

Cell[CellGroupData[{
Cell[33899, 1140, 648, 18, 70, 24, 0, "StyleData", "Input", "All"],
Cell[34550, 1160, 56, 1, 70, 40, 0, "StyleData", "Input", "Presentation"],
Cell[34609, 1163, 228, 6, 70, 37, 0, "StyleData", "Input", "SlideShow"],
Cell[34840, 1171, 111, 3, 70, 36, 0, "StyleData", "Input", "Printout"],
Cell[34954, 1176, 119, 3, 70, 44, 0, "StyleData", "Input", \
"EnhancedPrintout"],
Cell[35076, 1181, 126, 3, 70, 51, 0, "StyleData", "Input", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[35239, 1189, 622, 17, 70, 25, 0, "StyleData", "Output", "All"],
Cell[35864, 1208, 57, 1, 70, 41, 0, "StyleData", "Output", "Presentation"],
Cell[35924, 1211, 229, 6, 70, 38, 0, "StyleData", "Output", "SlideShow"],
Cell[36156, 1219, 112, 3, 70, 37, 0, "StyleData", "Output", "Printout"],
Cell[36271, 1224, 120, 3, 70, 45, 0, "StyleData", "Output", \
"EnhancedPrintout"],
Cell[36394, 1229, 127, 3, 70, 52, 0, "StyleData", "Output", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[36558, 1237, 678, 19, 70, 28, 0, "StyleData", "InputOnly", "All",
  StyleMenuListing->None],
Cell[37239, 1258, 60, 1, 70, 44, 0, "StyleData", "InputOnly", \
"Presentation"],
Cell[37302, 1261, 194, 5, 70, 41, 0, "StyleData", "InputOnly", "SlideShow"],
Cell[37499, 1268, 115, 3, 70, 40, 0, "StyleData", "InputOnly", "Printout"],
Cell[37617, 1273, 123, 3, 70, 48, 0, "StyleData", "InputOnly", \
"EnhancedPrintout"],
Cell[37743, 1278, 130, 3, 70, 55, 0, "StyleData", "InputOnly", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[37910, 1286, 756, 21, 70, 26, 0, "StyleData", "Message", "All",
  CounterIncrements->"Message",
  StyleMenuListing->None],
Cell[38669, 1309, 58, 1, 70, 42, 0, "StyleData", "Message", "Presentation"],
Cell[38730, 1312, 132, 3, 70, 39, 0, "StyleData", "Message", "SlideShow"],
Cell[38865, 1317, 164, 4, 70, 38, 0, "StyleData", "Message", "Printout"],
Cell[39032, 1323, 197, 5, 70, 46, 0, "StyleData", "Message", \
"EnhancedPrintout"],
Cell[39232, 1330, 204, 5, 70, 53, 0, "StyleData", "Message", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[39473, 1340, 578, 16, 70, 24, 0, "StyleData", "Print", "All",
  StyleMenuListing->None],
Cell[40054, 1358, 56, 1, 70, 40, 0, "StyleData", "Print", "Presentation"],
Cell[40113, 1361, 73, 1, 70, 37, 0, "StyleData", "Print", "SlideShow"],
Cell[40189, 1364, 135, 3, 70, 36, 0, "StyleData", "Print", "Printout"],
Cell[40327, 1369, 172, 4, 70, 44, 0, "StyleData", "Print", \
"EnhancedPrintout"],
Cell[40502, 1375, 179, 4, 70, 51, 0, "StyleData", "Print", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[40718, 1384, 376, 12, 70, 27, 0, "StyleData", "Graphics", "All",
  StyleMenuListing->None],
Cell[41097, 1398, 59, 1, 70, 43, 0, "StyleData", "Graphics", "Presentation"],
Cell[41159, 1401, 231, 6, 70, 40, 0, "StyleData", "Graphics", "SlideShow"],
Cell[41393, 1409, 163, 4, 70, 39, 0, "StyleData", "Graphics", "Printout"],
Cell[41559, 1415, 200, 5, 70, 47, 0, "StyleData", "Graphics", \
"EnhancedPrintout"],
Cell[41762, 1422, 207, 5, 70, 54, 0, "StyleData", "Graphics", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[42006, 1432, 193, 6, 70, 28, 0, "StyleData", "CellLabel", "All",
  StyleMenuListing->None],
Cell[42202, 1440, 60, 1, 70, 44, 0, "StyleData", "CellLabel", \
"Presentation"],
Cell[42265, 1443, 82, 1, 70, 41, 0, "StyleData", "CellLabel", "SlideShow"],
Cell[42350, 1446, 131, 4, 70, 40, 0, "StyleData", "CellLabel", "Printout"],
Cell[42484, 1452, 143, 4, 70, 48, 0, "StyleData", "CellLabel", \
"EnhancedPrintout"],
Cell[42630, 1458, 150, 4, 70, 55, 0, "StyleData", "CellLabel", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[42817, 1467, 185, 6, 70, 23, 0, "StyleData", "Name", "All",
  StyleMenuListing->None],
Cell[43005, 1475, 55, 1, 70, 39, 0, "StyleData", "Name", "Presentation"],
Cell[43063, 1478, 101, 3, 70, 35, 0, "StyleData", "Name", "Printout"],
Cell[43167, 1483, 140, 4, 70, 43, 0, "StyleData", "Name", \
"EnhancedPrintout"],
Cell[43310, 1489, 147, 4, 70, 50, 0, "StyleData", "Name", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[43506, 1499, 29, 0, 54, "Section"],
Cell[43538, 1501, 340, 6, 70, "Text"],

Cell[CellGroupData[{
Cell[43903, 1511, 279, 7, 70, 28, 0, "StyleData", "Hyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[44185, 1520, 107, 2, 70, 40, 0, "StyleData", "Hyperlink", "Printout"],
Cell[44295, 1524, 141, 3, 70, 48, 0, "StyleData", "Hyperlink", \
"EnhancedPrintout"],
Cell[44439, 1529, 148, 3, 70, 55, 0, "StyleData", "Hyperlink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[44624, 1537, 293, 7, 70, 31, 0, "StyleData", "MainBookLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[44920, 1546, 110, 2, 70, 43, 0, "StyleData", "MainBookLink", \
"Printout"],
Cell[45033, 1550, 144, 3, 70, 51, 0, "StyleData", "MainBookLink", \
"EnhancedPrintout"],
Cell[45180, 1555, 151, 3, 70, 58, 0, "StyleData", "MainBookLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[45368, 1563, 320, 8, 70, 33, 0, "StyleData", "MainBookLinkMR", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[45691, 1573, 112, 2, 70, 45, 0, "StyleData", "MainBookLinkMR", \
"Printout"],
Cell[45806, 1577, 120, 2, 70, 53, 0, "StyleData", "MainBookLinkMR", \
"EnhancedPrintout"],
Cell[45929, 1581, 127, 2, 70, 60, 0, "StyleData", "MainBookLinkMR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[46093, 1588, 314, 8, 70, 29, 0, "StyleData", "AddOnsLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[46410, 1598, 108, 2, 70, 41, 0, "StyleData", "AddOnsLink", "Printout"],
Cell[46521, 1602, 144, 3, 70, 49, 0, "StyleData", "AddOnsLink", \
"EnhancedPrintout"],
Cell[46668, 1607, 151, 3, 70, 56, 0, "StyleData", "AddOnsLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[46856, 1615, 316, 8, 70, 33, 0, "StyleData", "AddOnsLinkText", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[47175, 1625, 112, 2, 70, 45, 0, "StyleData", "AddOnsLinkText", \
"Printout"],
Cell[47290, 1629, 146, 3, 70, 53, 0, "StyleData", "AddOnsLinkText", \
"EnhancedPrintout"],
Cell[47439, 1634, 153, 3, 70, 60, 0, "StyleData", "AddOnsLinkText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[47629, 1642, 318, 8, 70, 31, 0, "StyleData", "RefGuideLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[47950, 1652, 110, 2, 70, 43, 0, "StyleData", "RefGuideLink", \
"Printout"],
Cell[48063, 1656, 146, 3, 70, 51, 0, "StyleData", "RefGuideLink", \
"EnhancedPrintout"],
Cell[48212, 1661, 153, 3, 70, 58, 0, "StyleData", "RefGuideLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[48402, 1669, 305, 7, 70, 37, 0, "StyleData", "GettingStartedLink", "All",
  
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[48710, 1678, 116, 2, 70, 49, 0, "StyleData", "GettingStartedLink", \
"Printout"],
Cell[48829, 1682, 150, 3, 70, 57, 0, "StyleData", "GettingStartedLink", \
"EnhancedPrintout"],
Cell[48982, 1687, 157, 3, 70, 64, 0, "StyleData", "GettingStartedLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[49176, 1695, 287, 7, 70, 28, 0, "StyleData", "DemosLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[49466, 1704, 107, 2, 70, 40, 0, "StyleData", "DemosLink", "Printout"],
Cell[49576, 1708, 115, 2, 70, 48, 0, "StyleData", "DemosLink", \
"EnhancedPrintout"],
Cell[49694, 1712, 122, 2, 70, 55, 0, "StyleData", "DemosLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[49853, 1719, 285, 7, 70, 27, 0, "StyleData", "TourLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[50141, 1728, 106, 2, 70, 39, 0, "StyleData", "TourLink", "Printout"],
Cell[50250, 1732, 114, 2, 70, 47, 0, "StyleData", "TourLink", \
"EnhancedPrintout"],
Cell[50367, 1736, 121, 2, 70, 54, 0, "StyleData", "TourLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[50525, 1743, 309, 7, 70, 39, 0, "StyleData", "OtherInformationLink", \
"All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[50837, 1752, 118, 2, 70, 51, 0, "StyleData", "OtherInformationLink", \
"Printout"],
Cell[50958, 1756, 152, 3, 70, 59, 0, "StyleData", "OtherInformationLink", \
"EnhancedPrintout"],
Cell[51113, 1761, 159, 3, 70, 66, 0, "StyleData", "OtherInformationLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[51309, 1769, 299, 7, 70, 41, 0, "StyleData", "OtherInformationLinkMR", \
"All",
  StyleMenuListing->None],
Cell[51611, 1778, 120, 2, 70, 53, 0, "StyleData", "OtherInformationLinkMR", \
"Printout"],
Cell[51734, 1782, 128, 2, 70, 61, 0, "StyleData", "OtherInformationLinkMR", \
"EnhancedPrintout"],
Cell[51865, 1786, 135, 2, 70, 68, 0, "StyleData", "OtherInformationLinkMR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[52037, 1793, 299, 7, 70, 34, 0, "StyleData", "MasterIndexLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[52339, 1802, 113, 2, 70, 46, 0, "StyleData", "MasterIndexLink", \
"Printout"],
Cell[52455, 1806, 121, 2, 70, 54, 0, "StyleData", "MasterIndexLink", \
"EnhancedPrintout"],
Cell[52579, 1810, 128, 2, 70, 61, 0, "StyleData", "MasterIndexLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[52744, 1817, 301, 8, 70, 31, 0, "StyleData", "NotebookLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[53048, 1827, 126, 3, 70, 43, 0, "StyleData", "NotebookLink", \
"Printout"],
Cell[53177, 1832, 160, 4, 70, 51, 0, "StyleData", "NotebookLink", \
"EnhancedPrintout"],
Cell[53340, 1838, 167, 4, 70, 58, 0, "StyleData", "NotebookLink", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[53544, 1847, 305, 8, 70, 33, 0, "StyleData", "NotebookLinkMR", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[53852, 1857, 128, 3, 70, 45, 0, "StyleData", "NotebookLinkMR", \
"Printout"],
Cell[53983, 1862, 136, 3, 70, 53, 0, "StyleData", "NotebookLinkMR", \
"EnhancedPrintout"],
Cell[54122, 1867, 143, 3, 70, 60, 0, "StyleData", "NotebookLinkMR", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[54314, 1876, 33, 0, 54, "Section"],
Cell[54350, 1878, 121, 3, 70, "Text"],
Cell[54474, 1883, 226, 5, 70, 24, 0, "StyleData", "Paste", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[54703, 1890, 304, 7, 70, 27, 0, "StyleData", "Evaluate", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[55010, 1899, 400, 9, 70, 31, 0, "StyleData", "EvaluateCell", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[55413, 1910, 387, 9, 70, 31, 0, "StyleData", "CopyEvaluate", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[55803, 1921, 401, 9, 70, 35, 0, "StyleData", "CopyEvaluateCell", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic]
}, Closed]],

Cell[CellGroupData[{
Cell[56241, 1935, 36, 0, 54, "Section"],
Cell[56280, 1937, 121, 3, 50, "Text"],

Cell[CellGroupData[{
Cell[56426, 1944, 74, 2, 39, 21, 0, "StyleData", "JT", "All",
  StyleMenuListing->None],
Cell[56503, 1948, 33, 0, 70, 33, 0, "StyleData", "JT", "Printout"],
Cell[56539, 1950, 41, 0, 70, 41, 0, "StyleData", "JT", "EnhancedPrintout"],
Cell[56583, 1952, 48, 0, 70, 48, 0, "StyleData", "JT", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[56668, 1957, 74, 2, 39, 21, 0, "StyleData", "JS", "All",
  StyleMenuListing->None],
Cell[56745, 1961, 33, 0, 70, 33, 0, "StyleData", "JS", "Printout"],
Cell[56781, 1963, 41, 0, 70, 41, 0, "StyleData", "JS", "EnhancedPrintout"],
Cell[56825, 1965, 48, 0, 70, 48, 0, "StyleData", "JS", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[56910, 1970, 79, 2, 39, 22, 0, "StyleData", "JSB", "All",
  StyleMenuListing->None],
Cell[56992, 1974, 34, 0, 70, 34, 0, "StyleData", "JSB", "Printout"],
Cell[57029, 1976, 42, 0, 70, 42, 0, "StyleData", "JSB", "EnhancedPrintout"],
Cell[57074, 1978, 49, 0, 70, 49, 0, "StyleData", "JSB", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[57160, 1983, 92, 3, 38, 21, 0, "StyleData", "RM", "All",
  StyleMenuListing->None],
Cell[57255, 1988, 33, 0, 70, 33, 0, "StyleData", "RM", "Printout"],
Cell[57291, 1990, 41, 0, 70, 41, 0, "StyleData", "RM", "EnhancedPrintout"],
Cell[57335, 1992, 48, 0, 70, 48, 0, "StyleData", "RM", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[57420, 1997, 69, 2, 38, 21, 0, "StyleData", "BF", "All",
  StyleMenuListing->None],
Cell[57492, 2001, 33, 0, 70, 33, 0, "StyleData", "BF", "Printout"],
Cell[57528, 2003, 41, 0, 70, 41, 0, "StyleData", "BF", "EnhancedPrintout"],
Cell[57572, 2005, 48, 0, 70, 48, 0, "StyleData", "BF", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[57657, 2010, 70, 2, 38, 21, 0, "StyleData", "IT", "All",
  StyleMenuListing->None],
Cell[57730, 2014, 33, 0, 70, 33, 0, "StyleData", "IT", "Printout"],
Cell[57766, 2016, 41, 0, 70, 41, 0, "StyleData", "IT", "EnhancedPrintout"],
Cell[57810, 2018, 48, 0, 70, 48, 0, "StyleData", "IT", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[57895, 2023, 115, 4, 38, 21, 0, "StyleData", "TR", "All",
  StyleMenuListing->None],
Cell[58013, 2029, 33, 0, 70, 33, 0, "StyleData", "TR", "Printout"],
Cell[58049, 2031, 67, 1, 70, 41, 0, "StyleData", "TR", "EnhancedPrintout"],
Cell[58119, 2034, 74, 1, 70, 48, 0, "StyleData", "TR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[58230, 2040, 93, 3, 38, 21, 0, "StyleData", "TI", "All",
  StyleMenuListing->None],
Cell[58326, 2045, 33, 0, 70, 33, 0, "StyleData", "TI", "Printout"],
Cell[58362, 2047, 67, 1, 70, 41, 0, "StyleData", "TI", "EnhancedPrintout"],
Cell[58432, 2050, 74, 1, 70, 48, 0, "StyleData", "TI", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[58543, 2056, 114, 4, 38, 21, 0, "StyleData", "TB", "All",
  StyleMenuListing->None],
Cell[58660, 2062, 33, 0, 70, 33, 0, "StyleData", "TB", "Printout"],
Cell[58696, 2064, 67, 1, 70, 41, 0, "StyleData", "TB", "EnhancedPrintout"],
Cell[58766, 2067, 74, 1, 70, 48, 0, "StyleData", "TB", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[58877, 2073, 116, 4, 38, 22, 0, "StyleData", "TBI", "All",
  StyleMenuListing->None],
Cell[58996, 2079, 34, 0, 70, 34, 0, "StyleData", "TBI", "Printout"],
Cell[59033, 2081, 68, 1, 70, 42, 0, "StyleData", "TBI", "EnhancedPrintout"],
Cell[59104, 2084, 75, 1, 70, 49, 0, "StyleData", "TBI", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[59216, 2090, 228, 7, 37, 21, 0, "StyleData", "MR", "All",
  StyleMenuListing->None],
Cell[59447, 2099, 33, 0, 70, 33, 0, "StyleData", "MR", "Printout"],
Cell[59483, 2101, 70, 1, 70, 41, 0, "StyleData", "MR", "EnhancedPrintout"],
Cell[59556, 2104, 77, 1, 70, 48, 0, "StyleData", "MR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[59670, 2110, 185, 5, 37, 21, 0, "StyleData", "MO", "All",
  StyleMenuListing->None],
Cell[59858, 2117, 57, 1, 70, 33, 0, "StyleData", "MO", "Printout"],
Cell[59918, 2120, 94, 2, 70, 41, 0, "StyleData", "MO", "EnhancedPrintout"],
Cell[60015, 2124, 101, 2, 70, 48, 0, "StyleData", "MO", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[60153, 2131, 183, 5, 37, 21, 0, "StyleData", "MB", "All",
  StyleMenuListing->None],
Cell[60339, 2138, 33, 0, 70, 33, 0, "StyleData", "MB", "Printout"],
Cell[60375, 2140, 70, 1, 70, 41, 0, "StyleData", "MB", "EnhancedPrintout"],
Cell[60448, 2143, 77, 1, 70, 48, 0, "StyleData", "MB", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[60562, 2149, 185, 5, 37, 22, 0, "StyleData", "MBO", "All",
  StyleMenuListing->None],
Cell[60750, 2156, 58, 1, 70, 34, 0, "StyleData", "MBO", "Printout"],
Cell[60811, 2159, 95, 2, 70, 42, 0, "StyleData", "MBO", "EnhancedPrintout"],
Cell[60909, 2163, 102, 2, 70, 49, 0, "StyleData", "MBO", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[61048, 2170, 119, 4, 38, 21, 0, "StyleData", "SR", "All",
  StyleMenuListing->None],
Cell[61170, 2176, 33, 0, 70, 33, 0, "StyleData", "SR", "Printout"],
Cell[61206, 2178, 73, 1, 70, 41, 0, "StyleData", "SR", "EnhancedPrintout"],
Cell[61282, 2181, 80, 1, 70, 48, 0, "StyleData", "SR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[61399, 2187, 120, 4, 38, 21, 0, "StyleData", "SO", "All",
  StyleMenuListing->None],
Cell[61522, 2193, 132, 4, 70, 33, 0, "StyleData", "SO", "Printout",
  StyleMenuListing->None],
Cell[61657, 2199, 96, 2, 70, 41, 0, "StyleData", "SO", "EnhancedPrintout"],
Cell[61756, 2203, 103, 2, 70, 48, 0, "StyleData", "SO", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[61896, 2210, 118, 4, 38, 21, 0, "StyleData", "SB", "All",
  StyleMenuListing->None],
Cell[62017, 2216, 59, 1, 70, 33, 0, "StyleData", "SB", "Printout",
  StyleMenuListing->None],
Cell[62079, 2219, 95, 2, 70, 41, 0, "StyleData", "SB", "EnhancedPrintout"],
Cell[62177, 2223, 102, 2, 70, 48, 0, "StyleData", "SB", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[62316, 2230, 123, 4, 38, 26, 0, "StyleData", "SBColor", "All",
  StyleMenuListing->None],
Cell[62442, 2236, 64, 1, 70, 38, 0, "StyleData", "SBColor", "Printout",
  StyleMenuListing->None],
Cell[62509, 2239, 100, 2, 70, 46, 0, "StyleData", "SBColor", \
"EnhancedPrintout"],
Cell[62612, 2243, 107, 2, 70, 53, 0, "StyleData", "SBColor", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[62756, 2250, 120, 4, 38, 22, 0, "StyleData", "SBO", "All",
  StyleMenuListing->None],
Cell[62879, 2256, 132, 4, 70, 34, 0, "StyleData", "SBO", "Printout",
  StyleMenuListing->None],
Cell[63014, 2262, 124, 3, 70, 42, 0, "StyleData", "SBO", "EnhancedPrintout"],
Cell[63141, 2267, 131, 3, 70, 49, 0, "StyleData", "SBO", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[63309, 2275, 139, 4, 38, 21, 0, "StyleData", "M4", "All",
  StyleMenuListing->None],
Cell[63451, 2281, 151, 4, 70, 33, 0, "StyleData", "M4", "Printout",
  StyleMenuListing->None],
Cell[63605, 2287, 159, 4, 70, 41, 0, "StyleData", "M4", "EnhancedPrintout",
  StyleMenuListing->None],
Cell[63767, 2293, 166, 4, 70, 48, 0, "StyleData", "M4", \
"EnhancedPrintoutNonGray",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[63970, 2302, 138, 5, 35, 23, 0, "StyleData", "SO10", "All",
  StyleMenuListing->None],
Cell[64111, 2309, 149, 5, 70, 35, 0, "StyleData", "SO10", "Printout",
  StyleMenuListing->None],
Cell[64263, 2316, 162, 5, 70, 43, 0, "StyleData", "SO10", "EnhancedPrintout",
  StyleMenuListing->None],
Cell[64428, 2323, 169, 5, 70, 50, 0, "StyleData", "SO10", \
"EnhancedPrintoutNonGray",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[64634, 2333, 112, 4, 34, 21, 0, "StyleData", "S9", "All",
  StyleMenuListing->None],
Cell[64749, 2339, 71, 2, 70, 33, 0, "StyleData", "S9", "Printout"],
Cell[64823, 2343, 111, 3, 70, 41, 0, "StyleData", "S9", "EnhancedPrintout"],
Cell[64937, 2348, 118, 3, 70, 48, 0, "StyleData", "S9", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[65092, 2356, 114, 4, 35, 22, 0, "StyleData", "S10", "All",
  StyleMenuListing->None],
Cell[65209, 2362, 73, 2, 70, 34, 0, "StyleData", "S10", "Printout"],
Cell[65285, 2366, 113, 3, 70, 42, 0, "StyleData", "S10", "EnhancedPrintout"],
Cell[65401, 2371, 120, 3, 70, 49, 0, "StyleData", "S10", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[65558, 2379, 167, 5, 35, 22, 0, "StyleData", "SB9", "All",
  StyleMenuListing->None],
Cell[65728, 2386, 49, 1, 70, 34, 0, "StyleData", "SB9", "Printout"],
Cell[65780, 2389, 111, 3, 70, 42, 0, "StyleData", "SB9", "EnhancedPrintout"],
Cell[65894, 2394, 118, 3, 70, 49, 0, "StyleData", "SB9", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[66049, 2402, 114, 4, 35, 23, 0, "StyleData", "SB10", "All",
  StyleMenuListing->None],
Cell[66166, 2408, 50, 1, 70, 35, 0, "StyleData", "SB10", "Printout"],
Cell[66219, 2411, 112, 3, 70, 43, 0, "StyleData", "SB10", \
"EnhancedPrintout"],
Cell[66334, 2416, 119, 3, 70, 50, 0, "StyleData", "SB10", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[66490, 2424, 253, 8, 35, 23, 0, "StyleData", "MR10", "All",
  StyleMenuListing->None],
Cell[66746, 2434, 50, 1, 70, 35, 0, "StyleData", "MR10", "Printout"],
Cell[66799, 2437, 87, 2, 70, 43, 0, "StyleData", "MR10", "EnhancedPrintout"],
Cell[66889, 2441, 94, 2, 70, 50, 0, "StyleData", "MR10", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[67020, 2448, 231, 7, 35, 23, 0, "StyleData", "MO10", "All",
  StyleMenuListing->None],
Cell[67254, 2457, 50, 1, 70, 35, 0, "StyleData", "MO10", "Printout"],
Cell[67307, 2460, 87, 2, 70, 43, 0, "StyleData", "MO10", "EnhancedPrintout"],
Cell[67397, 2464, 94, 2, 70, 50, 0, "StyleData", "MO10", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[67528, 2471, 81, 2, 38, 21, 0, "StyleData", "C1", "All",
  StyleMenuListing->None],
Cell[67612, 2475, 76, 2, 70, 33, 0, "StyleData", "C1", "Printout"],
Cell[67691, 2479, 110, 3, 70, 41, 0, "StyleData", "C1", "EnhancedPrintout"],
Cell[67804, 2484, 117, 3, 70, 48, 0, "StyleData", "C1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[67958, 2492, 108, 3, 37, 23, 0, "StyleData", "C1MR", "All",
  StyleMenuListing->None],
Cell[68069, 2497, 78, 2, 70, 35, 0, "StyleData", "C1MR", "Printout"],
Cell[68150, 2501, 115, 3, 70, 43, 0, "StyleData", "C1MR", \
"EnhancedPrintout"],
Cell[68268, 2506, 122, 3, 70, 50, 0, "StyleData", "C1MR", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[68427, 2514, 76, 2, 34, 28, 0, "StyleData", "SmallCaps", "All",
  StyleMenuListing->None],
Cell[68506, 2518, 40, 0, 70, 40, 0, "StyleData", "SmallCaps", "Printout"],
Cell[68549, 2520, 74, 1, 70, 48, 0, "StyleData", "SmallCaps", \
"EnhancedPrintout"],
Cell[68626, 2523, 81, 1, 70, 55, 0, "StyleData", "SmallCaps", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[68744, 2529, 74, 2, 38, 32, 0, "StyleData", "KeyboardChars", "All",
  StyleMenuListing->None],
Cell[68821, 2533, 60, 1, 70, 44, 0, "StyleData", "KeyboardChars", \
"Printout"],
Cell[68884, 2536, 94, 2, 70, 52, 0, "StyleData", "KeyboardChars", \
"EnhancedPrintout"],
Cell[68981, 2540, 101, 2, 70, 59, 0, "StyleData", "KeyboardChars", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[69119, 2547, 104, 2, 54, 24, 0, "StyleData", "Inert", "All",
  StyleMenuListing->None],
Cell[69226, 2551, 90, 2, 70, 36, 0, "StyleData", "Inert", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[69353, 2558, 34, 0, 30, "Subsection"],
Cell[69390, 2560, 58, 1, 38, 32, 0, "StyleData", "HeadingNumber", "All",
  StyleMenuListing->None]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[69497, 2567, 46, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[69568, 2571, 340, 9, 70, 22, 0, "StyleData", "Box", "All",
  StyleMenuListing->None],
Cell[69911, 2582, 54, 1, 70, 38, 0, "StyleData", "Box", "Presentation"],
Cell[69968, 2585, 150, 4, 70, 34, 0, "StyleData", "Box", "Printout"],
Cell[70121, 2591, 158, 4, 70, 42, 0, "StyleData", "Box", "EnhancedPrintout"],
Cell[70282, 2597, 158, 4, 70, 49, 0, "StyleData", "Box", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[70477, 2606, 368, 10, 70, 28, 0, "StyleData", "DoubleBox", "All",
  StyleMenuListing->None],
Cell[70848, 2618, 60, 1, 70, 44, 0, "StyleData", "DoubleBox", \
"Presentation"],
Cell[70911, 2621, 156, 4, 70, 40, 0, "StyleData", "DoubleBox", "Printout"],
Cell[71070, 2627, 164, 4, 70, 48, 0, "StyleData", "DoubleBox", \
"EnhancedPrintout"],
Cell[71237, 2633, 164, 4, 70, 55, 0, "StyleData", "DoubleBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[71438, 2642, 364, 10, 70, 29, 0, "StyleData", "1ColumnBox", "All",
  StyleMenuListing->None],
Cell[71805, 2654, 61, 1, 70, 45, 0, "StyleData", "1ColumnBox", \
"Presentation"],
Cell[71869, 2657, 157, 4, 70, 41, 0, "StyleData", "1ColumnBox", "Printout"],
Cell[72029, 2663, 165, 4, 70, 49, 0, "StyleData", "1ColumnBox", \
"EnhancedPrintout"],
Cell[72197, 2669, 165, 4, 70, 56, 0, "StyleData", "1ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[72399, 2678, 403, 11, 70, 29, 0, "StyleData", "2ColumnBox", "All",
  StyleMenuListing->None],
Cell[72805, 2691, 61, 1, 70, 45, 0, "StyleData", "2ColumnBox", \
"Presentation"],
Cell[72869, 2694, 156, 4, 70, 41, 0, "StyleData", "2ColumnBox", "Printout"],
Cell[73028, 2700, 164, 4, 70, 49, 0, "StyleData", "2ColumnBox", \
"EnhancedPrintout"],
Cell[73195, 2706, 164, 4, 70, 56, 0, "StyleData", "2ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[73396, 2715, 369, 10, 70, 33, 0, "StyleData", "2ColumnEvenBox", "All",
  StyleMenuListing->None],
Cell[73768, 2727, 65, 1, 70, 49, 0, "StyleData", "2ColumnEvenBox", \
"Presentation"],
Cell[73836, 2730, 161, 4, 70, 45, 0, "StyleData", "2ColumnEvenBox", \
"Printout"],
Cell[74000, 2736, 169, 4, 70, 53, 0, "StyleData", "2ColumnEvenBox", \
"EnhancedPrintout"],
Cell[74172, 2742, 169, 4, 70, 60, 0, "StyleData", "2ColumnEvenBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[74378, 2751, 428, 12, 70, 34, 0, "StyleData", "2ColumnSmallBox", "All",
  StyleMenuListing->None],
Cell[74809, 2765, 66, 1, 70, 50, 0, "StyleData", "2ColumnSmallBox", \
"Presentation"],
Cell[74878, 2768, 162, 4, 70, 46, 0, "StyleData", "2ColumnSmallBox", \
"Printout"],
Cell[75043, 2774, 170, 4, 70, 54, 0, "StyleData", "2ColumnSmallBox", \
"EnhancedPrintout"],
Cell[75216, 2780, 170, 4, 70, 61, 0, "StyleData", "2ColumnSmallBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[75423, 2789, 365, 10, 70, 29, 0, "StyleData", "3ColumnBox", "All",
  StyleMenuListing->None],
Cell[75791, 2801, 61, 1, 70, 45, 0, "StyleData", "3ColumnBox", \
"Presentation"],
Cell[75855, 2804, 157, 4, 70, 41, 0, "StyleData", "3ColumnBox", "Printout"],
Cell[76015, 2810, 165, 4, 70, 49, 0, "StyleData", "3ColumnBox", \
"EnhancedPrintout"],
Cell[76183, 2816, 165, 4, 70, 56, 0, "StyleData", "3ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[76385, 2825, 436, 12, 70, 34, 0, "StyleData", "3ColumnSmallBox", "All",
  StyleMenuListing->None],
Cell[76824, 2839, 66, 1, 70, 50, 0, "StyleData", "3ColumnSmallBox", \
"Presentation"],
Cell[76893, 2842, 162, 4, 70, 46, 0, "StyleData", "3ColumnSmallBox", \
"Printout"],
Cell[77058, 2848, 170, 4, 70, 54, 0, "StyleData", "3ColumnSmallBox", \
"EnhancedPrintout"],
Cell[77231, 2854, 188, 5, 70, 61, 0, "StyleData", "3ColumnSmallBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[77456, 2864, 415, 11, 70, 29, 0, "StyleData", "4ColumnBox", "All",
  StyleMenuListing->None],
Cell[77874, 2877, 61, 1, 70, 45, 0, "StyleData", "4ColumnBox", \
"Presentation"],
Cell[77938, 2880, 157, 4, 70, 41, 0, "StyleData", "4ColumnBox", "Printout"],
Cell[78098, 2886, 165, 4, 70, 49, 0, "StyleData", "4ColumnBox", \
"EnhancedPrintout"],
Cell[78266, 2892, 165, 4, 70, 56, 0, "StyleData", "4ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[78468, 2901, 366, 10, 70, 29, 0, "StyleData", "5ColumnBox", "All",
  StyleMenuListing->None],
Cell[78837, 2913, 61, 1, 70, 45, 0, "StyleData", "5ColumnBox", \
"Presentation"],
Cell[78901, 2916, 156, 4, 70, 41, 0, "StyleData", "5ColumnBox", "Printout"],
Cell[79060, 2922, 164, 4, 70, 49, 0, "StyleData", "5ColumnBox", \
"EnhancedPrintout"],
Cell[79227, 2928, 164, 4, 70, 56, 0, "StyleData", "5ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[79428, 2937, 400, 11, 70, 29, 0, "StyleData", "6ColumnBox", "All",
  StyleMenuListing->None],
Cell[79831, 2950, 61, 1, 70, 45, 0, "StyleData", "6ColumnBox", \
"Presentation"],
Cell[79895, 2953, 157, 4, 70, 41, 0, "StyleData", "6ColumnBox", "Printout"],
Cell[80055, 2959, 165, 4, 70, 49, 0, "StyleData", "6ColumnBox", \
"EnhancedPrintout"],
Cell[80223, 2965, 165, 4, 70, 56, 0, "StyleData", "6ColumnBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[80425, 2974, 400, 12, 70, 28, 0, "StyleData", "FramedBox", "All"],
Cell[80828, 2988, 60, 1, 70, 44, 0, "StyleData", "FramedBox", \
"Presentation"],
Cell[80891, 2991, 149, 4, 70, 40, 0, "StyleData", "FramedBox", "Printout"],
Cell[81043, 2997, 183, 5, 70, 48, 0, "StyleData", "FramedBox", \
"EnhancedPrintout"],
Cell[81229, 3004, 190, 5, 70, 55, 0, "StyleData", "FramedBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[81456, 3014, 453, 14, 70, 32, 0, "StyleData", "DefinitionBox", "All"],
Cell[81912, 3030, 64, 1, 70, 48, 0, "StyleData", "DefinitionBox", \
"Presentation"],
Cell[81979, 3033, 153, 4, 70, 44, 0, "StyleData", "DefinitionBox", \
"Printout"],
Cell[82135, 3039, 187, 5, 70, 52, 0, "StyleData", "DefinitionBox", \
"EnhancedPrintout"],
Cell[82325, 3046, 194, 5, 70, 59, 0, "StyleData", "DefinitionBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[82556, 3056, 464, 14, 70, 36, 0, "StyleData", "DefinitionBox3Col", \
"All"],
Cell[83023, 3072, 68, 1, 70, 52, 0, "StyleData", "DefinitionBox3Col", \
"Presentation"],
Cell[83094, 3075, 157, 4, 70, 48, 0, "StyleData", "DefinitionBox3Col", \
"Printout"],
Cell[83254, 3081, 191, 5, 70, 56, 0, "StyleData", "DefinitionBox3Col", \
"EnhancedPrintout"],
Cell[83448, 3088, 198, 5, 70, 63, 0, "StyleData", "DefinitionBox3Col", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[83683, 3098, 471, 14, 70, 36, 0, "StyleData", "DefinitionBox4Col", \
"All"],
Cell[84157, 3114, 68, 1, 70, 52, 0, "StyleData", "DefinitionBox4Col", \
"Presentation"],
Cell[84228, 3117, 157, 4, 70, 48, 0, "StyleData", "DefinitionBox4Col", \
"Printout"],
Cell[84388, 3123, 191, 5, 70, 56, 0, "StyleData", "DefinitionBox4Col", \
"EnhancedPrintout"],
Cell[84582, 3130, 198, 5, 70, 63, 0, "StyleData", "DefinitionBox4Col", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[84817, 3140, 467, 14, 70, 34, 0, "StyleData", "PrecedenceTable", "All"],
Cell[85287, 3156, 66, 1, 70, 50, 0, "StyleData", "PrecedenceTable", \
"Presentation"],
Cell[85356, 3159, 155, 4, 70, 46, 0, "StyleData", "PrecedenceTable", \
"Printout"],
Cell[85514, 3165, 189, 5, 70, 54, 0, "StyleData", "PrecedenceTable", \
"EnhancedPrintout"],
Cell[85706, 3172, 196, 5, 70, 61, 0, "StyleData", "PrecedenceTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[85939, 3182, 450, 14, 70, 36, 0, "StyleData", "DefinitionBox5Col", \
"All"],
Cell[86392, 3198, 68, 1, 70, 52, 0, "StyleData", "DefinitionBox5Col", \
"Presentation"],
Cell[86463, 3201, 157, 4, 70, 48, 0, "StyleData", "DefinitionBox5Col", \
"Printout"],
Cell[86623, 3207, 191, 5, 70, 56, 0, "StyleData", "DefinitionBox5Col", \
"EnhancedPrintout"],
Cell[86817, 3214, 198, 5, 70, 63, 0, "StyleData", "DefinitionBox5Col", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[87052, 3224, 483, 14, 70, 36, 0, "StyleData", "DefinitionBox6Col", \
"All"],
Cell[87538, 3240, 68, 1, 70, 52, 0, "StyleData", "DefinitionBox6Col", \
"Presentation"],
Cell[87609, 3243, 157, 4, 70, 48, 0, "StyleData", "DefinitionBox6Col", \
"Printout"],
Cell[87769, 3249, 191, 5, 70, 56, 0, "StyleData", "DefinitionBox6Col", \
"EnhancedPrintout"],
Cell[87963, 3256, 198, 5, 70, 63, 0, "StyleData", "DefinitionBox6Col", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[88198, 3266, 492, 15, 70, 25, 0, "StyleData", "TopBox", "All",
  StyleMenuListing->None],
Cell[88693, 3283, 57, 1, 70, 41, 0, "StyleData", "TopBox", "Presentation"],
Cell[88753, 3286, 130, 3, 70, 37, 0, "StyleData", "TopBox", "Printout"],
Cell[88886, 3291, 164, 4, 70, 45, 0, "StyleData", "TopBox", \
"EnhancedPrintout"],
Cell[89053, 3297, 171, 4, 70, 52, 0, "StyleData", "TopBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[89261, 3306, 519, 16, 70, 28, 0, "StyleData", "MiddleBox", "All",
  StyleMenuListing->None],
Cell[89783, 3324, 60, 1, 70, 44, 0, "StyleData", "MiddleBox", \
"Presentation"],
Cell[89846, 3327, 133, 3, 70, 40, 0, "StyleData", "MiddleBox", "Printout"],
Cell[89982, 3332, 167, 4, 70, 48, 0, "StyleData", "MiddleBox", \
"EnhancedPrintout"],
Cell[90152, 3338, 174, 4, 70, 55, 0, "StyleData", "MiddleBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[90363, 3347, 521, 16, 70, 28, 0, "StyleData", "BottomBox", "All",
  StyleMenuListing->None],
Cell[90887, 3365, 60, 1, 70, 44, 0, "StyleData", "BottomBox", \
"Presentation"],
Cell[90950, 3368, 189, 5, 70, 40, 0, "StyleData", "BottomBox", "Printout"],
Cell[91142, 3375, 223, 6, 70, 48, 0, "StyleData", "BottomBox", \
"EnhancedPrintout"],
Cell[91368, 3383, 230, 6, 70, 55, 0, "StyleData", "BottomBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[91635, 3394, 496, 15, 70, 29, 0, "StyleData", "TopSpanBox", "All",
  StyleMenuListing->None],
Cell[92134, 3411, 61, 1, 70, 45, 0, "StyleData", "TopSpanBox", \
"Presentation"],
Cell[92198, 3414, 151, 4, 70, 41, 0, "StyleData", "TopSpanBox", "Printout"],
Cell[92352, 3420, 185, 5, 70, 49, 0, "StyleData", "TopSpanBox", \
"EnhancedPrintout"],
Cell[92540, 3427, 192, 5, 70, 56, 0, "StyleData", "TopSpanBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[92769, 3437, 521, 16, 70, 32, 0, "StyleData", "MiddleSpanBox", "All",
  StyleMenuListing->None],
Cell[93293, 3455, 64, 1, 70, 48, 0, "StyleData", "MiddleSpanBox", \
"Presentation"],
Cell[93360, 3458, 193, 5, 70, 44, 0, "StyleData", "MiddleSpanBox", \
"Printout"],
Cell[93556, 3465, 227, 6, 70, 52, 0, "StyleData", "MiddleSpanBox", \
"EnhancedPrintout"],
Cell[93786, 3473, 234, 6, 70, 59, 0, "StyleData", "MiddleSpanBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[94057, 3484, 168, 4, 70, 26, 0, "StyleData", "Picture", "All",
  StyleMenuListing->None],
Cell[94228, 3490, 58, 1, 70, 42, 0, "StyleData", "Picture", "Presentation"],
Cell[94289, 3493, 102, 2, 70, 38, 0, "StyleData", "Picture", "Printout"],
Cell[94394, 3497, 110, 2, 70, 46, 0, "StyleData", "Picture", \
"EnhancedPrintout"],
Cell[94507, 3501, 117, 2, 70, 53, 0, "StyleData", "Picture", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[94661, 3508, 232, 5, 70, 43, 0, "StyleData", "OpenCloseItemizedPicture", \
"All",
  StyleMenuListing->None],
Cell[94896, 3515, 75, 1, 70, 59, 0, "StyleData", "OpenCloseItemizedPicture", \
"Presentation"],
Cell[94974, 3518, 178, 4, 70, 55, 0, "StyleData", "OpenCloseItemizedPicture", \
"Printout"],
Cell[95155, 3524, 186, 4, 70, 63, 0, "StyleData", "OpenCloseItemizedPicture", \
"EnhancedPrintout"],
Cell[95344, 3530, 193, 4, 70, 70, 0, "StyleData", "OpenCloseItemizedPicture", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[95574, 3539, 168, 4, 70, 34, 0, "StyleData", "ItemizedPicture", "All",
  StyleMenuListing->None],
Cell[95745, 3545, 66, 1, 70, 50, 0, "StyleData", "ItemizedPicture", \
"Presentation"],
Cell[95814, 3548, 103, 2, 70, 46, 0, "StyleData", "ItemizedPicture", \
"Printout"],
Cell[95920, 3552, 112, 2, 70, 54, 0, "StyleData", "ItemizedPicture", \
"EnhancedPrintout"],
Cell[96035, 3556, 118, 2, 70, 61, 0, "StyleData", "ItemizedPicture", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[96190, 3563, 164, 4, 70, 30, 0, "StyleData", "ListGraphic", "All",
  StyleMenuListing->None],
Cell[96357, 3569, 62, 1, 70, 46, 0, "StyleData", "ListGraphic", \
"Presentation"],
Cell[96422, 3572, 99, 2, 70, 42, 0, "StyleData", "ListGraphic", "Printout"],
Cell[96524, 3576, 108, 2, 70, 50, 0, "StyleData", "ListGraphic", \
"EnhancedPrintout"],
Cell[96635, 3580, 114, 2, 70, 57, 0, "StyleData", "ListGraphic", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[96786, 3587, 364, 9, 70, 30, 0, "StyleData", "ListNoteBox", "All",
  StyleMenuListing->None],
Cell[97153, 3598, 62, 1, 70, 46, 0, "StyleData", "ListNoteBox", \
"Presentation"],
Cell[97218, 3601, 127, 3, 70, 42, 0, "StyleData", "ListNoteBox", "Printout"],
Cell[97348, 3606, 167, 4, 70, 50, 0, "StyleData", "ListNoteBox", \
"EnhancedPrintout"],
Cell[97518, 3612, 167, 4, 70, 57, 0, "StyleData", "ListNoteBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[97722, 3621, 165, 4, 70, 31, 0, "StyleData", "PictureGroup", "All",
  StyleMenuListing->None],
Cell[97890, 3627, 63, 1, 70, 47, 0, "StyleData", "PictureGroup", \
"Presentation"],
Cell[97956, 3630, 166, 4, 70, 43, 0, "StyleData", "PictureGroup", \
"Printout"],
Cell[98125, 3636, 174, 4, 70, 51, 0, "StyleData", "PictureGroup", \
"EnhancedPrintout"],
Cell[98302, 3642, 181, 4, 70, 58, 0, "StyleData", "PictureGroup", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[98520, 3651, 117, 3, 70, 24, 0, "StyleData", "Sound", "All",
  StyleMenuListing->None],
Cell[98640, 3656, 56, 1, 70, 40, 0, "StyleData", "Sound", "Presentation"],
Cell[98699, 3659, 85, 2, 70, 36, 0, "StyleData", "Sound", "Printout"],
Cell[98787, 3663, 93, 2, 70, 44, 0, "StyleData", "Sound", \
"EnhancedPrintout"],
Cell[98883, 3667, 100, 2, 70, 51, 0, "StyleData", "Sound", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[99020, 3674, 153, 5, 70, 26, 0, "StyleData", "Caption", "All",
  StyleMenuListing->None],
Cell[99176, 3681, 58, 1, 70, 42, 0, "StyleData", "Caption", "Presentation"],
Cell[99237, 3684, 86, 2, 70, 38, 0, "StyleData", "Caption", "Printout"],
Cell[99326, 3688, 126, 3, 70, 46, 0, "StyleData", "Caption", \
"EnhancedPrintout"],
Cell[99455, 3693, 134, 3, 70, 53, 0, "StyleData", "Caption", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[99638, 3702, 25, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[99688, 3706, 217, 6, 70, 31, 0, "StyleData", "2ColumnTable", "All",
  StyleMenuListing->None],
Cell[99908, 3714, 63, 1, 70, 47, 0, "StyleData", "2ColumnTable", \
"Presentation"],
Cell[99974, 3717, 91, 2, 70, 43, 0, "StyleData", "2ColumnTable", "Printout"],
Cell[100068, 3721, 99, 2, 70, 51, 0, "StyleData", "2ColumnTable", \
"EnhancedPrintout"],
Cell[100170, 3725, 106, 2, 70, 58, 0, "StyleData", "2ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[100313, 3732, 213, 6, 70, 35, 0, "StyleData", "2ColumnEvenTable", "All",
  StyleMenuListing->None],
Cell[100529, 3740, 67, 1, 70, 51, 0, "StyleData", "2ColumnEvenTable", \
"Presentation"],
Cell[100599, 3743, 95, 2, 70, 47, 0, "StyleData", "2ColumnEvenTable", \
"Printout"],
Cell[100697, 3747, 103, 2, 70, 55, 0, "StyleData", "2ColumnEvenTable", \
"EnhancedPrintout"],
Cell[100803, 3751, 110, 2, 70, 62, 0, "StyleData", "2ColumnEvenTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[100950, 3758, 223, 6, 70, 31, 0, "StyleData", "3ColumnTable", "All",
  StyleMenuListing->None],
Cell[101176, 3766, 63, 1, 70, 47, 0, "StyleData", "3ColumnTable", \
"Presentation"],
Cell[101242, 3769, 91, 2, 70, 43, 0, "StyleData", "3ColumnTable", \
"Printout"],
Cell[101336, 3773, 99, 2, 70, 51, 0, "StyleData", "3ColumnTable", \
"EnhancedPrintout"],
Cell[101438, 3777, 106, 2, 70, 58, 0, "StyleData", "3ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[101593, 3785, 43, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[101661, 3789, 410, 11, 70, 32, 0, "StyleData", "InlineFormula", "All",
  StyleMenuListing->None],
Cell[102074, 3802, 93, 2, 70, 44, 0, "StyleData", "InlineFormula", \
"Printout"],
Cell[102170, 3806, 101, 2, 70, 52, 0, "StyleData", "InlineFormula", \
"EnhancedPrintout"],
Cell[102274, 3810, 108, 2, 70, 59, 0, "StyleData", "InlineFormula", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[102419, 3817, 291, 7, 70, 31, 0, "StyleData", "InlineOutput", "All",
  StyleMenuListing->None],
Cell[102713, 3826, 93, 2, 70, 43, 0, "StyleData", "InlineOutput", \
"Printout"],
Cell[102809, 3830, 101, 2, 70, 51, 0, "StyleData", "InlineOutput", \
"EnhancedPrintout"],
Cell[102913, 3834, 108, 2, 70, 58, 0, "StyleData", "InlineOutput", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[103058, 3841, 463, 11, 70, 33, 0, "StyleData", "DisplayFormula", "All",
  StyleMenuListing->None],
Cell[103524, 3854, 65, 1, 70, 49, 0, "StyleData", "DisplayFormula", \
"Presentation"],
Cell[103592, 3857, 45, 0, 70, 45, 0, "StyleData", "DisplayFormula", \
"Printout"],
Cell[103640, 3859, 79, 1, 70, 53, 0, "StyleData", "DisplayFormula", \
"EnhancedPrintout"],
Cell[103722, 3862, 86, 1, 70, 60, 0, "StyleData", "DisplayFormula", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[103845, 3868, 536, 15, 70, 30, 0, "StyleData", "DisplayMath", "All",
  CounterIncrements->"Input"],
Cell[104384, 3885, 62, 1, 70, 46, 0, "StyleData", "DisplayMath", \
"Presentation"],
Cell[104449, 3888, 91, 2, 70, 42, 0, "StyleData", "DisplayMath", "Printout"],
Cell[104543, 3892, 127, 3, 70, 50, 0, "StyleData", "DisplayMath", \
"EnhancedPrintout"],
Cell[104673, 3897, 134, 3, 70, 57, 0, "StyleData", "DisplayMath", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[104844, 3905, 398, 9, 70, 35, 0, "StyleData", "NumberedEquation", "All",
  CounterIncrements->"NumberedEquation"],
Cell[105245, 3916, 67, 1, 70, 51, 0, "StyleData", "NumberedEquation", \
"Presentation"],
Cell[105315, 3919, 99, 2, 70, 47, 0, "StyleData", "NumberedEquation", \
"Printout"],
Cell[105417, 3923, 133, 3, 70, 55, 0, "StyleData", "NumberedEquation", \
"EnhancedPrintout"],
Cell[105553, 3928, 140, 3, 70, 62, 0, "StyleData", "NumberedEquation", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[105730, 3936, 148, 3, 70, 33, 0, "StyleData", "EquationNumber", "All"],
Cell[105881, 3941, 65, 1, 70, 49, 0, "StyleData", "EquationNumber", \
"Presentation"],
Cell[105949, 3944, 70, 1, 70, 45, 0, "StyleData", "EquationNumber", \
"Printout"],
Cell[106022, 3947, 104, 2, 70, 53, 0, "StyleData", "EquationNumber", \
"EnhancedPrintout"],
Cell[106129, 3951, 111, 2, 70, 60, 0, "StyleData", "EquationNumber", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[106277, 3958, 225, 6, 70, 26, 0, "StyleData", "Program", "All"],
Cell[106505, 3966, 58, 1, 70, 42, 0, "StyleData", "Program", "Presentation"],
Cell[106566, 3969, 98, 2, 70, 38, 0, "StyleData", "Program", "Printout"],
Cell[106667, 3973, 134, 3, 70, 46, 0, "StyleData", "Program", \
"EnhancedPrintout"],
Cell[106804, 3978, 141, 3, 70, 53, 0, "StyleData", "Program", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[106994, 3987, 45, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[107064, 3991, 46, 3, 70, "Subsection"],

Cell[CellGroupData[{
Cell[107135, 3998, 315, 9, 70, 34, 0, "StyleData", "InspectorLevel1", "All",
  StyleMenuListing->None],
Cell[107453, 4009, 66, 1, 70, 50, 0, "StyleData", "InspectorLevel1", \
"Presentation"],
Cell[107522, 4012, 100, 1, 70, 47, 0, "StyleData", "InspectorLevel1", \
"SlideShow"],
Cell[107625, 4015, 115, 2, 70, 46, 0, "StyleData", "InspectorLevel1", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[107777, 4022, 245, 7, 70, 34, 0, "StyleData", "InspectorLevel2", "All",
  StyleMenuListing->None],
Cell[108025, 4031, 66, 1, 70, 50, 0, "StyleData", "InspectorLevel2", \
"Presentation"],
Cell[108094, 4034, 303, 8, 70, 47, 0, "StyleData", "InspectorLevel2", \
"SlideShow"],
Cell[108400, 4044, 115, 2, 70, 46, 0, "StyleData", "InspectorLevel2", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[108552, 4051, 435, 11, 70, 29, 0, "StyleData", "ObjectName", "All",
  StyleMenuListing->None],
Cell[108990, 4064, 61, 1, 70, 45, 0, "StyleData", "ObjectName", \
"Presentation"],
Cell[109054, 4067, 265, 7, 70, 42, 0, "StyleData", "ObjectName", "SlideShow",
  StyleMenuListing->None],
Cell[109322, 4076, 199, 4, 70, 41, 0, "StyleData", "ObjectName", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[109558, 4085, 348, 9, 70, 38, 0, "StyleData", "SubObjectNameClosed", \
"All",
  StyleMenuListing->None],
Cell[109909, 4096, 70, 1, 70, 54, 0, "StyleData", "SubObjectNameClosed", \
"Presentation"],
Cell[109982, 4099, 228, 6, 70, 51, 0, "StyleData", "SubObjectNameClosed", \
"SlideShow",
  StyleMenuListing->None],
Cell[110213, 4107, 153, 3, 70, 50, 0, "StyleData", "SubObjectNameClosed", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[110403, 4115, 241, 7, 70, 32, 0, "StyleData", "SubObjectName", "All",
  StyleMenuListing->None],
Cell[110647, 4124, 64, 1, 70, 48, 0, "StyleData", "SubObjectName", \
"Presentation"],
Cell[110714, 4127, 206, 5, 70, 45, 0, "StyleData", "SubObjectName", \
"SlideShow"],
Cell[110923, 4134, 172, 4, 70, 44, 0, "StyleData", "SubObjectName", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[111132, 4143, 243, 7, 70, 34, 0, "StyleData", "GroupObjectName", "All",
  StyleMenuListing->None],
Cell[111378, 4152, 66, 1, 70, 50, 0, "StyleData", "GroupObjectName", \
"Presentation"],
Cell[111447, 4155, 334, 9, 70, 47, 0, "StyleData", "GroupObjectName", \
"SlideShow",
  CounterIncrements->"Outline2"],
Cell[111784, 4166, 115, 2, 70, 46, 0, "StyleData", "GroupObjectName", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[111936, 4173, 350, 9, 70, 40, 0, "StyleData", "GroupObjectNameClosed", \
"All",
  StyleMenuListing->None],
Cell[112289, 4184, 72, 1, 70, 56, 0, "StyleData", "GroupObjectNameClosed", \
"Presentation"],
Cell[112364, 4187, 340, 9, 70, 53, 0, "StyleData", "GroupObjectNameClosed", \
"SlideShow",
  CounterIncrements->"Outline2"],
Cell[112707, 4198, 121, 2, 70, 52, 0, "StyleData", "GroupObjectNameClosed", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[112865, 4205, 267, 7, 70, 44, 0, "StyleData", \
"ObjectNameWarningMessages", "All",
  StyleMenuListing->None],
Cell[113135, 4214, 76, 1, 70, 60, 0, "StyleData", \
"ObjectNameWarningMessages", "Presentation"],
Cell[113214, 4217, 254, 6, 70, 57, 0, "StyleData", \
"ObjectNameWarningMessages", "SlideShow"],
Cell[113471, 4225, 159, 3, 70, 56, 0, "StyleData", \
"ObjectNameWarningMessages", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[113667, 4233, 420, 11, 70, 26, 0, "StyleData", "Command", "All",
  CounterIncrements->"Section",
  StyleMenuListing->None],
Cell[114090, 4246, 58, 1, 70, 42, 0, "StyleData", "Command", "Presentation"],
Cell[114151, 4249, 221, 5, 70, 38, 0, "StyleData", "Command", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[114409, 4259, 328, 7, 70, 32, 0, "StyleData", "CharacterName", "All",
  StyleMenuListing->None],
Cell[114740, 4268, 64, 1, 70, 48, 0, "StyleData", "CharacterName", \
"Presentation"],
Cell[114807, 4271, 268, 7, 70, 45, 0, "StyleData", "CharacterName", \
"SlideShow",
  StyleMenuListing->None],
Cell[115078, 4280, 146, 3, 70, 44, 0, "StyleData", "CharacterName", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[115261, 4288, 394, 10, 70, 24, 0, "StyleData", "Usage", "All",
  StyleMenuListing->None],
Cell[115658, 4300, 56, 1, 70, 40, 0, "StyleData", "Usage", "Presentation"],
Cell[115717, 4303, 260, 7, 70, 37, 0, "StyleData", "Usage", "SlideShow",
  StyleMenuListing->None],
Cell[115980, 4312, 242, 6, 70, 36, 0, "StyleData", "Usage", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[116259, 4323, 563, 16, 70, 31, 0, "StyleData", "ErrorMessage", "All",
  StyleMenuListing->None],
Cell[116825, 4341, 63, 1, 70, 47, 0, "StyleData", "ErrorMessage", \
"Presentation"],
Cell[116891, 4344, 190, 4, 70, 44, 0, "StyleData", "ErrorMessage", \
"SlideShow",
  StyleMenuListing->None],
Cell[117084, 4350, 138, 3, 70, 43, 0, "StyleData", "ErrorMessage", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[117259, 4358, 246, 7, 70, 24, 0, "StyleData", "Notes", "All",
  StyleMenuListing->None],
Cell[117508, 4367, 56, 1, 70, 40, 0, "StyleData", "Notes", "Presentation"],
Cell[117567, 4370, 258, 7, 70, 37, 0, "StyleData", "Notes", "SlideShow",
  StyleMenuListing->None],
Cell[117828, 4379, 159, 4, 70, 36, 0, "StyleData", "Notes", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[118024, 4388, 191, 6, 70, 28, 0, "StyleData", "NotesList", "All",
  StyleMenuListing->None],
Cell[118218, 4396, 60, 1, 70, 44, 0, "StyleData", "NotesList", \
"Presentation"],
Cell[118281, 4399, 257, 7, 70, 41, 0, "StyleData", "NotesList", "SlideShow",
  StyleMenuListing->None],
Cell[118541, 4408, 163, 4, 70, 40, 0, "StyleData", "NotesList", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[118741, 4417, 333, 9, 70, 35, 0, "StyleData", "ReferenceSection", "All",
  StyleMenuListing->None],
Cell[119077, 4428, 67, 1, 70, 51, 0, "StyleData", "ReferenceSection", \
"Presentation"],
Cell[119147, 4431, 201, 5, 70, 47, 0, "StyleData", "ReferenceSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[119385, 4441, 1354, 32, 70, 28, 0, "StyleData", "Reference", "All",
  CounterIncrements->"Reference"],
Cell[120742, 4475, 60, 1, 70, 44, 0, "StyleData", "Reference", \
"Presentation"],
Cell[120805, 4478, 114, 3, 70, 41, 0, "StyleData", "Reference", "SlideShow"],
Cell[120922, 4483, 134, 4, 70, 40, 0, "StyleData", "Reference", "Printout"],
Cell[121059, 4489, 168, 5, 70, 48, 0, "StyleData", "Reference", \
"EnhancedPrintout"],
Cell[121230, 4496, 175, 5, 70, 55, 0, "StyleData", "Reference", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[121442, 4506, 331, 9, 70, 33, 0, "StyleData", "ExampleSection", "All",
  StyleMenuListing->None],
Cell[121776, 4517, 65, 1, 70, 49, 0, "StyleData", "ExampleSection", \
"Presentation"],
Cell[121844, 4520, 199, 5, 70, 45, 0, "StyleData", "ExampleSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[122080, 4530, 207, 5, 70, 30, 0, "StyleData", "ExampleText", "All",
  StyleMenuListing->None],
Cell[122290, 4537, 62, 1, 70, 46, 0, "StyleData", "ExampleText", \
"Presentation"],
Cell[122355, 4540, 217, 6, 70, 42, 0, "StyleData", "ExampleText", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[122609, 4551, 286, 8, 70, 36, 0, "StyleData", "ExampleSubsection", "All",
  
  StyleMenuListing->None],
Cell[122898, 4561, 68, 1, 70, 52, 0, "StyleData", "ExampleSubsection", \
"Presentation"],
Cell[122969, 4564, 176, 4, 70, 48, 0, "StyleData", "ExampleSubsection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[123182, 4573, 332, 9, 70, 34, 0, "StyleData", "MessagesSection", "All",
  StyleMenuListing->None],
Cell[123517, 4584, 66, 1, 70, 50, 0, "StyleData", "MessagesSection", \
"Presentation"],
Cell[123586, 4587, 200, 5, 70, 46, 0, "StyleData", "MessagesSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[123823, 4597, 354, 9, 70, 34, 0, "StyleData", "TemplateSection", "All",
  StyleMenuListing->None],
Cell[124180, 4608, 66, 1, 70, 50, 0, "StyleData", "TemplateSection", \
"Presentation"],
Cell[124249, 4611, 200, 5, 70, 46, 0, "StyleData", "TemplateSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[124486, 4621, 320, 9, 70, 27, 0, "StyleData", "LineHead", "All",
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}},
  StyleMenuListing->None],
Cell[124809, 4632, 59, 1, 70, 43, 0, "StyleData", "LineHead", \
"Presentation"],
Cell[124871, 4635, 167, 4, 70, 39, 0, "StyleData", "LineHead", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[125075, 4644, 566, 16, 70, 29, 0, "StyleData", "FlushInput", "All",
  StyleMenuListing->None],
Cell[125644, 4662, 61, 1, 70, 45, 0, "StyleData", "FlushInput", \
"Presentation"],
Cell[125708, 4665, 143, 3, 70, 41, 0, "StyleData", "FlushInput", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[125888, 4673, 540, 14, 70, 30, 0, "StyleData", "FlushOutput", "All",
  StyleMenuListing->None],
Cell[126431, 4689, 62, 1, 70, 46, 0, "StyleData", "FlushOutput", \
"Presentation"],
Cell[126496, 4692, 168, 3, 70, 42, 0, "StyleData", "FlushOutput", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[126701, 4700, 288, 8, 70, 29, 0, "StyleData", "DialogItem", "All",
  StyleMenuListing->None],
Cell[126992, 4710, 61, 1, 70, 45, 0, "StyleData", "DialogItem", \
"Presentation"],
Cell[127056, 4713, 169, 4, 70, 41, 0, "StyleData", "DialogItem", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[127262, 4722, 238, 5, 70, 31, 0, "StyleData", "GroupDivider", "All",
  StyleMenuListing->None],
Cell[127503, 4729, 63, 1, 70, 47, 0, "StyleData", "GroupDivider", \
"Presentation"]
}, Closed]],

Cell[CellGroupData[{
Cell[127603, 4735, 277, 8, 70, 28, 0, "StyleData", "Highlight", "All",
  StyleMenuListing->None],
Cell[127883, 4745, 60, 1, 70, 44, 0, "StyleData", "Highlight", \
"Presentation"],
Cell[127946, 4748, 186, 5, 70, 40, 0, "StyleData", "Highlight", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[128169, 4758, 242, 7, 70, 28, 0, "StyleData", "UserNotes", "All",
  StyleMenuListing->None],
Cell[128414, 4767, 60, 1, 70, 44, 0, "StyleData", "UserNotes", \
"Presentation"],
Cell[128477, 4770, 185, 5, 70, 40, 0, "StyleData", "UserNotes", "Printout"],
Cell[128665, 4777, 172, 5, 70, 48, 0, "StyleData", "UserNotes", \
"EnhancedPrintout"],
Cell[128840, 4784, 179, 5, 70, 55, 0, "StyleData", "UserNotes", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[129056, 4794, 283, 8, 70, 27, 0, "StyleData", "MoreInfo", "All",
  StyleMenuListing->None],
Cell[129342, 4804, 59, 1, 70, 43, 0, "StyleData", "MoreInfo", \
"Presentation"],
Cell[129404, 4807, 184, 5, 70, 39, 0, "StyleData", "MoreInfo", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[129625, 4817, 283, 8, 70, 27, 0, "StyleData", "UserTips", "All",
  StyleMenuListing->None],
Cell[129911, 4827, 59, 1, 70, 43, 0, "StyleData", "UserTips", \
"Presentation"],
Cell[129973, 4830, 258, 7, 70, 39, 0, "StyleData", "UserTips", "Printout"],
Cell[130234, 4839, 291, 8, 70, 47, 0, "StyleData", "UserTips", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[130562, 4852, 259, 7, 70, 26, 0, "StyleData", "Theorem", "All"],
Cell[130824, 4861, 58, 1, 70, 42, 0, "StyleData", "Theorem", "Presentation"],
Cell[130885, 4864, 224, 6, 70, 38, 0, "StyleData", "Theorem", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[131146, 4875, 228, 7, 70, 29, 0, "StyleData", "Commentary", "All"],
Cell[131377, 4884, 61, 1, 70, 45, 0, "StyleData", "Commentary", \
"Presentation"],
Cell[131441, 4887, 125, 3, 70, 41, 0, "StyleData", "Commentary", "Printout"],
Cell[131569, 4892, 159, 4, 70, 49, 0, "StyleData", "Commentary", \
"EnhancedPrintout"],
Cell[131731, 4898, 166, 4, 70, 56, 0, "StyleData", "Commentary", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[131934, 4907, 235, 6, 70, 29, 0, "StyleData", "Level1Icon", "All",
  StyleMenuListing->None],
Cell[132172, 4915, 61, 1, 70, 45, 0, "StyleData", "Level1Icon", \
"Presentation"],
Cell[132236, 4918, 143, 3, 70, 41, 0, "StyleData", "Level1Icon", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[132416, 4926, 235, 6, 70, 29, 0, "StyleData", "Level2Icon", "All",
  StyleMenuListing->None],
Cell[132654, 4934, 61, 1, 70, 45, 0, "StyleData", "Level2Icon", \
"Presentation"],
Cell[132718, 4937, 143, 3, 70, 41, 0, "StyleData", "Level2Icon", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[132898, 4945, 182, 6, 70, 32, 0, "StyleData", "CopyrightHead", "All",
  StyleMenuListing->None],
Cell[133083, 4953, 64, 1, 70, 48, 0, "StyleData", "CopyrightHead", \
"Presentation"],
Cell[133150, 4956, 117, 3, 70, 44, 0, "StyleData", "CopyrightHead", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[133304, 4964, 156, 5, 70, 28, 0, "StyleData", "Copyright", "All",
  StyleMenuListing->None],
Cell[133463, 4971, 60, 1, 70, 44, 0, "StyleData", "Copyright", \
"Presentation"],
Cell[133526, 4974, 112, 3, 70, 40, 0, "StyleData", "Copyright", "Printout"],
Cell[133641, 4979, 152, 4, 70, 48, 0, "StyleData", "Copyright", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[133830, 4988, 1477, 35, 70, 37, 0, "StyleData", "RegisterSubsection", \
"All"],
Cell[135310, 5025, 69, 1, 70, 53, 0, "StyleData", "RegisterSubsection", \
"Presentation"],
Cell[135382, 5028, 122, 3, 70, 50, 0, "StyleData", "RegisterSubsection", \
"SlideShow"],
Cell[135507, 5033, 99, 2, 70, 49, 0, "StyleData", "RegisterSubsection", \
"Printout"],
Cell[135609, 5037, 139, 3, 70, 57, 0, "StyleData", "RegisterSubsection", \
"EnhancedPrintout"],
Cell[135751, 5042, 146, 3, 70, 64, 0, "StyleData", "RegisterSubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[135934, 5050, 1490, 34, 70, 40, 0, "StyleData", "RegisterSubsubsection", \
"All"],
Cell[137427, 5086, 72, 1, 70, 56, 0, "StyleData", "RegisterSubsubsection", \
"Presentation"],
Cell[137502, 5089, 101, 2, 70, 52, 0, "StyleData", "RegisterSubsubsection", \
"Printout"],
Cell[137606, 5093, 190, 5, 70, 60, 0, "StyleData", "RegisterSubsubsection", \
"EnhancedPrintout"],
Cell[137799, 5100, 197, 5, 70, 67, 0, "StyleData", "RegisterSubsubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[138033, 5110, 132, 4, 70, 31, 0, "StyleData", "RegisterText", "All",
  StyleMenuListing->None],
Cell[138168, 5116, 63, 1, 70, 47, 0, "StyleData", "RegisterText", \
"Presentation"],
Cell[138234, 5119, 115, 3, 70, 43, 0, "StyleData", "RegisterText", \
"Printout"],
Cell[138352, 5124, 149, 4, 70, 51, 0, "StyleData", "RegisterText", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[138538, 5133, 180, 6, 70, 30, 0, "StyleData", "CaptionHead", "All",
  StyleMenuListing->None],
Cell[138721, 5141, 62, 1, 70, 46, 0, "StyleData", "CaptionHead", \
"Presentation"],
Cell[138786, 5144, 114, 3, 70, 42, 0, "StyleData", "CaptionHead", \
"Printout"],
Cell[138903, 5149, 148, 4, 70, 50, 0, "StyleData", "CaptionHead", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[139088, 5158, 115, 3, 70, 30, 0, "StyleData", "CaptionText", "All",
  StyleMenuListing->None],
Cell[139206, 5163, 62, 1, 70, 46, 0, "StyleData", "CaptionText", \
"Presentation"],
Cell[139271, 5166, 114, 3, 70, 42, 0, "StyleData", "CaptionText", \
"Printout"],
Cell[139388, 5171, 148, 4, 70, 50, 0, "StyleData", "CaptionText", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[139573, 5180, 301, 8, 70, 29, 0, "StyleData", "BulletText", "All",
  CounterIncrements->"BulletText",
  StyleMenuListing->None],
Cell[139877, 5190, 61, 1, 70, 45, 0, "StyleData", "BulletText", \
"Presentation"],
Cell[139941, 5193, 57, 1, 70, 41, 0, "StyleData", "BulletText", "Printout"],
Cell[140001, 5196, 125, 3, 70, 49, 0, "StyleData", "BulletText", \
"EnhancedPrintout"],
Cell[140129, 5201, 98, 2, 70, 56, 0, "StyleData", "BulletText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[140264, 5208, 89, 2, 70, 29, 0, "StyleData", "HelpLabels", "All",
  StyleMenuListing->None],
Cell[140356, 5212, 61, 1, 70, 45, 0, "StyleData", "HelpLabels", \
"Presentation"],
Cell[140420, 5215, 91, 2, 70, 41, 0, "StyleData", "HelpLabels", "Printout"],
Cell[140514, 5219, 125, 3, 70, 49, 0, "StyleData", "HelpLabels", \
"EnhancedPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[140688, 5228, 37, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[140750, 5232, 38, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[140813, 5236, 290, 9, 70, 31, 0, "StyleData", "FunctionName", "All",
  StyleMenuListing->None,
  CellTags->"FunctionName"],
Cell[141106, 5247, 63, 1, 70, 47, 0, "StyleData", "FunctionName", \
"Presentation"],
Cell[141172, 5250, 94, 2, 70, 43, 0, "StyleData", "FunctionName", \
"Printout"],
Cell[141269, 5254, 127, 3, 70, 51, 0, "StyleData", "FunctionName", \
"EnhancedPrintout"],
Cell[141399, 5259, 134, 3, 70, 58, 0, "StyleData", "FunctionName", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[141570, 5267, 259, 7, 70, 37, 0, "StyleData", "FunctionSubsection", \
"All",
  StyleMenuListing->None,
  CellTags->"FunctionSubsection"],
Cell[141832, 5276, 69, 1, 70, 53, 0, "StyleData", "FunctionSubsection", \
"Presentation"],
Cell[141904, 5279, 83, 1, 70, 49, 0, "StyleData", "FunctionSubsection", \
"Printout"],
Cell[141990, 5282, 133, 3, 70, 57, 0, "StyleData", "FunctionSubsection", \
"EnhancedPrintout"],
Cell[142126, 5287, 140, 3, 70, 64, 0, "StyleData", "FunctionSubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[142303, 5295, 219, 6, 70, 38, 0, "StyleData", "FunctionDescription", \
"All",
  CounterIncrements->"FunctionDescription",
  StyleMenuListing->None],
Cell[142525, 5303, 70, 1, 70, 54, 0, "StyleData", "FunctionDescription", \
"Presentation"],
Cell[142598, 5306, 100, 2, 70, 50, 0, "StyleData", "FunctionDescription", \
"Printout"],
Cell[142701, 5310, 158, 4, 70, 58, 0, "StyleData", "FunctionDescription", \
"EnhancedPrintout"],
Cell[142862, 5316, 165, 4, 70, 65, 0, "StyleData", "FunctionDescription", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[143064, 5325, 243, 6, 70, 43, 0, "StyleData", \
"FunctionDescriptionRuled", "All",
  CounterIncrements->"FunctionDescriptionRuled",
  StyleMenuListing->None],
Cell[143310, 5333, 75, 1, 70, 59, 0, "StyleData", "FunctionDescriptionRuled", \
"Presentation"],
Cell[143388, 5336, 105, 2, 70, 55, 0, "StyleData", \
"FunctionDescriptionRuled", "Printout"],
Cell[143496, 5340, 163, 4, 70, 63, 0, "StyleData", \
"FunctionDescriptionRuled", "EnhancedPrintout"],
Cell[143662, 5346, 170, 4, 70, 70, 0, "StyleData", \
"FunctionDescriptionRuled", "EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[143869, 5355, 244, 6, 70, 45, 0, "StyleData", \
"FunctionDescriptionRuleTop", "All",
  CounterIncrements->"FunctionDescriptionRuleTop",
  StyleMenuListing->None],
Cell[144116, 5363, 77, 1, 70, 61, 0, "StyleData", \
"FunctionDescriptionRuleTop", "Presentation"],
Cell[144196, 5366, 107, 2, 70, 57, 0, "StyleData", \
"FunctionDescriptionRuleTop", "Printout"],
Cell[144306, 5370, 165, 4, 70, 65, 0, "StyleData", \
"FunctionDescriptionRuleTop", "EnhancedPrintout"],
Cell[144474, 5376, 174, 5, 70, 74, 1, "StyleData", \
"FunctionDescriptionRuleTop", "EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[144685, 5386, 250, 6, 70, 48, 0, "StyleData", \
"FunctionDescriptionRuleBottom", "All",
  CounterIncrements->"FunctionDescriptionRuleBottom",
  StyleMenuListing->None],
Cell[144938, 5394, 80, 1, 70, 64, 0, "StyleData", \
"FunctionDescriptionRuleBottom", "Presentation"],
Cell[145021, 5397, 110, 2, 70, 60, 0, "StyleData", \
"FunctionDescriptionRuleBottom", "Printout"],
Cell[145134, 5401, 168, 4, 70, 68, 0, "StyleData", \
"FunctionDescriptionRuleBottom", "EnhancedPrintout"],
Cell[145305, 5407, 177, 5, 70, 77, 1, "StyleData", \
"FunctionDescriptionRuleBottom", "EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[145519, 5417, 111, 3, 70, 34, 0, "StyleData", "FunctionExample", "All",
  StyleMenuListing->None],
Cell[145633, 5422, 66, 1, 70, 50, 0, "StyleData", "FunctionExample", \
"Presentation"],
Cell[145702, 5425, 95, 2, 70, 46, 0, "StyleData", "FunctionExample", \
"Printout"],
Cell[145800, 5429, 129, 3, 70, 54, 0, "StyleData", "FunctionExample", \
"EnhancedPrintout"],
Cell[145932, 5434, 136, 3, 70, 61, 0, "StyleData", "FunctionExample", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[146105, 5442, 163, 5, 70, 35, 0, "StyleData", "FunctionTextNote", "All",
  StyleMenuListing->None],
Cell[146271, 5449, 67, 1, 70, 51, 0, "StyleData", "FunctionTextNote", \
"Presentation"],
Cell[146341, 5452, 96, 2, 70, 47, 0, "StyleData", "FunctionTextNote", \
"Printout"],
Cell[146440, 5456, 130, 3, 70, 55, 0, "StyleData", "FunctionTextNote", \
"EnhancedPrintout"],
Cell[146573, 5461, 137, 3, 70, 62, 0, "StyleData", "FunctionTextNote", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[146747, 5469, 341, 11, 70, 39, 0, "StyleData", "3ColumnFunctionTable", \
"All",
  StyleMenuListing->None],
Cell[147091, 5482, 71, 1, 70, 55, 0, "StyleData", "3ColumnFunctionTable", \
"Presentation"],
Cell[147165, 5485, 101, 2, 70, 51, 0, "StyleData", "3ColumnFunctionTable", \
"Printout"],
Cell[147269, 5489, 109, 2, 70, 59, 0, "StyleData", "3ColumnFunctionTable", \
"EnhancedPrintout"],
Cell[147381, 5493, 116, 2, 70, 66, 0, "StyleData", "3ColumnFunctionTable", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[147546, 5501, 42, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[147613, 5505, 187, 6, 70, 29, 0, "StyleData", "TextNormal", "All",
  CounterIncrements->"TextNormal",
  StyleMenuListing->None],
Cell[147803, 5513, 61, 1, 70, 45, 0, "StyleData", "TextNormal", \
"Presentation"],
Cell[147867, 5516, 90, 2, 70, 41, 0, "StyleData", "TextNormal", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[147994, 5523, 325, 10, 70, 35, 0, "StyleData", "BrowserEmulation", "All",
  
  StyleMenuListing->None],
Cell[148322, 5535, 67, 1, 70, 51, 0, "StyleData", "BrowserEmulation", \
"Presentation"],
Cell[148392, 5538, 96, 2, 70, 47, 0, "StyleData", "BrowserEmulation", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[148525, 5545, 285, 9, 70, 31, 0, "StyleData", "CategoryDefs", "All",
  StyleMenuListing->None],
Cell[148813, 5556, 63, 1, 70, 47, 0, "StyleData", "CategoryDefs", \
"Presentation"],
Cell[148879, 5559, 92, 2, 70, 43, 0, "StyleData", "CategoryDefs", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[149008, 5566, 231, 7, 70, 28, 0, "StyleData", "Category1", "All",
  StyleMenuListing->None],
Cell[149242, 5575, 60, 1, 70, 44, 0, "StyleData", "Category1", \
"Presentation"],
Cell[149305, 5578, 73, 1, 70, 40, 0, "StyleData", "Category1", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[149415, 5584, 270, 8, 70, 28, 0, "StyleData", "Category2", "All",
  StyleMenuListing->None],
Cell[149688, 5594, 60, 1, 70, 44, 0, "StyleData", "Category2", \
"Presentation"],
Cell[149751, 5597, 73, 1, 70, 40, 0, "StyleData", "Category2", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[149861, 5603, 268, 8, 70, 28, 0, "StyleData", "Category3", "All",
  StyleMenuListing->None],
Cell[150132, 5613, 60, 1, 70, 44, 0, "StyleData", "Category3", \
"Presentation"],
Cell[150195, 5616, 73, 1, 70, 40, 0, "StyleData", "Category3", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[150305, 5622, 257, 7, 70, 28, 0, "StyleData", "Category4", "All",
  StyleMenuListing->None],
Cell[150565, 5631, 60, 1, 70, 44, 0, "StyleData", "Category4", \
"Presentation"],
Cell[150628, 5634, 73, 1, 70, 40, 0, "StyleData", "Category4", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[150750, 5641, 29, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[150804, 5645, 327, 11, 70, 31, 0, "StyleData", "4ColumnTable", "All",
  StyleMenuListing->None],
Cell[151134, 5658, 63, 1, 70, 47, 0, "StyleData", "4ColumnTable", \
"Presentation"],
Cell[151200, 5661, 76, 1, 70, 43, 0, "StyleData", "4ColumnTable", \
"Printout"],
Cell[151279, 5664, 84, 1, 70, 51, 0, "StyleData", "4ColumnTable", \
"EnhancedPrintout"],
Cell[151366, 5667, 91, 1, 70, 58, 0, "StyleData", "4ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[151494, 5673, 326, 11, 70, 31, 0, "StyleData", "5ColumnTable", "All",
  StyleMenuListing->None],
Cell[151823, 5686, 63, 1, 70, 47, 0, "StyleData", "5ColumnTable", \
"Presentation"],
Cell[151889, 5689, 76, 1, 70, 43, 0, "StyleData", "5ColumnTable", \
"Printout"],
Cell[151968, 5692, 84, 1, 70, 51, 0, "StyleData", "5ColumnTable", \
"EnhancedPrintout"],
Cell[152055, 5695, 91, 1, 70, 58, 0, "StyleData", "5ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[152183, 5701, 327, 11, 70, 31, 0, "StyleData", "6ColumnTable", "All",
  StyleMenuListing->None],
Cell[152513, 5714, 63, 1, 70, 47, 0, "StyleData", "6ColumnTable", \
"Presentation"],
Cell[152579, 5717, 76, 1, 70, 43, 0, "StyleData", "6ColumnTable", \
"Printout"],
Cell[152658, 5720, 84, 1, 70, 51, 0, "StyleData", "6ColumnTable", \
"EnhancedPrintout"],
Cell[152745, 5723, 91, 1, 70, 58, 0, "StyleData", "6ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[152873, 5729, 327, 11, 70, 31, 0, "StyleData", "7ColumnTable", "All",
  StyleMenuListing->None],
Cell[153203, 5742, 63, 1, 70, 47, 0, "StyleData", "7ColumnTable", \
"Presentation"],
Cell[153269, 5745, 76, 1, 70, 43, 0, "StyleData", "7ColumnTable", \
"Printout"],
Cell[153348, 5748, 84, 1, 70, 51, 0, "StyleData", "7ColumnTable", \
"EnhancedPrintout"],
Cell[153435, 5751, 91, 1, 70, 58, 0, "StyleData", "7ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[153563, 5757, 327, 11, 70, 31, 0, "StyleData", "8ColumnTable", "All",
  StyleMenuListing->None],
Cell[153893, 5770, 63, 1, 70, 47, 0, "StyleData", "8ColumnTable", \
"Presentation"],
Cell[153959, 5773, 76, 1, 70, 43, 0, "StyleData", "8ColumnTable", \
"Printout"],
Cell[154038, 5776, 84, 1, 70, 51, 0, "StyleData", "8ColumnTable", \
"EnhancedPrintout"],
Cell[154125, 5779, 91, 1, 70, 58, 0, "StyleData", "8ColumnTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[154253, 5785, 177, 5, 70, 33, 0, "StyleData", "ABItemizedText", "All",
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],
Cell[154433, 5792, 65, 1, 70, 49, 0, "StyleData", "ABItemizedText", \
"Presentation"],
Cell[154501, 5795, 106, 3, 70, 45, 0, "StyleData", "ABItemizedText", \
"Printout"],
Cell[154610, 5800, 140, 4, 70, 53, 0, "StyleData", "ABItemizedText", \
"EnhancedPrintout"],
Cell[154753, 5806, 147, 4, 70, 60, 0, "StyleData", "ABItemizedText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[154937, 5815, 1721, 41, 70, 29, 0, "StyleData", "ChapNumber", "All",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
      "Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None],
Cell[156661, 5858, 61, 1, 70, 45, 0, "StyleData", "ChapNumber", \
"Presentation"],
Cell[156725, 5861, 93, 2, 70, 41, 0, "StyleData", "ChapNumber", "Printout"],
Cell[156821, 5865, 160, 4, 70, 49, 0, "StyleData", "ChapNumber", \
"EnhancedPrintout"],
Cell[156984, 5871, 167, 4, 70, 56, 0, "StyleData", "ChapNumber", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[157188, 5880, 1719, 41, 70, 28, 0, "StyleData", "ChapTitle", "All",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
      "Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None],
Cell[158910, 5923, 60, 1, 70, 44, 0, "StyleData", "ChapTitle", \
"Presentation"],
Cell[158973, 5926, 91, 2, 70, 40, 0, "StyleData", "ChapTitle", "Printout"],
Cell[159067, 5930, 180, 5, 70, 48, 0, "StyleData", "ChapTitle", \
"EnhancedPrintout"],
Cell[159250, 5937, 160, 4, 70, 55, 0, "StyleData", "ChapTitle", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[159447, 5946, 124, 4, 70, 30, 0, "StyleData", "ItemDingbat", "All",
  StyleMenuListing->None],
Cell[159574, 5952, 62, 1, 70, 46, 0, "StyleData", "ItemDingbat", \
"Presentation"],
Cell[159639, 5955, 68, 1, 70, 42, 0, "StyleData", "ItemDingbat", "Printout"],
Cell[159710, 5958, 72, 1, 70, 50, 0, "StyleData", "ItemDingbat", \
"EnhancedPrintout"],
Cell[159785, 5961, 79, 1, 70, 57, 0, "StyleData", "ItemDingbat", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[159901, 5967, 138, 4, 70, 24, 0, "StyleData", "Item1", "All",
  CounterIncrements->"Item1",
  StyleMenuListing->None],
Cell[160042, 5973, 56, 1, 70, 40, 0, "StyleData", "Item1", "Presentation"],
Cell[160101, 5976, 86, 2, 70, 36, 0, "StyleData", "Item1", "Printout"],
Cell[160190, 5980, 94, 2, 70, 44, 0, "StyleData", "Item1", \
"EnhancedPrintout"],
Cell[160287, 5984, 101, 2, 70, 51, 0, "StyleData", "Item1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[160425, 5991, 132, 3, 70, 33, 0, "StyleData", "Item1Continued", "All",
  CounterIncrements->"Item1Continued",
  StyleMenuListing->None],
Cell[160560, 5996, 65, 1, 70, 49, 0, "StyleData", "Item1Continued", \
"Presentation"],
Cell[160628, 5999, 95, 2, 70, 45, 0, "StyleData", "Item1Continued", \
"Printout"],
Cell[160726, 6003, 103, 2, 70, 53, 0, "StyleData", "Item1Continued", \
"EnhancedPrintout"],
Cell[160832, 6007, 110, 2, 70, 60, 0, "StyleData", "Item1Continued", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[160979, 6014, 138, 4, 70, 24, 0, "StyleData", "Item2", "All",
  CounterIncrements->"Item2",
  StyleMenuListing->None],
Cell[161120, 6020, 56, 1, 70, 40, 0, "StyleData", "Item2", "Presentation"],
Cell[161179, 6023, 110, 3, 70, 36, 0, "StyleData", "Item2", "Printout"],
Cell[161292, 6028, 118, 3, 70, 44, 0, "StyleData", "Item2", \
"EnhancedPrintout"],
Cell[161413, 6033, 125, 3, 70, 51, 0, "StyleData", "Item2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[161575, 6041, 132, 3, 70, 33, 0, "StyleData", "Item2Continued", "All",
  CounterIncrements->"Item2Continued",
  StyleMenuListing->None],
Cell[161710, 6046, 65, 1, 70, 49, 0, "StyleData", "Item2Continued", \
"Presentation"],
Cell[161778, 6049, 79, 1, 70, 45, 0, "StyleData", "Item2Continued", \
"Printout"],
Cell[161860, 6052, 103, 2, 70, 53, 0, "StyleData", "Item2Continued", \
"EnhancedPrintout"],
Cell[161966, 6056, 94, 1, 70, 60, 0, "StyleData", "Item2Continued", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[162097, 6062, 138, 4, 70, 24, 0, "StyleData", "Item3", "All",
  CounterIncrements->"Item3",
  StyleMenuListing->None],
Cell[162238, 6068, 56, 1, 70, 40, 0, "StyleData", "Item3", "Presentation"],
Cell[162297, 6071, 70, 1, 70, 36, 0, "StyleData", "Item3", "Printout"],
Cell[162370, 6074, 94, 2, 70, 44, 0, "StyleData", "Item3", \
"EnhancedPrintout"],
Cell[162467, 6078, 111, 2, 70, 51, 0, "StyleData", "Item3", \
"EnhancedPrintoutNonGray",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[162615, 6085, 132, 3, 70, 33, 0, "StyleData", "Item3Continued", "All",
  CounterIncrements->"Item3Continued",
  StyleMenuListing->None],
Cell[162750, 6090, 65, 1, 70, 49, 0, "StyleData", "Item3Continued", \
"Presentation"],
Cell[162818, 6093, 79, 1, 70, 45, 0, "StyleData", "Item3Continued", \
"Printout"],
Cell[162900, 6096, 103, 2, 70, 53, 0, "StyleData", "Item3Continued", \
"EnhancedPrintout"],
Cell[163006, 6100, 94, 1, 70, 60, 0, "StyleData", "Item3Continued", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[163137, 6106, 187, 5, 70, 37, 0, "StyleData", "ItemizedBulletText", \
"All",
  CounterIncrements->"ItemizedBulletText",
  StyleMenuListing->None],
Cell[163327, 6113, 69, 1, 70, 53, 0, "StyleData", "ItemizedBulletText", \
"Presentation"],
Cell[163399, 6116, 110, 3, 70, 49, 0, "StyleData", "ItemizedBulletText", \
"Printout"],
Cell[163512, 6121, 144, 4, 70, 57, 0, "StyleData", "ItemizedBulletText", \
"EnhancedPrintout"],
Cell[163659, 6127, 151, 4, 70, 64, 0, "StyleData", "ItemizedBulletText", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[163847, 6136, 360, 9, 70, 26, 0, "StyleData", "NoteBox", "All",
  StyleMenuListing->None],
Cell[164210, 6147, 58, 1, 70, 42, 0, "StyleData", "NoteBox", "Presentation"],
Cell[164271, 6150, 122, 3, 70, 38, 0, "StyleData", "NoteBox", "Printout"],
Cell[164396, 6155, 162, 4, 70, 46, 0, "StyleData", "NoteBox", \
"EnhancedPrintout"],
Cell[164561, 6161, 162, 4, 70, 53, 0, "StyleData", "NoteBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[164760, 6170, 367, 9, 70, 34, 0, "StyleData", "ItemizedNoteBox", "All",
  StyleMenuListing->None],
Cell[165130, 6181, 66, 1, 70, 50, 0, "StyleData", "ItemizedNoteBox", \
"Presentation"],
Cell[165199, 6184, 131, 3, 70, 46, 0, "StyleData", "ItemizedNoteBox", \
"Printout"],
Cell[165333, 6189, 171, 4, 70, 54, 0, "StyleData", "ItemizedNoteBox", \
"EnhancedPrintout"],
Cell[165507, 6195, 171, 4, 70, 61, 0, "StyleData", "ItemizedNoteBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[165715, 6204, 446, 12, 70, 33, 0, "StyleData", "ItemizedTopBox", "All",
  StyleMenuListing->None],
Cell[166164, 6218, 65, 1, 70, 49, 0, "StyleData", "ItemizedTopBox", \
"Presentation"],
Cell[166232, 6221, 96, 2, 70, 45, 0, "StyleData", "ItemizedTopBox", \
"Printout"],
Cell[166331, 6225, 170, 4, 70, 53, 0, "StyleData", "ItemizedTopBox", \
"EnhancedPrintout"],
Cell[166504, 6231, 170, 4, 70, 60, 0, "StyleData", "ItemizedTopBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[166711, 6240, 449, 12, 70, 36, 0, "StyleData", "ItemizedBottomBox", \
"All",
  StyleMenuListing->None],
Cell[167163, 6254, 68, 1, 70, 52, 0, "StyleData", "ItemizedBottomBox", \
"Presentation"],
Cell[167234, 6257, 99, 2, 70, 48, 0, "StyleData", "ItemizedBottomBox", \
"Printout"],
Cell[167336, 6261, 173, 4, 70, 56, 0, "StyleData", "ItemizedBottomBox", \
"EnhancedPrintout"],
Cell[167512, 6267, 173, 4, 70, 63, 0, "StyleData", "ItemizedBottomBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[167722, 6276, 525, 16, 70, 34, 0, "StyleData", "MiddleSpacedBox", "All",
  StyleMenuListing->None],
Cell[168250, 6294, 66, 1, 70, 50, 0, "StyleData", "MiddleSpacedBox", \
"Presentation"],
Cell[168319, 6297, 146, 3, 70, 46, 0, "StyleData", "MiddleSpacedBox", \
"Printout"],
Cell[168468, 6302, 212, 5, 70, 54, 0, "StyleData", "MiddleSpacedBox", \
"EnhancedPrintout"],
Cell[168683, 6309, 219, 5, 70, 61, 0, "StyleData", "MiddleSpacedBox", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[168939, 6319, 152, 4, 70, 31, 0, "StyleData", "ItemizedNote", "All",
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],
Cell[169094, 6325, 63, 1, 70, 47, 0, "StyleData", "ItemizedNote", \
"Presentation"],
Cell[169160, 6328, 114, 3, 70, 43, 0, "StyleData", "ItemizedNote", \
"Printout"],
Cell[169277, 6333, 172, 5, 70, 51, 0, "StyleData", "ItemizedNote", \
"EnhancedPrintout"],
Cell[169452, 6340, 179, 5, 70, 58, 0, "StyleData", "ItemizedNote", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[169668, 6350, 156, 4, 70, 36, 0, "StyleData", "ItemizedNoteBelow", "All",
  
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],
Cell[169827, 6356, 68, 1, 70, 52, 0, "StyleData", "ItemizedNoteBelow", \
"Presentation"],
Cell[169898, 6359, 120, 3, 70, 48, 0, "StyleData", "ItemizedNoteBelow", \
"Printout"],
Cell[170021, 6364, 177, 5, 70, 56, 0, "StyleData", "ItemizedNoteBelow", \
"EnhancedPrintout"],
Cell[170201, 6371, 184, 5, 70, 63, 0, "StyleData", "ItemizedNoteBelow", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[170422, 6381, 183, 5, 70, 39, 0, "StyleData", "ItemizedTextBelowPic", \
"All",
  CounterIncrements->"ItemizedText",
  StyleMenuListing->None],
Cell[170608, 6388, 71, 1, 70, 55, 0, "StyleData", "ItemizedTextBelowPic", \
"Presentation"],
Cell[170682, 6391, 147, 4, 70, 51, 0, "StyleData", "ItemizedTextBelowPic", \
"Printout"],
Cell[170832, 6397, 181, 5, 70, 59, 0, "StyleData", "ItemizedTextBelowPic", \
"EnhancedPrintout"],
Cell[171016, 6404, 188, 5, 70, 66, 0, "StyleData", "ItemizedTextBelowPic", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[171241, 6414, 156, 4, 70, 36, 0, "StyleData", "ItemizedTextNote2", "All",
  
  CounterIncrements->"ItemizedNote",
  StyleMenuListing->None],
Cell[171400, 6420, 68, 1, 70, 52, 0, "StyleData", "ItemizedTextNote2", \
"Presentation"],
Cell[171471, 6423, 119, 3, 70, 48, 0, "StyleData", "ItemizedTextNote2", \
"Printout"],
Cell[171593, 6428, 153, 4, 70, 56, 0, "StyleData", "ItemizedTextNote2", \
"EnhancedPrintout"],
Cell[171749, 6434, 160, 4, 70, 63, 0, "StyleData", "ItemizedTextNote2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[171946, 6443, 200, 5, 70, 32, 0, "StyleData", "NumberedItem1", "All",
  CounterIncrements->"NumberedItem1",
  StyleMenuListing->None],
Cell[172149, 6450, 64, 1, 70, 48, 0, "StyleData", "NumberedItem1", \
"Presentation"],
Cell[172216, 6453, 78, 1, 70, 44, 0, "StyleData", "NumberedItem1", \
"Printout"],
Cell[172297, 6456, 86, 1, 70, 52, 0, "StyleData", "NumberedItem1", \
"EnhancedPrintout"],
Cell[172386, 6459, 93, 1, 70, 59, 0, "StyleData", "NumberedItem1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[172516, 6465, 200, 5, 70, 32, 0, "StyleData", "NumberedItem2", "All",
  CounterIncrements->"NumberedItem2",
  StyleMenuListing->None],
Cell[172719, 6472, 64, 1, 70, 48, 0, "StyleData", "NumberedItem2", \
"Presentation"],
Cell[172786, 6475, 78, 1, 70, 44, 0, "StyleData", "NumberedItem2", \
"Printout"],
Cell[172867, 6478, 86, 1, 70, 52, 0, "StyleData", "NumberedItem2", \
"EnhancedPrintout"],
Cell[172956, 6481, 93, 1, 70, 59, 0, "StyleData", "NumberedItem2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[173086, 6487, 200, 5, 70, 32, 0, "StyleData", "NumberedItem3", "All",
  CounterIncrements->"NumberedItem3",
  StyleMenuListing->None],
Cell[173289, 6494, 64, 1, 70, 48, 0, "StyleData", "NumberedItem3", \
"Presentation"],
Cell[173356, 6497, 78, 1, 70, 44, 0, "StyleData", "NumberedItem3", \
"Printout"],
Cell[173437, 6500, 86, 1, 70, 52, 0, "StyleData", "NumberedItem3", \
"EnhancedPrintout"],
Cell[173526, 6503, 119, 2, 70, 59, 0, "StyleData", "NumberedItem3", \
"EnhancedPrintoutNonGray",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[173682, 6510, 152, 5, 70, 33, 0, "StyleData", "PageHeaderBold", "All",
  StyleMenuListing->None],
Cell[173837, 6517, 45, 0, 70, 45, 0, "StyleData", "PageHeaderBold", \
"Printout"],
Cell[173885, 6519, 135, 3, 70, 53, 0, "StyleData", "PageHeaderBold", \
"EnhancedPrintout"],
Cell[174023, 6524, 142, 3, 70, 60, 0, "StyleData", "PageHeaderBold", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[174202, 6532, 299, 10, 70, 33, 0, "StyleData", "SingleRowTable", "All",
  StyleMenuListing->None],
Cell[174504, 6544, 65, 1, 70, 49, 0, "StyleData", "SingleRowTable", \
"Presentation"],
Cell[174572, 6547, 78, 1, 70, 45, 0, "StyleData", "SingleRowTable", \
"Printout"],
Cell[174653, 6550, 86, 1, 70, 53, 0, "StyleData", "SingleRowTable", \
"EnhancedPrintout"],
Cell[174742, 6553, 93, 1, 70, 60, 0, "StyleData", "SingleRowTable", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[174872, 6559, 187, 5, 70, 35, 0, "StyleData", "Subsubsubsection", "All",
  StyleMenuListing->None],
Cell[175062, 6566, 67, 1, 70, 51, 0, "StyleData", "Subsubsubsection", \
"Presentation"],
Cell[175132, 6569, 96, 2, 70, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"],
Cell[175231, 6573, 130, 3, 70, 55, 0, "StyleData", "Subsubsubsection", \
"EnhancedPrintout"],
Cell[175364, 6578, 137, 3, 70, 62, 0, "StyleData", "Subsubsubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[175538, 6586, 1639, 40, 70, 30, 0, "StyleData", "Subsubtitle", "All",
  CounterIncrements->"Subsubtitle",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
  StyleMenuListing->None],
Cell[177180, 6628, 62, 1, 70, 46, 0, "StyleData", "Subsubtitle", \
"Presentation"],
Cell[177245, 6631, 93, 2, 70, 42, 0, "StyleData", "Subsubtitle", "Printout"],
Cell[177341, 6635, 133, 3, 70, 50, 0, "StyleData", "Subsubtitle", \
"EnhancedPrintout"],
Cell[177477, 6640, 140, 3, 70, 57, 0, "StyleData", "Subsubtitle", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[177654, 6648, 1630, 39, 70, 27, 0, "StyleData", "Subtitle", "All",
  CounterIncrements->"Subtitle",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
      "Subsubtitle", 0}},
  StyleMenuListing->None],
Cell[179287, 6689, 59, 1, 70, 43, 0, "StyleData", "Subtitle", \
"Presentation"],
Cell[179349, 6692, 91, 2, 70, 39, 0, "StyleData", "Subtitle", "Printout"],
Cell[179443, 6696, 131, 3, 70, 47, 0, "StyleData", "Subtitle", \
"EnhancedPrintout"],
Cell[179577, 6701, 138, 3, 70, 54, 0, "StyleData", "Subtitle", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[179752, 6709, 1346, 32, 70, 28, 0, "StyleData", "TextBelow", "All",
  StyleMenuListing->None],
Cell[181101, 6743, 60, 1, 70, 44, 0, "StyleData", "TextBelow", \
"Presentation"],
Cell[181164, 6746, 135, 4, 70, 40, 0, "StyleData", "TextBelow", "Printout"],
Cell[181302, 6752, 169, 5, 70, 48, 0, "StyleData", "TextBelow", \
"EnhancedPrintout"],
Cell[181474, 6759, 176, 5, 70, 55, 0, "StyleData", "TextBelow", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[181687, 6769, 1715, 41, 70, 24, 0, "StyleData", "Title", "All",
  CounterIncrements->"Title",
  CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
      "Subtitle", 0}, {"Subsubtitle", 0}},
  StyleMenuListing->None],
Cell[183405, 6812, 56, 1, 70, 40, 0, "StyleData", "Title", "Presentation"],
Cell[183464, 6815, 88, 2, 70, 36, 0, "StyleData", "Title", "Printout"],
Cell[183555, 6819, 152, 4, 70, 44, 0, "StyleData", "Title", \
"EnhancedPrintout"],
Cell[183710, 6825, 159, 4, 70, 51, 0, "StyleData", "Title", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[183906, 6834, 1426, 34, 70, 34, 0, "StyleData", "Undersubsection", "All",
  
  StyleMenuListing->None],
Cell[185335, 6870, 66, 1, 70, 50, 0, "StyleData", "Undersubsection", \
"Presentation"],
Cell[185404, 6873, 96, 2, 70, 46, 0, "StyleData", "Undersubsection", \
"Printout"],
Cell[185503, 6877, 157, 4, 70, 54, 0, "StyleData", "Undersubsection", \
"EnhancedPrintout"],
Cell[185663, 6883, 164, 4, 70, 61, 0, "StyleData", "Undersubsection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[185864, 6892, 315, 9, 70, 31, 0, "StyleData", "SectionFirst", "All",
  CounterIncrements->"Section",
  StyleMenuListing->None],
Cell[186182, 6903, 63, 1, 70, 47, 0, "StyleData", "SectionFirst", \
"Presentation"],
Cell[186248, 6906, 117, 3, 70, 43, 0, "StyleData", "SectionFirst", \
"Printout"],
Cell[186368, 6911, 413, 11, 70, 51, 0, "StyleData", "SectionFirst", \
"EnhancedPrintout",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}}],
Cell[186784, 6924, 393, 10, 70, 58, 0, "StyleData", "SectionFirst", \
"EnhancedPrintoutNonGray",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}}]
}, Closed]],

Cell[CellGroupData[{
Cell[187214, 6939, 359, 10, 70, 34, 0, "StyleData", "SubsectionFirst", "All",
  StyleMenuListing->None],
Cell[187576, 6951, 66, 1, 70, 50, 0, "StyleData", "SubsectionFirst", \
"Presentation"],
Cell[187645, 6954, 118, 3, 70, 47, 0, "StyleData", "SubsectionFirst", \
"SlideShow"],
Cell[187766, 6959, 147, 3, 70, 46, 0, "StyleData", "SubsectionFirst", \
"Printout"],
Cell[187916, 6964, 236, 6, 70, 54, 0, "StyleData", "SubsectionFirst", \
"EnhancedPrintout"],
Cell[188155, 6972, 216, 5, 70, 61, 0, "StyleData", "SubsectionFirst", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[188408, 6982, 341, 9, 70, 37, 0, "StyleData", "SubsubsectionFirst", \
"All",
  StyleMenuListing->None],
Cell[188752, 6993, 69, 1, 70, 53, 0, "StyleData", "SubsubsectionFirst", \
"Presentation"],
Cell[188824, 6996, 150, 3, 70, 49, 0, "StyleData", "SubsubsectionFirst", \
"Printout"],
Cell[188977, 7001, 239, 6, 70, 57, 0, "StyleData", "SubsubsectionFirst", \
"EnhancedPrintout"],
Cell[189219, 7009, 219, 5, 70, 64, 0, "StyleData", "SubsubsectionFirst", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[189475, 7019, 192, 5, 70, 40, 0, "StyleData", "SubsubsubsectionFirst", \
"All",
  StyleMenuListing->None],
Cell[189670, 7026, 72, 1, 70, 56, 0, "StyleData", "SubsubsubsectionFirst", \
"Presentation"],
Cell[189745, 7029, 101, 2, 70, 52, 0, "StyleData", "SubsubsubsectionFirst", \
"Printout"],
Cell[189849, 7033, 135, 3, 70, 60, 0, "StyleData", "SubsubsubsectionFirst", \
"EnhancedPrintout"],
Cell[189987, 7038, 142, 3, 70, 67, 0, "StyleData", "SubsubsubsectionFirst", \
"EnhancedPrintoutNonGray"]
}, Closed]],
Cell[190144, 7044, 27, 0, 70, "Text"],

Cell[CellGroupData[{
Cell[190196, 7048, 175, 5, 70, 25, 0, "StyleData", "Spacer", "All",
  StyleMenuListing->None],
Cell[190374, 7055, 70, 2, 70, 37, 0, "StyleData", "Spacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[190481, 7062, 111, 3, 70, 38, 0, "StyleData", "DiscretionaryHyphen", \
"All",
  StyleMenuListing->None],
Cell[190595, 7067, 93, 2, 70, 50, 0, "StyleData", "DiscretionaryHyphen", \
"Printout"],
Cell[190691, 7071, 101, 2, 70, 58, 0, "StyleData", "DiscretionaryHyphen", \
"EnhancedPrintout"],
Cell[190795, 7075, 108, 2, 70, 65, 0, "StyleData", "DiscretionaryHyphen", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[190940, 7082, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller1", "All",
  StyleMenuListing->None],
Cell[191119, 7088, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller1", \
"Presentation"],
Cell[191188, 7091, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller1", \
"Printout"],
Cell[191301, 7095, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller1", \
"EnhancedPrintout"],
Cell[191422, 7099, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[191584, 7106, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller2", "All",
  StyleMenuListing->None],
Cell[191763, 7112, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller2", \
"Presentation"],
Cell[191832, 7115, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller2", \
"Printout"],
Cell[191945, 7119, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller2", \
"EnhancedPrintout"],
Cell[192066, 7123, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[192228, 7130, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller3", "All",
  StyleMenuListing->None],
Cell[192407, 7136, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller3", \
"Presentation"],
Cell[192476, 7139, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller3", \
"Printout"],
Cell[192589, 7143, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller3", \
"EnhancedPrintout"],
Cell[192710, 7147, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller3", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[192872, 7154, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller4", "All",
  StyleMenuListing->None],
Cell[193051, 7160, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller4", \
"Presentation"],
Cell[193120, 7163, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller4", \
"Printout"],
Cell[193233, 7167, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller4", \
"EnhancedPrintout"],
Cell[193354, 7171, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller4", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[193516, 7178, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller5", "All",
  StyleMenuListing->None],
Cell[193695, 7184, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller5", \
"Presentation"],
Cell[193764, 7187, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller5", \
"Printout"],
Cell[193877, 7191, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller5", \
"EnhancedPrintout"],
Cell[193998, 7195, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller5", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[194160, 7202, 176, 4, 70, 34, 0, "StyleData", "PictureSmaller6", "All",
  StyleMenuListing->None],
Cell[194339, 7208, 66, 1, 70, 50, 0, "StyleData", "PictureSmaller6", \
"Presentation"],
Cell[194408, 7211, 110, 2, 70, 46, 0, "StyleData", "PictureSmaller6", \
"Printout"],
Cell[194521, 7215, 118, 2, 70, 54, 0, "StyleData", "PictureSmaller6", \
"EnhancedPrintout"],
Cell[194642, 7219, 125, 2, 70, 61, 0, "StyleData", "PictureSmaller6", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[194804, 7226, 172, 4, 70, 30, 0, "StyleData", "ItemPicture", "All",
  StyleMenuListing->None],
Cell[194979, 7232, 62, 1, 70, 46, 0, "StyleData", "ItemPicture", \
"Presentation"],
Cell[195044, 7235, 108, 2, 70, 42, 0, "StyleData", "ItemPicture", \
"Printout"],
Cell[195155, 7239, 117, 2, 70, 50, 0, "StyleData", "ItemPicture", \
"EnhancedPrintout"],
Cell[195275, 7243, 124, 2, 70, 57, 0, "StyleData", "ItemPicture", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[195436, 7250, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller1", \
"All",
  StyleMenuListing->None],
Cell[195619, 7256, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller1", \
"Presentation"],
Cell[195692, 7259, 116, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller1", \
"Printout"],
Cell[195811, 7263, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller1", \
"EnhancedPrintout"],
Cell[195939, 7267, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[196108, 7274, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller2", \
"All",
  StyleMenuListing->None],
Cell[196291, 7280, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller2", \
"Presentation"],
Cell[196364, 7283, 116, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller2", \
"Printout"],
Cell[196483, 7287, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller2", \
"EnhancedPrintout"],
Cell[196611, 7291, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[196780, 7298, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller3", \
"All",
  StyleMenuListing->None],
Cell[196963, 7304, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller3", \
"Presentation"],
Cell[197036, 7307, 117, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller3", \
"Printout"],
Cell[197156, 7311, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller3", \
"EnhancedPrintout"],
Cell[197284, 7315, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller3", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[197453, 7322, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller4", \
"All",
  StyleMenuListing->None],
Cell[197636, 7328, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller4", \
"Presentation"],
Cell[197709, 7331, 117, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller4", \
"Printout"],
Cell[197829, 7335, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller4", \
"EnhancedPrintout"],
Cell[197957, 7339, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller4", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[198126, 7346, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller5", \
"All",
  StyleMenuListing->None],
Cell[198309, 7352, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller5", \
"Presentation"],
Cell[198382, 7355, 117, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller5", \
"Printout"],
Cell[198502, 7359, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller5", \
"EnhancedPrintout"],
Cell[198630, 7363, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller5", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[198799, 7370, 180, 4, 70, 38, 0, "StyleData", "ItemPictureSmaller6", \
"All",
  StyleMenuListing->None],
Cell[198982, 7376, 70, 1, 70, 54, 0, "StyleData", "ItemPictureSmaller6", \
"Presentation"],
Cell[199055, 7379, 117, 2, 70, 50, 0, "StyleData", "ItemPictureSmaller6", \
"Printout"],
Cell[199175, 7383, 125, 2, 70, 58, 0, "StyleData", "ItemPictureSmaller6", \
"EnhancedPrintout"],
Cell[199303, 7387, 132, 2, 70, 65, 0, "StyleData", "ItemPictureSmaller6", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[199472, 7394, 175, 4, 70, 33, 0, "StyleData", "PictureBigger1", "All",
  StyleMenuListing->None],
Cell[199650, 7400, 65, 1, 70, 49, 0, "StyleData", "PictureBigger1", \
"Presentation"],
Cell[199718, 7403, 109, 2, 70, 45, 0, "StyleData", "PictureBigger1", \
"Printout"],
Cell[199830, 7407, 117, 2, 70, 53, 0, "StyleData", "PictureBigger1", \
"EnhancedPrintout"],
Cell[199950, 7411, 124, 2, 70, 60, 0, "StyleData", "PictureBigger1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[200111, 7418, 175, 4, 70, 33, 0, "StyleData", "PictureBigger2", "All",
  StyleMenuListing->None],
Cell[200289, 7424, 65, 1, 70, 49, 0, "StyleData", "PictureBigger2", \
"Presentation"],
Cell[200357, 7427, 109, 2, 70, 45, 0, "StyleData", "PictureBigger2", \
"Printout"],
Cell[200469, 7431, 117, 2, 70, 53, 0, "StyleData", "PictureBigger2", \
"EnhancedPrintout"],
Cell[200589, 7435, 124, 2, 70, 60, 0, "StyleData", "PictureBigger2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[200750, 7442, 175, 4, 70, 33, 0, "StyleData", "PictureBigger3", "All",
  StyleMenuListing->None],
Cell[200928, 7448, 65, 1, 70, 49, 0, "StyleData", "PictureBigger3", \
"Presentation"],
Cell[200996, 7451, 109, 2, 70, 45, 0, "StyleData", "PictureBigger3", \
"Printout"],
Cell[201108, 7455, 117, 2, 70, 53, 0, "StyleData", "PictureBigger3", \
"EnhancedPrintout"],
Cell[201228, 7459, 124, 2, 70, 60, 0, "StyleData", "PictureBigger3", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[201389, 7466, 175, 4, 70, 33, 0, "StyleData", "PictureBigger4", "All",
  StyleMenuListing->None],
Cell[201567, 7472, 65, 1, 70, 49, 0, "StyleData", "PictureBigger4", \
"Presentation"],
Cell[201635, 7475, 109, 2, 70, 45, 0, "StyleData", "PictureBigger4", \
"Printout"],
Cell[201747, 7479, 117, 2, 70, 53, 0, "StyleData", "PictureBigger4", \
"EnhancedPrintout"],
Cell[201867, 7483, 124, 2, 70, 60, 0, "StyleData", "PictureBigger4", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[202028, 7490, 175, 4, 70, 33, 0, "StyleData", "PictureBigger5", "All",
  StyleMenuListing->None],
Cell[202206, 7496, 65, 1, 70, 49, 0, "StyleData", "PictureBigger5", \
"Presentation"],
Cell[202274, 7499, 108, 2, 70, 45, 0, "StyleData", "PictureBigger5", \
"Printout"],
Cell[202385, 7503, 116, 2, 70, 53, 0, "StyleData", "PictureBigger5", \
"EnhancedPrintout"],
Cell[202504, 7507, 123, 2, 70, 60, 0, "StyleData", "PictureBigger5", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[202664, 7514, 175, 4, 70, 33, 0, "StyleData", "PictureBigger6", "All",
  StyleMenuListing->None],
Cell[202842, 7520, 65, 1, 70, 49, 0, "StyleData", "PictureBigger6", \
"Presentation"],
Cell[202910, 7523, 109, 2, 70, 45, 0, "StyleData", "PictureBigger6", \
"Printout"],
Cell[203022, 7527, 117, 2, 70, 53, 0, "StyleData", "PictureBigger6", \
"EnhancedPrintout"],
Cell[203142, 7531, 124, 2, 70, 60, 0, "StyleData", "PictureBigger6", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[203303, 7538, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger1", \
"All",
  StyleMenuListing->None],
Cell[203485, 7544, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger1", \
"Presentation"],
Cell[203557, 7547, 115, 2, 70, 49, 0, "StyleData", "ItemPictureBigger1", \
"Printout"],
Cell[203675, 7551, 124, 2, 70, 57, 0, "StyleData", "ItemPictureBigger1", \
"EnhancedPrintout"],
Cell[203802, 7555, 131, 2, 70, 64, 0, "StyleData", "ItemPictureBigger1", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[203970, 7562, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger2", \
"All",
  StyleMenuListing->None],
Cell[204152, 7568, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger2", \
"Presentation"],
Cell[204224, 7571, 115, 2, 70, 49, 0, "StyleData", "ItemPictureBigger2", \
"Printout"],
Cell[204342, 7575, 124, 2, 70, 57, 0, "StyleData", "ItemPictureBigger2", \
"EnhancedPrintout"],
Cell[204469, 7579, 131, 2, 70, 64, 0, "StyleData", "ItemPictureBigger2", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[204637, 7586, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger3", \
"All",
  StyleMenuListing->None],
Cell[204819, 7592, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger3", \
"Presentation"],
Cell[204891, 7595, 116, 2, 70, 49, 0, "StyleData", "ItemPictureBigger3", \
"Printout"],
Cell[205010, 7599, 124, 2, 70, 57, 0, "StyleData", "ItemPictureBigger3", \
"EnhancedPrintout"],
Cell[205137, 7603, 131, 2, 70, 64, 0, "StyleData", "ItemPictureBigger3", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[205305, 7610, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger4", \
"All",
  StyleMenuListing->None],
Cell[205487, 7616, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger4", \
"Presentation"],
Cell[205559, 7619, 116, 2, 70, 49, 0, "StyleData", "ItemPictureBigger4", \
"Printout"],
Cell[205678, 7623, 124, 2, 70, 57, 0, "StyleData", "ItemPictureBigger4", \
"EnhancedPrintout"],
Cell[205805, 7627, 131, 2, 70, 64, 0, "StyleData", "ItemPictureBigger4", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[205973, 7634, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger5", \
"All",
  StyleMenuListing->None],
Cell[206155, 7640, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger5", \
"Presentation"],
Cell[206227, 7643, 115, 2, 70, 49, 0, "StyleData", "ItemPictureBigger5", \
"Printout"],
Cell[206345, 7647, 123, 2, 70, 57, 0, "StyleData", "ItemPictureBigger5", \
"EnhancedPrintout"],
Cell[206471, 7651, 130, 2, 70, 64, 0, "StyleData", "ItemPictureBigger5", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[206638, 7658, 179, 4, 70, 37, 0, "StyleData", "ItemPictureBigger6", \
"All",
  StyleMenuListing->None],
Cell[206820, 7664, 69, 1, 70, 53, 0, "StyleData", "ItemPictureBigger6", \
"Presentation"],
Cell[206892, 7667, 116, 2, 70, 49, 0, "StyleData", "ItemPictureBigger6", \
"Printout"],
Cell[207011, 7671, 123, 2, 70, 57, 0, "StyleData", "ItemPictureBigger6", \
"EnhancedPrintout"],
Cell[207137, 7675, 130, 2, 70, 64, 0, "StyleData", "ItemPictureBigger6", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[207304, 7682, 133, 3, 70, 32, 0, "StyleData", "ScreenGraphic", "All",
  StyleMenuListing->None],
Cell[207440, 7687, 64, 1, 70, 48, 0, "StyleData", "ScreenGraphic", \
"Presentation"],
Cell[207507, 7690, 85, 1, 70, 44, 0, "StyleData", "ScreenGraphic", \
"Printout"],
Cell[207595, 7693, 182, 4, 70, 52, 0, "StyleData", "ScreenGraphic", \
"EnhancedPrintout"],
Cell[207780, 7699, 189, 4, 70, 59, 0, "StyleData", "ScreenGraphic", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[208006, 7708, 221, 6, 70, 31, 0, "StyleData", "PrintGraphic", "All",
  StyleMenuListing->None],
Cell[208230, 7716, 63, 1, 70, 47, 0, "StyleData", "PrintGraphic", \
"Presentation"],
Cell[208296, 7719, 173, 4, 70, 43, 0, "StyleData", "PrintGraphic", \
"Printout"],
Cell[208472, 7725, 156, 3, 70, 51, 0, "StyleData", "PrintGraphic", \
"EnhancedPrintout"],
Cell[208631, 7730, 163, 3, 70, 58, 0, "StyleData", "PrintGraphic", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[208831, 7738, 155, 5, 70, 32, 0, "StyleData", "SmallTextSans", "All"],
Cell[208989, 7745, 64, 1, 70, 48, 0, "StyleData", "SmallTextSans", \
"Presentation"],
Cell[209056, 7748, 113, 3, 70, 44, 0, "StyleData", "SmallTextSans", \
"Printout"],
Cell[209172, 7753, 205, 6, 70, 52, 0, "StyleData", "SmallTextSans", \
"EnhancedPrintout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[209450, 7767, 30, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[209505, 7771, 205, 6, 70, 32, 0, "StyleData", "BilateralCell", "All",
  StyleMenuListing->None],
Cell[209713, 7779, 64, 1, 70, 48, 0, "StyleData", "BilateralCell", \
"Presentation"],
Cell[209780, 7782, 115, 2, 70, 45, 0, "StyleData", "BilateralCell", \
"SlideShow"],
Cell[209898, 7786, 117, 3, 70, 44, 0, "StyleData", "BilateralCell", \
"Printout"],
Cell[210018, 7791, 151, 4, 70, 52, 0, "StyleData", "BilateralCell", \
"EnhancedPrintout"],
Cell[210172, 7797, 158, 4, 70, 59, 0, "StyleData", "BilateralCell", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[210367, 7806, 155, 4, 70, 33, 0, "StyleData", "RuledPageBreak", "All"],
Cell[210525, 7812, 65, 1, 70, 49, 0, "StyleData", "RuledPageBreak", \
"Presentation"],
Cell[210593, 7815, 81, 1, 70, 46, 0, "StyleData", "RuledPageBreak", \
"SlideShow"],
Cell[210677, 7818, 117, 3, 70, 45, 0, "StyleData", "RuledPageBreak", \
"Printout"],
Cell[210797, 7823, 110, 2, 70, 53, 0, "StyleData", "RuledPageBreak", \
"EnhancedPrintout"],
Cell[210910, 7827, 117, 2, 70, 60, 0, "StyleData", "RuledPageBreak", \
"EnhancedPrintoutNonGray"]
}, Closed]],
Cell[211042, 7832, 487, 14, 70, 31, 0, "StyleData", "PaletteTitle", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[211532, 7848, 320, 10, 70, 32, 0, "StyleData", "PaletteButton", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[211855, 7860, 320, 10, 70, 33, 0, "StyleData", "PaletteButton2", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[212212, 7875, 33, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[212270, 7879, 346, 9, 70, 27, 0, "StyleData", "Outline1", "All",
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}, {"Outline3", 0}, {"Outline4", 0}}],
Cell[212619, 7890, 59, 1, 70, 43, 0, "StyleData", "Outline1", \
"Presentation"],
Cell[212681, 7893, 100, 1, 70, 39, 0, "StyleData", "Outline1", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[212818, 7899, 348, 9, 70, 27, 0, "StyleData", "Outline2", "All",
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}, {"Outline4", 0}}],
Cell[213169, 7910, 59, 1, 70, 43, 0, "StyleData", "Outline2", \
"Presentation"],
Cell[213231, 7913, 126, 2, 70, 39, 0, "StyleData", "Outline2", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[213394, 7920, 272, 7, 70, 27, 0, "StyleData", "Outline3", "All",
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}}],
Cell[213669, 7929, 59, 1, 70, 43, 0, "StyleData", "Outline3", \
"Presentation"],
Cell[213731, 7932, 89, 1, 70, 39, 0, "StyleData", "Outline3", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[213857, 7938, 269, 7, 70, 27, 0, "StyleData", "Outline4", "All",
  CounterIncrements->"Outline4"],
Cell[214129, 7947, 59, 1, 70, 43, 0, "StyleData", "Outline4", \
"Presentation"],
Cell[214191, 7950, 39, 0, 70, 39, 0, "StyleData", "Outline4", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[214279, 7956, 36, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[214340, 7960, 709, 21, 70, 41, 0, "StyleData", "SlideShowNavigationBar", \
"All",
  CounterIncrements->"SlideShowNavigationBar",
  StyleMenuListing->None],
Cell[215052, 7983, 199, 5, 70, 54, 0, "StyleData", "SlideShowNavigationBar", \
"SlideShow"],
Cell[215254, 7990, 126, 3, 70, 53, 0, "StyleData", "SlideShowNavigationBar", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[215417, 7998, 1702, 41, 70, 35, 0, "StyleData", "SlideShowSection", \
"All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
  StyleMenuListing->None],
Cell[217122, 8041, 67, 1, 70, 51, 0, "StyleData", "SlideShowSection", \
"Presentation"],
Cell[217192, 8044, 98, 2, 70, 48, 0, "StyleData", "SlideShowSection", \
"SlideShow"],
Cell[217293, 8048, 122, 3, 70, 47, 0, "StyleData", "SlideShowSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[217452, 8056, 327, 10, 70, 33, 0, "StyleData", "SlideHyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[217782, 8068, 46, 0, 70, 46, 0, "StyleData", "SlideHyperlink", \
"SlideShow"],
Cell[217831, 8070, 128, 3, 70, 45, 0, "StyleData", "SlideHyperlink", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[217996, 8078, 341, 9, 70, 31, 0, "StyleData", "SlideTOCLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[218340, 8089, 44, 0, 70, 44, 0, "StyleData", "SlideTOCLink", \
"SlideShow"],
Cell[218387, 8091, 110, 2, 70, 43, 0, "StyleData", "SlideTOCLink", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[218534, 8098, 166, 4, 70, 27, 0, "StyleData", "SlideTOC", "All",
  StyleMenuListing->None],
Cell[218703, 8104, 56, 1, 70, 40, 0, "StyleData", "SlideTOC", "SlideShow"],
Cell[218762, 8107, 82, 2, 70, 39, 0, "StyleData", "SlideTOC", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[218893, 8115, 50, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[218968, 8119, 186, 5, 97, 32, 0, "StyleData", "ContentsTitle", "All"],
Cell[219157, 8126, 64, 1, 70, 48, 0, "StyleData", "ContentsTitle", \
"Presentation"],
Cell[219224, 8129, 151, 4, 70, 44, 0, "StyleData", "ContentsTitle", \
"Printout"],
Cell[219378, 8135, 219, 6, 70, 52, 0, "StyleData", "ContentsTitle", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[219634, 8146, 238, 7, 42, 34, 0, "StyleData", "ContentsSection", "All",
  StyleMenuListing->None],
Cell[219875, 8155, 66, 1, 70, 50, 0, "StyleData", "ContentsSection", \
"Presentation"],
Cell[219944, 8158, 122, 3, 59, 46, 0, "StyleData", "ContentsSection", \
"Printout"],
Cell[220069, 8163, 184, 5, 59, 54, 0, "StyleData", "ContentsSection", \
"EnhancedPrintout"],
Cell[220256, 8170, 191, 5, 59, 61, 0, "StyleData", "ContentsSection", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[220484, 8180, 191, 6, 45, 31, 0, "StyleData", "IndexSection", "All",
  StyleMenuListing->None],
Cell[220678, 8188, 63, 1, 70, 47, 0, "StyleData", "IndexSection", \
"Presentation"],
Cell[220744, 8191, 119, 3, 70, 43, 0, "StyleData", "IndexSection", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[220900, 8199, 166, 4, 38, 27, 0, "StyleData", "Contents", "All",
  StyleMenuListing->None],
Cell[221069, 8205, 59, 1, 70, 43, 0, "StyleData", "Contents", \
"Presentation"],
Cell[221131, 8208, 89, 2, 70, 39, 0, "StyleData", "Contents", "Printout"],
Cell[221223, 8212, 123, 3, 70, 47, 0, "StyleData", "Contents", \
"EnhancedPrintout"],
Cell[221349, 8217, 130, 3, 70, 54, 0, "StyleData", "Contents", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[221516, 8225, 108, 3, 38, 24, 0, "StyleData", "Index", "All",
  StyleMenuListing->None],
Cell[221627, 8230, 56, 1, 70, 40, 0, "StyleData", "Index", "Presentation"],
Cell[221686, 8233, 85, 2, 70, 36, 0, "StyleData", "Index", "Printout"],
Cell[221774, 8237, 119, 3, 70, 44, 0, "StyleData", "Index", \
"EnhancedPrintout"],
Cell[221896, 8242, 126, 3, 70, 51, 0, "StyleData", "Index", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[222059, 8250, 90, 2, 38, 32, 0, "StyleData", "IndexSubentry", "All"],
Cell[222152, 8254, 64, 1, 70, 48, 0, "StyleData", "IndexSubentry", \
"Presentation"],
Cell[222219, 8257, 93, 2, 70, 44, 0, "StyleData", "IndexSubentry", \
"Printout"],
Cell[222315, 8261, 127, 3, 70, 52, 0, "StyleData", "IndexSubentry", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[222479, 8269, 216, 7, 36, 31, 0, "StyleData", "Index2Column", "All",
  StyleMenuListing->None],
Cell[222698, 8278, 63, 1, 70, 47, 0, "StyleData", "Index2Column", \
"Presentation"],
Cell[222764, 8281, 91, 2, 70, 43, 0, "StyleData", "Index2Column", \
"Printout"],
Cell[222858, 8285, 150, 4, 70, 51, 0, "StyleData", "Index2Column", \
"EnhancedPrintout"],
Cell[223011, 8291, 157, 4, 70, 58, 0, "StyleData", "Index2Column", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[223205, 8300, 132, 5, 43, 25, 0, "StyleData", "Leader", "All",
  StyleMenuListing->None],
Cell[223340, 8307, 53, 1, 70, 37, 0, "StyleData", "Leader", "Printout"],
Cell[223396, 8310, 87, 2, 70, 45, 0, "StyleData", "Leader", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[223520, 8317, 138, 5, 43, 31, 0, "StyleData", "LeaderNoDots", "All",
  StyleMenuListing->None],
Cell[223661, 8324, 59, 1, 70, 43, 0, "StyleData", "LeaderNoDots", \
"Printout"],
Cell[223723, 8327, 93, 2, 70, 51, 0, "StyleData", "LeaderNoDots", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[223853, 8334, 275, 7, 43, 27, 0, "StyleData", "PageLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[224131, 8343, 66, 1, 70, 39, 0, "StyleData", "PageLink", "Printout"],
Cell[224200, 8346, 74, 1, 70, 47, 0, "StyleData", "PageLink", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[224311, 8352, 144, 5, 43, 26, 0, "StyleData", "TOCPage", "All",
  StyleMenuListing->None],
Cell[224458, 8359, 58, 1, 70, 42, 0, "StyleData", "TOCPage", "Presentation"],
Cell[224519, 8362, 54, 1, 70, 38, 0, "StyleData", "TOCPage", "Printout"],
Cell[224576, 8365, 88, 2, 70, 46, 0, "StyleData", "TOCPage", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[224701, 8372, 267, 8, 40, 27, 0, "StyleData", "TOCTitle", "All",
  CounterIncrements->"TOCTitle",
  CounterAssignments->{{"TOCSection", 0}}],
Cell[224971, 8382, 59, 1, 70, 43, 0, "StyleData", "TOCTitle", \
"Presentation"],
Cell[225033, 8385, 135, 4, 70, 39, 0, "StyleData", "TOCTitle", "Printout"],
Cell[225171, 8391, 197, 6, 70, 47, 0, "StyleData", "TOCTitle", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[225405, 8402, 254, 7, 39, 29, 0, "StyleData", "TOCSection", "All",
  CounterIncrements->"TOCSection",
  CounterAssignments->{{"TOCSubsection", 0}}],
Cell[225662, 8411, 61, 1, 70, 45, 0, "StyleData", "TOCSection", \
"Presentation"],
Cell[225726, 8414, 116, 3, 70, 41, 0, "StyleData", "TOCSection", "Printout"],
Cell[225845, 8419, 177, 5, 70, 49, 0, "StyleData", "TOCSection", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[226059, 8429, 236, 6, 39, 32, 0, "StyleData", "TOCSubsection", "All",
  CounterIncrements->"TOCSubsection",
  CounterAssignments->{{"TOCSubsubsection", 0}}],
Cell[226298, 8437, 64, 1, 70, 48, 0, "StyleData", "TOCSubsection", \
"Presentation"],
Cell[226365, 8440, 119, 3, 70, 44, 0, "StyleData", "TOCSubsection", \
"Printout"],
Cell[226487, 8445, 174, 5, 70, 52, 0, "StyleData", "TOCSubsection", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[226698, 8455, 194, 5, 39, 35, 0, "StyleData", "TOCSubsubsection", "All",
  CounterIncrements->"TOCSubsubsection"],
Cell[226895, 8462, 67, 1, 70, 51, 0, "StyleData", "TOCSubsubsection", \
"Presentation"],
Cell[226965, 8465, 121, 3, 70, 47, 0, "StyleData", "TOCSubsubsection", \
"Printout"],
Cell[227089, 8470, 155, 4, 70, 55, 0, "StyleData", "TOCSubsubsection", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[227281, 8479, 87, 2, 43, 34, 0, "StyleData", "TOCTitleDingbat", "All"],
Cell[227371, 8483, 102, 2, 70, 54, 0, "StyleData", "TOCTitleDingbat", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[227510, 8490, 89, 2, 43, 36, 0, "StyleData", "TOCSectionDingbat", \
"All"],
Cell[227602, 8494, 103, 2, 70, 56, 0, "StyleData", "TOCSectionDingbat", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[227742, 8501, 92, 2, 43, 39, 0, "StyleData", "TOCSubsectionDingbat", \
"All"],
Cell[227837, 8505, 74, 1, 70, 59, 0, "StyleData", "TOCSubsectionDingbat", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[227948, 8511, 334, 9, 40, 36, 0, "StyleData", "TOCTitleCondensed", "All",
  
  CounterIncrements->"TOCTitleCondensed",
  CounterAssignments->{{"TOCSectionCondensed", 0}, {
      "TOCSubsectionCondensed", 0}}],
Cell[228285, 8522, 68, 1, 70, 52, 0, "StyleData", "TOCTitleCondensed", \
"Presentation"],
Cell[228356, 8525, 123, 3, 70, 48, 0, "StyleData", "TOCTitleCondensed", \
"Printout"],
Cell[228482, 8530, 185, 5, 70, 56, 0, "StyleData", "TOCTitleCondensed", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[228704, 8540, 323, 9, 38, 38, 0, "StyleData", "TOCSectionCondensed", \
"All",
  CounterIncrements->"TOCSectionCondensed",
  CounterAssignments->{{"TOCSubsection", 0}}],
Cell[229030, 8551, 70, 1, 70, 54, 0, "StyleData", "TOCSectionCondensed", \
"Presentation"],
Cell[229103, 8554, 125, 3, 70, 50, 0, "StyleData", "TOCSectionCondensed", \
"Printout"],
Cell[229231, 8559, 159, 4, 70, 58, 0, "StyleData", "TOCSectionCondensed", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[229427, 8568, 179, 5, 39, 41, 0, "StyleData", "TOCSubsectionCondensed", \
"All"],
Cell[229609, 8575, 73, 1, 70, 57, 0, "StyleData", "TOCSubsectionCondensed", \
"Presentation"],
Cell[229685, 8578, 149, 4, 70, 53, 0, "StyleData", "TOCSubsectionCondensed", \
"Printout"],
Cell[229837, 8584, 183, 5, 70, 61, 0, "StyleData", "TOCSubsectionCondensed", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[230057, 8594, 212, 5, 39, 44, 0, "StyleData", \
"TOCSubsubsectionCondensed", "All",
  CounterIncrements->"TOCSubsubsectionCondensed"],
Cell[230272, 8601, 76, 1, 70, 60, 0, "StyleData", \
"TOCSubsubsectionCondensed", "Presentation"],
Cell[230351, 8604, 130, 3, 70, 56, 0, "StyleData", \
"TOCSubsubsectionCondensed", "Printout"],
Cell[230484, 8609, 164, 4, 70, 64, 0, "StyleData", \
"TOCSubsubsectionCondensed", "EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[230685, 8618, 143, 4, 163, 35, 0, "StyleData", "TitlePageGraphic", \
"All"],
Cell[230831, 8624, 67, 1, 70, 51, 0, "StyleData", "TitlePageGraphic", \
"Presentation"],
Cell[230901, 8627, 83, 1, 70, 47, 0, "StyleData", "TitlePageGraphic", \
"Printout"],
Cell[230987, 8630, 91, 1, 70, 55, 0, "StyleData", "TitlePageGraphic", \
"EnhancedPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[231115, 8636, 65, 1, 38, 32, 0, "StyleData", "TitlePageLogo", "All"],
Cell[231183, 8639, 64, 1, 70, 48, 0, "StyleData", "TitlePageLogo", \
"Presentation"],
Cell[231250, 8642, 44, 0, 70, 44, 0, "StyleData", "TitlePageLogo", \
"Printout"],
Cell[231297, 8644, 52, 0, 70, 52, 0, "StyleData", "TitlePageLogo", \
"EnhancedPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[231398, 8650, 35, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[231458, 8654, 134, 4, 70, 24, 0, "StyleData", "Line1", "All",
  StyleMenuListing->None],
Cell[231595, 8660, 55, 1, 70, 40, 0, "StyleData", "Line1", "Presentation"],
Cell[231653, 8663, 71, 1, 70, 36, 0, "StyleData", "Line1", "Printout"]
}, Closed]],
Cell[231739, 8667, 65, 3, 70, "Text"],

Cell[CellGroupData[{
Cell[231829, 8674, 168, 5, 70, 29, 0, "StyleData", "ProgramTop", "All",
  StyleMenuListing->None],
Cell[232000, 8681, 60, 1, 70, 45, 0, "StyleData", "ProgramTop", \
"Presentation"],
Cell[232063, 8684, 77, 1, 70, 41, 0, "StyleData", "ProgramTop", "Printout"]
}, Closed]],
Cell[232155, 8688, 61, 4, 70, "Text"],

Cell[CellGroupData[{
Cell[232241, 8696, 171, 5, 70, 32, 0, "StyleData", "ProgramBottom", "All",
  StyleMenuListing->None],
Cell[232415, 8703, 63, 1, 70, 48, 0, "StyleData", "ProgramBottom", \
"Presentation"],
Cell[232481, 8706, 80, 1, 70, 44, 0, "StyleData", "ProgramBottom", \
"Printout"]
}, Closed]],
Cell[232576, 8710, 64, 4, 70, "Text"],

Cell[CellGroupData[{
Cell[232665, 8718, 193, 6, 70, 31, 0, "StyleData", "SessionLabel", "All",
  StyleMenuListing->None],
Cell[232861, 8726, 63, 1, 70, 47, 0, "StyleData", "SessionLabel", \
"Presentation"],
Cell[232927, 8729, 93, 2, 70, 43, 0, "StyleData", "SessionLabel", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[233069, 8737, 43, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[233137, 8741, 126, 4, 31, 29, 0, "StyleData", "PageHeader", "All",
  StyleMenuListing->None],
Cell[233266, 8747, 41, 0, 70, 41, 0, "StyleData", "PageHeader", "Printout"],
Cell[233310, 8749, 81, 1, 70, 49, 0, "StyleData", "PageHeader", \
"EnhancedPrintout"],
Cell[233394, 8752, 88, 1, 70, 56, 0, "StyleData", "PageHeader", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[233519, 8758, 152, 5, 35, 29, 0, "StyleData", "PageNumber", "All",
  StyleMenuListing->None],
Cell[233674, 8765, 41, 0, 70, 41, 0, "StyleData", "PageNumber", "Printout"],
Cell[233718, 8767, 103, 2, 70, 49, 0, "StyleData", "PageNumber", \
"EnhancedPrintout"],
Cell[233824, 8771, 110, 2, 70, 56, 0, "StyleData", "PageNumber", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[233971, 8778, 97, 3, 36, 29, 0, "StyleData", "PageFooter", "All",
  StyleMenuListing->None],
Cell[234071, 8783, 41, 0, 70, 41, 0, "StyleData", "PageFooter", "Printout"],
Cell[234115, 8785, 81, 1, 70, 49, 0, "StyleData", "PageFooter", \
"EnhancedPrintout"],
Cell[234199, 8788, 88, 1, 70, 56, 0, "StyleData", "PageFooter", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[234324, 8794, 39, 0, 37, "Subsection"],

Cell[CellGroupData[{
Cell[234388, 8798, 122, 4, 70, 25, 0, "StyleData", "Header", "All",
  StyleMenuListing->None],
Cell[234513, 8804, 37, 0, 70, 37, 0, "StyleData", "Header", "Printout"],
Cell[234553, 8806, 99, 2, 70, 45, 0, "StyleData", "Header", \
"EnhancedPrintout"],
Cell[234655, 8810, 106, 2, 70, 52, 0, "StyleData", "Header", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[234798, 8817, 93, 3, 70, 25, 0, "StyleData", "Footer", "All",
  StyleMenuListing->None],
Cell[234894, 8822, 37, 0, 70, 37, 0, "StyleData", "Footer", "Printout"],
Cell[234934, 8824, 77, 1, 70, 45, 0, "StyleData", "Footer", \
"EnhancedPrintout"],
Cell[235014, 8827, 84, 1, 70, 52, 0, "StyleData", "Footer", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[235159, 8835, 36, 0, 54, "Section"],
Cell[235198, 8837, 307, 6, 122, "Text"],

Cell[CellGroupData[{
Cell[235530, 8847, 336, 11, 44, 33, 0, "StyleData", "CellExpression", "All",
  StyleMenuListing->None],
Cell[235869, 8860, 98, 2, 70, 53, 0, "StyleData", "CellExpression", \
"EnhancedPrintout"],
Cell[235970, 8864, 105, 2, 70, 60, 0, "StyleData", "CellExpression", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[236112, 8871, 157, 5, 43, 28, 0, "StyleData", "InputForm", "All",
  StyleMenuListing->None],
Cell[236272, 8878, 77, 1, 70, 48, 0, "StyleData", "InputForm", \
"EnhancedPrintout"],
Cell[236352, 8881, 84, 1, 70, 55, 0, "StyleData", "InputForm", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[236473, 8887, 151, 5, 43, 29, 0, "StyleData", "OutputForm", "All",
  StyleMenuListing->None],
Cell[236627, 8894, 78, 1, 70, 49, 0, "StyleData", "OutputForm", \
"EnhancedPrintout"],
Cell[236708, 8897, 85, 1, 70, 56, 0, "StyleData", "OutputForm", \
"EnhancedPrintoutNonGray"]
}, Closed]],

Cell[CellGroupData[{
Cell[236830, 8903, 341, 8, 43, 31, 0, "StyleData", "StandardForm", "All",
  StyleMenuListing->None],
Cell[237174, 8913, 80, 1, 70, 51, 0, "StyleData", "StandardForm", \
"EnhancedPrintout"],
Cell[237257, 8916, 87, 1, 70, 58, 0, "StyleData", "StandardForm", \
"EnhancedPrintoutNonGray"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[237393, 8923, 35, 0, 54, "Section"],
Cell[237431, 8925, 330, 6, 122, "Text"],
Cell[237764, 8933, 61, 1, 44, 35, 0, "StyleData", "UnmatchedBracket", "All",
  StyleMenuListing->None]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

